/* MainWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from MainWindow.vala, do not modify */

/*
* Copyright 2017–2020 elementary, Inc. <https://elementary.io>
*           2011–2013 Mario Guerriero <mefrio.g@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "codecore.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <handy.h>
#include <libpeas/peas.h>
#include <float.h>
#include <math.h>
#include <gtksourceview/gtksource.h>
#include <vte/vte.h>
#include <cairo-gobject.h>
#include <glib-unix.h>
#include <signal.h>

#define SCRATCH_MAIN_WINDOW_MAX_SEARCH_TEXT_LENGTH ((guint) 255)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SCRATCH_MAIN_WINDOW_0_PROPERTY,
	SCRATCH_MAIN_WINDOW_APP_PROPERTY,
	SCRATCH_MAIN_WINDOW_RESTORE_DOCS_PROPERTY,
	SCRATCH_MAIN_WINDOW_RESTORE_OVERRIDE_PROPERTY,
	SCRATCH_MAIN_WINDOW_ACTIONS_PROPERTY,
	SCRATCH_MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* scratch_main_window_properties[SCRATCH_MAIN_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
typedef void (*ScratchMainWindowHookFunc) (gpointer user_data);
typedef struct _Block3Data Block3Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
typedef struct _ScratchMainWindowCheckUnsavedChangesData ScratchMainWindowCheckUnsavedChangesData;
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;

struct _ScratchMainWindowPrivate {
	ScratchApplication* _app;
	gboolean _restore_docs;
	RestoreOverride* _restore_override;
	GtkRevealer* search_revealer;
	CodeWelcomeView* welcome_view;
	CodeTerminal* terminal;
	ScratchFolderManagerFileView* folder_manager_view;
	ScratchServicesDocumentManager* document_manager;
	GtkEventControllerKey* key_controller;
	ScratchServicesPluginsManager* plugins;
	GraniteDialog* preferences_dialog;
	GtkPaned* hp1;
	GtkPaned* vp;
	GtkStack* content_stack;
	GSimpleActionGroup* _actions;
	gulong color_scheme_listener_handler_id;
	ScratchServicesGitManager* git_manager;
	gchar* current_search_term;
};

struct _Block1Data {
	int _ref_count_;
	ScratchMainWindow* self;
	GtkSettings* gtk_settings;
	GraniteSettings* granite_settings;
};

struct _Block2Data {
	int _ref_count_;
	ScratchMainWindow* self;
	GtkGrid* view_grid;
};

struct _Block3Data {
	int _ref_count_;
	ScratchMainWindow* self;
	ScratchMainWindowHookFunc hook_func;
	gpointer hook_func_target;
	GDestroyNotify hook_func_target_destroy_notify;
};

struct _ScratchMainWindowCheckUnsavedChangesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ScratchMainWindow* self;
	gboolean result;
	ScratchWidgetsDocumentView* _tmp0_;
	ScratchWidgetsDocumentView* _tmp1_;
	GList* _tmp2_;
	GList* doc_collection;
	GList* doc_it;
	ScratchServicesDocument* _tmp3_;
	ScratchServicesDocument* doc;
	ScratchServicesDocument* _tmp4_;
	ScratchWidgetsDocumentView* _tmp5_;
	ScratchServicesDocument* _tmp6_;
};

struct _Block4Data {
	int _ref_count_;
	ScratchMainWindow* self;
	gchar* close_path;
};

struct _Block5Data {
	int _ref_count_;
	ScratchMainWindow* self;
	gchar* project_path;
	gboolean make_restorable;
};

struct _Block6Data {
	int _ref_count_;
	ScratchMainWindow* self;
	gulong map_handler;
};

static gint ScratchMainWindow_private_offset;
static gpointer scratch_main_window_parent_class = NULL;
GeeMultiMap* scratch_main_window_action_accelerators = NULL;
static gchar* scratch_main_window_base_title;
static gchar* scratch_main_window_base_title = NULL;

static void scratch_main_window_action_fetch (ScratchMainWindow* self,
                                       GSimpleAction* action,
                                       GVariant* param);
static void _scratch_main_window_action_fetch_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void scratch_main_window_action_find_next (ScratchMainWindow* self);
static void _scratch_main_window_action_find_next_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void scratch_main_window_action_find_previous (ScratchMainWindow* self);
static void _scratch_main_window_action_find_previous_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void scratch_main_window_action_find_global (ScratchMainWindow* self,
                                             GSimpleAction* action,
                                             GVariant* param);
static void _scratch_main_window_action_find_global_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void scratch_main_window_action_open (ScratchMainWindow* self);
static void _scratch_main_window_action_open_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void scratch_main_window_action_open_folder (ScratchMainWindow* self,
                                             GSimpleAction* action,
                                             GVariant* param);
static void _scratch_main_window_action_open_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void scratch_main_window_action_collapse_all_folders (ScratchMainWindow* self);
static void _scratch_main_window_action_collapse_all_folders_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self);
static void scratch_main_window_action_order_folders (ScratchMainWindow* self);
static void _scratch_main_window_action_order_folders_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void scratch_main_window_action_preferences (ScratchMainWindow* self);
static void _scratch_main_window_action_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void scratch_main_window_action_revert (ScratchMainWindow* self);
static void _scratch_main_window_action_revert_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void scratch_main_window_action_save (ScratchMainWindow* self);
static void _scratch_main_window_action_save_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void scratch_main_window_action_save_as (ScratchMainWindow* self);
static void _scratch_main_window_action_save_as_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void scratch_main_window_action_show_fetch (ScratchMainWindow* self);
static void _scratch_main_window_action_show_fetch_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void scratch_main_window_action_templates (ScratchMainWindow* self);
static void _scratch_main_window_action_templates_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void scratch_main_window_action_go_to (ScratchMainWindow* self);
static void _scratch_main_window_action_go_to_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void scratch_main_window_action_sort_lines (ScratchMainWindow* self);
static void _scratch_main_window_action_sort_lines_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void scratch_main_window_action_new_tab (ScratchMainWindow* self);
static void _scratch_main_window_action_new_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void scratch_main_window_action_new_tab_from_clipboard (ScratchMainWindow* self);
static void _scratch_main_window_action_new_tab_from_clipboard_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                          GVariant* parameter,
                                                                                          gpointer self);
static void scratch_main_window_action_duplicate_tab (ScratchMainWindow* self);
static void _scratch_main_window_action_duplicate_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void scratch_main_window_action_undo (ScratchMainWindow* self);
static void _scratch_main_window_action_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void scratch_main_window_action_redo (ScratchMainWindow* self);
static void _scratch_main_window_action_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void scratch_main_window_action_show_replace (ScratchMainWindow* self,
                                              GSimpleAction* action);
static void _scratch_main_window_action_show_replace_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
static void scratch_main_window_action_to_lower_case (ScratchMainWindow* self);
static void _scratch_main_window_action_to_lower_case_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void scratch_main_window_action_to_upper_case (ScratchMainWindow* self);
static void _scratch_main_window_action_to_upper_case_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void scratch_main_window_action_duplicate (ScratchMainWindow* self);
static void _scratch_main_window_action_duplicate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void scratch_main_window_action_fullscreen (ScratchMainWindow* self);
static void _scratch_main_window_action_fullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void scratch_main_window_action_quit (ScratchMainWindow* self);
static void _scratch_main_window_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void scratch_main_window_action_set_default_zoom (ScratchMainWindow* self);
static void _scratch_main_window_action_set_default_zoom_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self);
static void _scratch_main_window_action_zoom_in_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void _scratch_main_window_action_zoom_out_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self);
static void scratch_main_window_action_toggle_comment (ScratchMainWindow* self);
static void _scratch_main_window_action_toggle_comment_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void scratch_main_window_action_toggle_sidebar (ScratchMainWindow* self,
                                                GSimpleAction* action);
static void _scratch_main_window_action_toggle_sidebar_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void scratch_main_window_action_toggle_terminal (ScratchMainWindow* self);
static void _scratch_main_window_action_toggle_terminal_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void scratch_main_window_action_open_in_terminal (ScratchMainWindow* self,
                                                  GSimpleAction* action,
                                                  GVariant* param);
static void _scratch_main_window_action_open_in_terminal_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self);
static void scratch_main_window_action_toggle_outline (ScratchMainWindow* self,
                                                GSimpleAction* action);
static void _scratch_main_window_action_toggle_outline_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void scratch_main_window_action_next_tab (ScratchMainWindow* self);
static void _scratch_main_window_action_next_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self);
static void scratch_main_window_action_previous_tab (ScratchMainWindow* self);
static void _scratch_main_window_action_previous_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
static void scratch_main_window_action_clear_lines (ScratchMainWindow* self);
static void _scratch_main_window_action_clear_lines_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void scratch_main_window_action_new_branch (ScratchMainWindow* self,
                                            GSimpleAction* action,
                                            GVariant* param);
static void _scratch_main_window_action_new_branch_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void scratch_main_window_action_close_tab (ScratchMainWindow* self,
                                           GSimpleAction* action,
                                           GVariant* param);
static void _scratch_main_window_action_close_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void scratch_main_window_action_close_tabs_to_right (ScratchMainWindow* self);
static void _scratch_main_window_action_close_tabs_to_right_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self);
static void scratch_main_window_action_close_other_tabs (ScratchMainWindow* self);
static void _scratch_main_window_action_close_other_tabs_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self);
static void scratch_main_window_action_hide_project_docs (ScratchMainWindow* self,
                                                   GSimpleAction* action,
                                                   GVariant* param);
static void _scratch_main_window_action_hide_project_docs_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self);
static void scratch_main_window_action_close_project_docs (ScratchMainWindow* self,
                                                    GSimpleAction* action,
                                                    GVariant* param);
static void _scratch_main_window_action_close_project_docs_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self);
static void scratch_main_window_action_restore_project_docs (ScratchMainWindow* self,
                                                      GSimpleAction* action,
                                                      GVariant* param);
static void _scratch_main_window_action_restore_project_docs_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self);
static void scratch_main_window_action_move_tab_to_new_window (ScratchMainWindow* self);
static void _scratch_main_window_action_move_tab_to_new_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                          GVariant* parameter,
                                                                                          gpointer self);
static void scratch_main_window_action_restore_closed_tab (ScratchMainWindow* self,
                                                    GSimpleAction* action,
                                                    GVariant* param);
static void _scratch_main_window_action_restore_closed_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self);
static void scratch_main_window_update_style (ScratchMainWindow* self);
static void scratch_main_window_connect_color_scheme_preference_listener (ScratchMainWindow* self);
static void scratch_main_window_disconnect_color_scheme_preference_listener (ScratchMainWindow* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda144_ (Block1Data* _data1_);
static void ___lambda144__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void scratch_main_window_update_toolbar_button (ScratchMainWindow* self,
                                                const gchar* name,
                                                gboolean new_state);
static void scratch_main_window_init_layout (ScratchMainWindow* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda145_ (ScratchMainWindow* self,
                   GtkWidget* w);
static void scratch_main_window_set_search_text (ScratchMainWindow* self);
static void ___lambda145__gtk_widget_map (GtkWidget* _sender,
                                   gpointer self);
static void __lambda146_ (ScratchMainWindow* self);
static void ___lambda146__gtk_widget_unmap (GtkWidget* _sender,
                                     gpointer self);
static void __lambda147_ (ScratchMainWindow* self);
static void ___lambda147__scratch_widgets_search_bar_search_empty (ScratchWidgetsSearchBar* _sender,
                                                            gpointer self);
static void __lambda148_ (ScratchMainWindow* self,
                   GdkDragContext* ctx,
                   gint x,
                   gint y,
                   GtkSelectionData* sel,
                   guint info,
                   guint time);
static void ___lambda148__gtk_widget_drag_data_received (GtkWidget* _sender,
                                                  GdkDragContext* context,
                                                  gint x,
                                                  gint y,
                                                  GtkSelectionData* selection_data,
                                                  guint info,
                                                  guint time_,
                                                  gpointer self);
static void __lambda149_ (ScratchMainWindow* self,
                   const gchar* a);
static void scratch_main_window_open_binary (ScratchMainWindow* self,
                                      GFile* file);
static void ___lambda149__scratch_folder_manager_file_view_select (ScratchFolderManagerFileView* _sender,
                                                            const gchar* file,
                                                            gpointer self);
static gboolean __lambda150_ (ScratchMainWindow* self,
                       ScratchFolderManagerFile* file);
static gboolean ___lambda150__scratch_folder_manager_file_view_rename_request (ScratchFolderManagerFileView* _sender,
                                                                        ScratchFolderManagerFile* file,
                                                                        gpointer self);
static void __lambda151_ (ScratchMainWindow* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda152_ (ScratchMainWindow* self);
static void ___lambda152__scratch_main_window_hook_func (gpointer self);
static void __lambda153_ (Block3Data* _data3_);
static void ___lambda153__scratch_services_plugins_manager_extension_added (ScratchServicesPluginsManager* _sender,
                                                                     PeasPluginInfo* info,
                                                                     gpointer self);
static void ___lambda151__gtk_widget_realize (GtkWidget* _sender,
                                       gpointer self);
static void __lambda154_ (ScratchMainWindow* self);
static void scratch_main_window_restore_opened_documents (ScratchMainWindow* self);
static void scratch_main_window_update_find_actions (ScratchMainWindow* self);
static void ___lambda154__gtk_widget_realize (GtkWidget* _sender,
                                       gpointer self);
static void __lambda157_ (ScratchMainWindow* self);
static void scratch_main_window_set_widgets_sensitive (ScratchMainWindow* self,
                                                gboolean val);
static void ___lambda157__scratch_widgets_document_view_request_placeholder (ScratchWidgetsDocumentView* _sender,
                                                                      gpointer self);
static void __lambda158_ (Block2Data* _data2_);
static void ___lambda158__scratch_widgets_document_view_tab_added (ScratchWidgetsDocumentView* _sender,
                                                            ScratchServicesDocument* document,
                                                            gpointer self);
static void __lambda159_ (ScratchMainWindow* self,
                   ScratchServicesDocument* doc);
static void ___lambda159__scratch_widgets_document_view_tab_removed (ScratchWidgetsDocumentView* _sender,
                                                              ScratchServicesDocument* document,
                                                              gpointer self);
static void __lambda160_ (ScratchMainWindow* self,
                   ScratchServicesDocument* doc);
static void ___lambda160__scratch_widgets_document_view_document_change (ScratchWidgetsDocumentView* _sender,
                                                                  ScratchServicesDocument* document,
                                                                  ScratchWidgetsDocumentView* parent,
                                                                  gpointer self);
static void __lambda161_ (ScratchMainWindow* self);
static void ___lambda161__code_choose_project_button_project_chosen (CodeChooseProjectButton* _sender,
                                                              gpointer self);
static gboolean __lambda155_ (ScratchMainWindow* self);
static gboolean ___lambda155__gsource_func (gpointer self);
static gboolean scratch_main_window_on_key_pressed (ScratchMainWindow* self,
                                             guint keyval,
                                             guint keycode,
                                             GdkModifierType state);
static GVariant* _variant_new1 (gboolean value);
static gboolean scratch_main_window_real_delete_event (GtkWidget* base,
                                                GdkEventAny* event);
static void scratch_main_window_check_unsaved_changes_data_free (gpointer _data);
static void scratch_main_window_check_unsaved_changes (ScratchMainWindow* self,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static gboolean scratch_main_window_check_unsaved_changes_finish (ScratchMainWindow* self,
                                                           GAsyncResult* _res_);
static gboolean scratch_main_window_check_unsaved_changes_co (ScratchMainWindowCheckUnsavedChangesData* _data_);
static void scratch_main_window_check_unsaved_changes_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void scratch_main_window_restore_saved_state_extra (ScratchMainWindow* self);
static void scratch_main_window_create_unsaved_documents_directory (ScratchMainWindow* self);
static void scratch_main_window_update_saved_state (ScratchMainWindow* self);
static void scratch_main_window_handle_quit (ScratchMainWindow* self);
static void scratch_main_window_zooming (ScratchMainWindow* self,
                                  GdkScrollDirection direction);
static void ___lambda138_ (ScratchMainWindow* self);
static void ____lambda138__gtk_widget_destroy (GtkWidget* _sender,
                                        gpointer self);
static void __lambda140_ (ScratchMainWindow* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda140__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void ____lambda137_ (ScratchMainWindow* self,
                     GFile* glib_file);
static void _____lambda137__gfunc (gconstpointer data,
                            gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda141_ (Block4Data* _data4_,
                   ScratchServicesDocument* doc);
static void ___lambda141__gfunc (gconstpointer data,
                          gpointer self);
static void scratch_main_window_close_project_docs (ScratchMainWindow* self,
                                             const gchar* project_path,
                                             gboolean make_restorable);
static gchar* scratch_main_window_get_target_path_for_actions (ScratchMainWindow* self,
                                                        GVariant* path_variant,
                                                        gboolean use_build_dir);
static void scratch_main_window_restore_project_docs (ScratchMainWindow* self,
                                               const gchar* project_path);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda142_ (Block5Data* _data5_,
                   ScratchServicesDocument* doc);
static void ___lambda142__gfunc (gconstpointer data,
                          gpointer self);
static gboolean __lambda143_ (ScratchMainWindow* self,
                       gchar* doc_path);
static gboolean ___lambda143__gee_forall_func (gpointer g,
                                        gpointer self);
static GVariant* _variant_new2 (gboolean value);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void ___lambda139_ (Block6Data* _data6_);
static void ____lambda139__gtk_widget_map (GtkWidget* _sender,
                                    gpointer self);
static gboolean __lambda156_ (ScratchMainWindow* self);
static gboolean ___lambda156__gsource_func (gpointer self);
static GVariant* _variant_new3 (gboolean value);
static GVariant* _variant_new4 (gboolean value);
static GVariant* _variant_new5 (gboolean value);
static GVariant* _variant_new6 (gboolean value);
static void scratch_main_window_set_app (ScratchMainWindow* self,
                                  ScratchApplication* value);
static GObject * scratch_main_window_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _scratch_main_window___lambda162_ (ScratchMainWindow* self);
static void __scratch_main_window___lambda162__g_settings_changed (GSettings* _sender,
                                                            const gchar* key,
                                                            gpointer self);
static gboolean _scratch_main_window_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                   guint keyval,
                                                                                   guint keycode,
                                                                                   GdkModifierType state,
                                                                                   gpointer self);
static void _scratch_main_window___lambda163_ (ScratchMainWindow* self);
static void __scratch_main_window___lambda163__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _scratch_main_window___lambda164_ (ScratchMainWindow* self,
                                        const gchar* name,
                                        GVariant* new_state);
static void __scratch_main_window___lambda164__g_action_group_action_state_changed (GActionGroup* _sender,
                                                                             const gchar* action_name,
                                                                             GVariant* state,
                                                                             gpointer self);
static GVariant* _variant_new7 (gboolean value);
static GVariant* _variant_new8 (gboolean value);
static GVariant* _variant_new9 (gboolean value);
static gboolean _scratch_main_window_quit_source_func_gsource_func (gpointer self);
static void scratch_main_window_finalize (GObject * obj);
static GType scratch_main_window_get_type_once (void);
static void _vala_scratch_main_window_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_scratch_main_window_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GActionEntry SCRATCH_MAIN_WINDOW_ACTION_ENTRIES[48] = {{SCRATCH_MAIN_WINDOW_ACTION_FIND, _scratch_main_window_action_fetch_gsimple_action_activate_callback, "s"}, {SCRATCH_MAIN_WINDOW_ACTION_FIND_NEXT, _scratch_main_window_action_find_next_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_FIND_PREVIOUS, _scratch_main_window_action_find_previous_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_FIND_GLOBAL, _scratch_main_window_action_find_global_gsimple_action_activate_callback, "s"}, {SCRATCH_MAIN_WINDOW_ACTION_OPEN, _scratch_main_window_action_open_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_OPEN_FOLDER, _scratch_main_window_action_open_folder_gsimple_action_activate_callback, "s"}, {SCRATCH_MAIN_WINDOW_ACTION_COLLAPSE_ALL_FOLDERS, _scratch_main_window_action_collapse_all_folders_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_ORDER_FOLDERS, _scratch_main_window_action_order_folders_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_PREFERENCES, _scratch_main_window_action_preferences_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_REVERT, _scratch_main_window_action_revert_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_SAVE, _scratch_main_window_action_save_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_SAVE_AS, _scratch_main_window_action_save_as_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_SHOW_FIND, _scratch_main_window_action_show_fetch_gsimple_action_activate_callback, NULL, "false"}, {SCRATCH_MAIN_WINDOW_ACTION_TEMPLATES, _scratch_main_window_action_templates_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_GO_TO, _scratch_main_window_action_go_to_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_SORT_LINES, _scratch_main_window_action_sort_lines_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_NEW_TAB, _scratch_main_window_action_new_tab_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_NEW_FROM_CLIPBOARD, _scratch_main_window_action_new_tab_from_clipboard_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_DUPLICATE_TAB, _scratch_main_window_action_duplicate_tab_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_PREFERENCES, _scratch_main_window_action_preferences_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_UNDO, _scratch_main_window_action_undo_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_REDO, _scratch_main_window_action_redo_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_SHOW_REPLACE, _scratch_main_window_action_show_replace_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_TO_LOWER_CASE, _scratch_main_window_action_to_lower_case_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_TO_UPPER_CASE, _scratch_main_window_action_to_upper_case_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_DUPLICATE, _scratch_main_window_action_duplicate_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_FULLSCREEN, _scratch_main_window_action_fullscreen_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_QUIT, _scratch_main_window_action_quit_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_ZOOM_DEFAULT, _scratch_main_window_action_set_default_zoom_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_ZOOM_IN, _scratch_main_window_action_zoom_in_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_ZOOM_OUT, _scratch_main_window_action_zoom_out_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_COMMENT, _scratch_main_window_action_toggle_comment_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_SIDEBAR, _scratch_main_window_action_toggle_sidebar_gsimple_action_activate_callback, NULL, "true"}, {SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_TERMINAL, _scratch_main_window_action_toggle_terminal_gsimple_action_activate_callback, NULL, "false"}, {SCRATCH_MAIN_WINDOW_ACTION_OPEN_IN_TERMINAL, _scratch_main_window_action_open_in_terminal_gsimple_action_activate_callback, "s"}, {SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_OUTLINE, _scratch_main_window_action_toggle_outline_gsimple_action_activate_callback, NULL, "false"}, {SCRATCH_MAIN_WINDOW_ACTION_NEXT_TAB, _scratch_main_window_action_next_tab_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_PREVIOUS_TAB, _scratch_main_window_action_previous_tab_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_CLEAR_LINES, _scratch_main_window_action_clear_lines_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_NEW_BRANCH, _scratch_main_window_action_new_branch_gsimple_action_activate_callback, "s"}, {SCRATCH_MAIN_WINDOW_ACTION_CLOSE_TAB, _scratch_main_window_action_close_tab_gsimple_action_activate_callback, "s"}, {SCRATCH_MAIN_WINDOW_ACTION_CLOSE_TABS_TO_RIGHT, _scratch_main_window_action_close_tabs_to_right_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_CLOSE_OTHER_TABS, _scratch_main_window_action_close_other_tabs_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_HIDE_PROJECT_DOCS, _scratch_main_window_action_hide_project_docs_gsimple_action_activate_callback, "s"}, {SCRATCH_MAIN_WINDOW_ACTION_CLOSE_PROJECT_DOCS, _scratch_main_window_action_close_project_docs_gsimple_action_activate_callback, "s"}, {SCRATCH_MAIN_WINDOW_ACTION_RESTORE_PROJECT_DOCS, _scratch_main_window_action_restore_project_docs_gsimple_action_activate_callback, "s"}, {SCRATCH_MAIN_WINDOW_ACTION_MOVE_TAB_TO_NEW_WINDOW, _scratch_main_window_action_move_tab_to_new_window_gsimple_action_activate_callback}, {SCRATCH_MAIN_WINDOW_ACTION_RESTORE_CLOSED_TAB, _scratch_main_window_action_restore_closed_tab_gsimple_action_activate_callback, "s"}};
VALA_EXTERN const SelectionRange SELECTION_RANGE_EMPTY;

static inline gpointer
scratch_main_window_get_instance_private (ScratchMainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, ScratchMainWindow_private_offset);
}

static void
_scratch_main_window_action_fetch_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_fetch ((ScratchMainWindow*) self, action, parameter);
#line 611 "MainWindow.c"
}

static void
_scratch_main_window_action_find_next_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_find_next ((ScratchMainWindow*) self);
#line 621 "MainWindow.c"
}

static void
_scratch_main_window_action_find_previous_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_find_previous ((ScratchMainWindow*) self);
#line 631 "MainWindow.c"
}

static void
_scratch_main_window_action_find_global_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_find_global ((ScratchMainWindow*) self, action, parameter);
#line 641 "MainWindow.c"
}

static void
_scratch_main_window_action_open_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_open ((ScratchMainWindow*) self);
#line 651 "MainWindow.c"
}

static void
_scratch_main_window_action_open_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_open_folder ((ScratchMainWindow*) self, action, parameter);
#line 661 "MainWindow.c"
}

static void
_scratch_main_window_action_collapse_all_folders_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_collapse_all_folders ((ScratchMainWindow*) self);
#line 671 "MainWindow.c"
}

static void
_scratch_main_window_action_order_folders_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_order_folders ((ScratchMainWindow*) self);
#line 681 "MainWindow.c"
}

static void
_scratch_main_window_action_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_preferences ((ScratchMainWindow*) self);
#line 691 "MainWindow.c"
}

static void
_scratch_main_window_action_revert_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_revert ((ScratchMainWindow*) self);
#line 701 "MainWindow.c"
}

static void
_scratch_main_window_action_save_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_save ((ScratchMainWindow*) self);
#line 711 "MainWindow.c"
}

static void
_scratch_main_window_action_save_as_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_save_as ((ScratchMainWindow*) self);
#line 721 "MainWindow.c"
}

static void
_scratch_main_window_action_show_fetch_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_show_fetch ((ScratchMainWindow*) self);
#line 731 "MainWindow.c"
}

static void
_scratch_main_window_action_templates_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_templates ((ScratchMainWindow*) self);
#line 741 "MainWindow.c"
}

static void
_scratch_main_window_action_go_to_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_go_to ((ScratchMainWindow*) self);
#line 751 "MainWindow.c"
}

static void
_scratch_main_window_action_sort_lines_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_sort_lines ((ScratchMainWindow*) self);
#line 761 "MainWindow.c"
}

static void
_scratch_main_window_action_new_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_new_tab ((ScratchMainWindow*) self);
#line 771 "MainWindow.c"
}

static void
_scratch_main_window_action_new_tab_from_clipboard_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_new_tab_from_clipboard ((ScratchMainWindow*) self);
#line 781 "MainWindow.c"
}

static void
_scratch_main_window_action_duplicate_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_duplicate_tab ((ScratchMainWindow*) self);
#line 791 "MainWindow.c"
}

static void
_scratch_main_window_action_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_undo ((ScratchMainWindow*) self);
#line 801 "MainWindow.c"
}

static void
_scratch_main_window_action_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_redo ((ScratchMainWindow*) self);
#line 811 "MainWindow.c"
}

static void
_scratch_main_window_action_show_replace_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_show_replace ((ScratchMainWindow*) self, action);
#line 821 "MainWindow.c"
}

static void
_scratch_main_window_action_to_lower_case_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_to_lower_case ((ScratchMainWindow*) self);
#line 831 "MainWindow.c"
}

static void
_scratch_main_window_action_to_upper_case_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_to_upper_case ((ScratchMainWindow*) self);
#line 841 "MainWindow.c"
}

static void
_scratch_main_window_action_duplicate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_duplicate ((ScratchMainWindow*) self);
#line 851 "MainWindow.c"
}

static void
_scratch_main_window_action_fullscreen_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_fullscreen ((ScratchMainWindow*) self);
#line 861 "MainWindow.c"
}

static void
_scratch_main_window_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_quit ((ScratchMainWindow*) self);
#line 871 "MainWindow.c"
}

static void
_scratch_main_window_action_set_default_zoom_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_set_default_zoom ((ScratchMainWindow*) self);
#line 881 "MainWindow.c"
}

static void
_scratch_main_window_action_zoom_in_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_zoom_in ((ScratchMainWindow*) self);
#line 891 "MainWindow.c"
}

static void
_scratch_main_window_action_zoom_out_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_zoom_out ((ScratchMainWindow*) self);
#line 901 "MainWindow.c"
}

static void
_scratch_main_window_action_toggle_comment_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_toggle_comment ((ScratchMainWindow*) self);
#line 911 "MainWindow.c"
}

static void
_scratch_main_window_action_toggle_sidebar_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_toggle_sidebar ((ScratchMainWindow*) self, action);
#line 921 "MainWindow.c"
}

static void
_scratch_main_window_action_toggle_terminal_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_toggle_terminal ((ScratchMainWindow*) self);
#line 931 "MainWindow.c"
}

static void
_scratch_main_window_action_open_in_terminal_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_open_in_terminal ((ScratchMainWindow*) self, action, parameter);
#line 941 "MainWindow.c"
}

static void
_scratch_main_window_action_toggle_outline_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_toggle_outline ((ScratchMainWindow*) self, action);
#line 951 "MainWindow.c"
}

static void
_scratch_main_window_action_next_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_next_tab ((ScratchMainWindow*) self);
#line 961 "MainWindow.c"
}

static void
_scratch_main_window_action_previous_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_previous_tab ((ScratchMainWindow*) self);
#line 971 "MainWindow.c"
}

static void
_scratch_main_window_action_clear_lines_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_clear_lines ((ScratchMainWindow*) self);
#line 981 "MainWindow.c"
}

static void
_scratch_main_window_action_new_branch_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_new_branch ((ScratchMainWindow*) self, action, parameter);
#line 991 "MainWindow.c"
}

static void
_scratch_main_window_action_close_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_close_tab ((ScratchMainWindow*) self, action, parameter);
#line 1001 "MainWindow.c"
}

static void
_scratch_main_window_action_close_tabs_to_right_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_close_tabs_to_right ((ScratchMainWindow*) self);
#line 1011 "MainWindow.c"
}

static void
_scratch_main_window_action_close_other_tabs_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_close_other_tabs ((ScratchMainWindow*) self);
#line 1021 "MainWindow.c"
}

static void
_scratch_main_window_action_hide_project_docs_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_hide_project_docs ((ScratchMainWindow*) self, action, parameter);
#line 1031 "MainWindow.c"
}

static void
_scratch_main_window_action_close_project_docs_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_close_project_docs ((ScratchMainWindow*) self, action, parameter);
#line 1041 "MainWindow.c"
}

static void
_scratch_main_window_action_restore_project_docs_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_restore_project_docs ((ScratchMainWindow*) self, action, parameter);
#line 1051 "MainWindow.c"
}

static void
_scratch_main_window_action_move_tab_to_new_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_move_tab_to_new_window ((ScratchMainWindow*) self);
#line 1061 "MainWindow.c"
}

static void
_scratch_main_window_action_restore_closed_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self)
{
#line 117 "../src/MainWindow.vala"
	scratch_main_window_action_restore_closed_tab ((ScratchMainWindow*) self, action, parameter);
#line 1071 "MainWindow.c"
}

ScratchMainWindow*
scratch_main_window_construct (GType object_type,
                               gboolean restore_docs)
{
	ScratchMainWindow * self = NULL;
#line 169 "../src/MainWindow.vala"
	self = (ScratchMainWindow*) g_object_new (object_type, "icon-name", CONSTANTS_PROJECT_NAME, "restore-docs", restore_docs, NULL);
#line 168 "../src/MainWindow.vala"
	return self;
#line 1083 "MainWindow.c"
}

ScratchMainWindow*
scratch_main_window_new (gboolean restore_docs)
{
#line 168 "../src/MainWindow.vala"
	return scratch_main_window_construct (SCRATCH_TYPE_MAIN_WINDOW, restore_docs);
#line 1091 "MainWindow.c"
}

ScratchMainWindow*
scratch_main_window_construct_with_restore_override (GType object_type,
                                                     gboolean restore_docs,
                                                     RestoreOverride* restore_override)
{
	ScratchMainWindow * self = NULL;
#line 175 "../src/MainWindow.vala"
	g_return_val_if_fail (restore_override != NULL, NULL);
#line 176 "../src/MainWindow.vala"
	self = (ScratchMainWindow*) g_object_new (object_type, "icon-name", CONSTANTS_PROJECT_NAME, "restore-docs", restore_docs, "restore-override", restore_override, NULL);
#line 175 "../src/MainWindow.vala"
	return self;
#line 1106 "MainWindow.c"
}

ScratchMainWindow*
scratch_main_window_new_with_restore_override (gboolean restore_docs,
                                               RestoreOverride* restore_override)
{
#line 175 "../src/MainWindow.vala"
	return scratch_main_window_construct_with_restore_override (SCRATCH_TYPE_MAIN_WINDOW, restore_docs, restore_override);
#line 1115 "MainWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 339 "../src/MainWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 1123 "MainWindow.c"
}

static void
scratch_main_window_update_style (ScratchMainWindow* self)
{
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	GSettings* _tmp2_;
#line 338 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 339 "../src/MainWindow.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 339 "../src/MainWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 339 "../src/MainWindow.vala"
	gtk_settings = _tmp1_;
#line 340 "../src/MainWindow.vala"
	_tmp2_ = scratch_settings;
#line 340 "../src/MainWindow.vala"
	if (g_settings_get_boolean (_tmp2_, "follow-system-style")) {
#line 1145 "MainWindow.c"
		gboolean system_prefers_dark = FALSE;
		GraniteSettings* _tmp3_;
		GraniteSettingsColorScheme _tmp4_;
		GraniteSettingsColorScheme _tmp5_;
		GtkSettings* _tmp6_;
#line 341 "../src/MainWindow.vala"
		_tmp3_ = granite_settings_get_default ();
#line 341 "../src/MainWindow.vala"
		_tmp4_ = granite_settings_get_prefers_color_scheme (_tmp3_);
#line 341 "../src/MainWindow.vala"
		_tmp5_ = _tmp4_;
#line 341 "../src/MainWindow.vala"
		system_prefers_dark = _tmp5_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK;
#line 342 "../src/MainWindow.vala"
		_tmp6_ = gtk_settings;
#line 342 "../src/MainWindow.vala"
		g_object_set (_tmp6_, "gtk-application-prefer-dark-theme", system_prefers_dark, NULL);
#line 343 "../src/MainWindow.vala"
		scratch_main_window_connect_color_scheme_preference_listener (self);
#line 1165 "MainWindow.c"
	} else {
		GtkSettings* _tmp7_;
		GSettings* _tmp8_;
#line 345 "../src/MainWindow.vala"
		scratch_main_window_disconnect_color_scheme_preference_listener (self);
#line 346 "../src/MainWindow.vala"
		_tmp7_ = gtk_settings;
#line 346 "../src/MainWindow.vala"
		_tmp8_ = scratch_settings;
#line 346 "../src/MainWindow.vala"
		g_object_set (_tmp7_, "gtk-application-prefer-dark-theme", g_settings_get_boolean (_tmp8_, "prefer-dark-style"), NULL);
#line 1177 "MainWindow.c"
	}
#line 338 "../src/MainWindow.vala"
	_g_object_unref0 (gtk_settings);
#line 1181 "MainWindow.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 350 "../src/MainWindow.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 350 "../src/MainWindow.vala"
	return _data1_;
#line 1191 "MainWindow.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 350 "../src/MainWindow.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1201 "MainWindow.c"
		ScratchMainWindow* self;
#line 350 "../src/MainWindow.vala"
		self = _data1_->self;
#line 350 "../src/MainWindow.vala"
		_g_object_unref0 (_data1_->granite_settings);
#line 350 "../src/MainWindow.vala"
		_g_object_unref0 (_data1_->gtk_settings);
#line 350 "../src/MainWindow.vala"
		_g_object_unref0 (self);
#line 350 "../src/MainWindow.vala"
		g_slice_free (Block1Data, _data1_);
#line 1213 "MainWindow.c"
	}
}

static void
__lambda144_ (Block1Data* _data1_)
{
	ScratchMainWindow* self;
	GraniteSettingsColorScheme _tmp0_;
	GraniteSettingsColorScheme _tmp1_;
#line 354 "../src/MainWindow.vala"
	self = _data1_->self;
#line 355 "../src/MainWindow.vala"
	_tmp0_ = granite_settings_get_prefers_color_scheme (_data1_->granite_settings);
#line 355 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 355 "../src/MainWindow.vala"
	g_object_set (_data1_->gtk_settings, "gtk-application-prefer-dark-theme", _tmp1_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, NULL);
#line 1231 "MainWindow.c"
}

static void
___lambda144__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 354 "../src/MainWindow.vala"
	__lambda144_ (self);
#line 1241 "MainWindow.c"
}

static void
scratch_main_window_connect_color_scheme_preference_listener (ScratchMainWindow* self)
{
	Block1Data* _data1_;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	GraniteSettings* _tmp2_;
	GraniteSettings* _tmp3_;
	gulong _tmp4_;
#line 350 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 350 "../src/MainWindow.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 350 "../src/MainWindow.vala"
	_data1_->_ref_count_ = 1;
#line 350 "../src/MainWindow.vala"
	_data1_->self = g_object_ref (self);
#line 351 "../src/MainWindow.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 351 "../src/MainWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 351 "../src/MainWindow.vala"
	_data1_->gtk_settings = _tmp1_;
#line 352 "../src/MainWindow.vala"
	_tmp2_ = granite_settings_get_default ();
#line 352 "../src/MainWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 352 "../src/MainWindow.vala"
	_data1_->granite_settings = _tmp3_;
#line 354 "../src/MainWindow.vala"
	_tmp4_ = g_signal_connect_data ((GObject*) _data1_->granite_settings, "notify::prefers-color-scheme", (GCallback) ___lambda144__g_object_notify, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 354 "../src/MainWindow.vala"
	self->priv->color_scheme_listener_handler_id = _tmp4_;
#line 350 "../src/MainWindow.vala"
	block1_data_unref (_data1_);
#line 350 "../src/MainWindow.vala"
	_data1_ = NULL;
#line 1281 "MainWindow.c"
}

static void
scratch_main_window_disconnect_color_scheme_preference_listener (ScratchMainWindow* self)
{
#line 361 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 362 "../src/MainWindow.vala"
	if (self->priv->color_scheme_listener_handler_id != ((gulong) 0)) {
#line 1291 "MainWindow.c"
		GraniteSettings* granite_settings = NULL;
		GraniteSettings* _tmp0_;
		GraniteSettings* _tmp1_;
		GraniteSettings* _tmp2_;
#line 363 "../src/MainWindow.vala"
		_tmp0_ = granite_settings_get_default ();
#line 363 "../src/MainWindow.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 363 "../src/MainWindow.vala"
		granite_settings = _tmp1_;
#line 364 "../src/MainWindow.vala"
		_tmp2_ = granite_settings;
#line 364 "../src/MainWindow.vala"
		g_signal_handler_disconnect ((GObject*) _tmp2_, self->priv->color_scheme_listener_handler_id);
#line 365 "../src/MainWindow.vala"
		self->priv->color_scheme_listener_handler_id = (gulong) 0;
#line 362 "../src/MainWindow.vala"
		_g_object_unref0 (granite_settings);
#line 1310 "MainWindow.c"
	}
}

static void
scratch_main_window_update_toolbar_button (ScratchMainWindow* self,
                                           const gchar* name,
                                           gboolean new_state)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 370 "../src/MainWindow.vala"
	static GQuark _tmp1_label0 = 0;
#line 370 "../src/MainWindow.vala"
	static GQuark _tmp1_label1 = 0;
#line 370 "../src/MainWindow.vala"
	static GQuark _tmp1_label2 = 0;
#line 370 "../src/MainWindow.vala"
	static GQuark _tmp1_label3 = 0;
#line 369 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 369 "../src/MainWindow.vala"
	g_return_if_fail (name != NULL);
#line 370 "../src/MainWindow.vala"
	_tmp0_ = name;
#line 370 "../src/MainWindow.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 370 "../src/MainWindow.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string (SCRATCH_MAIN_WINDOW_ACTION_SHOW_FIND)))) {
#line 370 "../src/MainWindow.vala"
		switch (0) {
#line 1341 "MainWindow.c"
			default:
			{
				GtkRevealer* _tmp22_;
#line 372 "../src/MainWindow.vala"
				if (new_state) {
#line 1347 "MainWindow.c"
					ScratchHeaderBar* _tmp3_;
					GtkToggleButton* _tmp4_;
					GtkToggleButton* _tmp5_;
					gchar* _tmp6_;
					gchar** _tmp7_;
					gchar** _tmp8_;
					gint _tmp8__length1;
					gchar* _tmp9_;
					gchar* _tmp10_;
#line 373 "../src/MainWindow.vala"
					_tmp3_ = self->toolbar;
#line 373 "../src/MainWindow.vala"
					_tmp4_ = scratch_header_bar_get_find_button (_tmp3_);
#line 373 "../src/MainWindow.vala"
					_tmp5_ = _tmp4_;
#line 373 "../src/MainWindow.vala"
					_tmp6_ = g_strdup ("Escape");
#line 373 "../src/MainWindow.vala"
					_tmp7_ = g_new0 (gchar*, 1 + 1);
#line 373 "../src/MainWindow.vala"
					_tmp7_[0] = _tmp6_;
#line 373 "../src/MainWindow.vala"
					_tmp8_ = _tmp7_;
#line 373 "../src/MainWindow.vala"
					_tmp8__length1 = 1;
#line 373 "../src/MainWindow.vala"
					_tmp9_ = granite_markup_accel_tooltip (_tmp8_, (gint) 1, _ ("Hide search bar"));
#line 373 "../src/MainWindow.vala"
					_tmp10_ = _tmp9_;
#line 373 "../src/MainWindow.vala"
					gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp5_, _tmp10_);
#line 373 "../src/MainWindow.vala"
					_g_free0 (_tmp10_);
#line 373 "../src/MainWindow.vala"
					_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 1383 "MainWindow.c"
				} else {
					ScratchHeaderBar* _tmp11_;
					GtkToggleButton* _tmp12_;
					GtkToggleButton* _tmp13_;
					ScratchApplication* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar** _tmp17_;
					gchar** _tmp18_;
					gchar** _tmp19_;
					gint _tmp19__length1;
					gchar* _tmp20_;
					gchar* _tmp21_;
#line 378 "../src/MainWindow.vala"
					_tmp11_ = self->toolbar;
#line 378 "../src/MainWindow.vala"
					_tmp12_ = scratch_header_bar_get_find_button (_tmp11_);
#line 378 "../src/MainWindow.vala"
					_tmp13_ = _tmp12_;
#line 378 "../src/MainWindow.vala"
					_tmp14_ = self->priv->_app;
#line 378 "../src/MainWindow.vala"
					_tmp15_ = g_strconcat (SCRATCH_MAIN_WINDOW_ACTION_PREFIX, name, NULL);
#line 378 "../src/MainWindow.vala"
					_tmp16_ = _tmp15_;
#line 378 "../src/MainWindow.vala"
					_tmp18_ = _tmp17_ = gtk_application_get_accels_for_action ((GtkApplication*) _tmp14_, _tmp16_);
#line 378 "../src/MainWindow.vala"
					_tmp19_ = _tmp18_;
#line 378 "../src/MainWindow.vala"
					_tmp19__length1 = _vala_array_length (_tmp17_);
#line 378 "../src/MainWindow.vala"
					_tmp20_ = granite_markup_accel_tooltip (_tmp19_, (gint) _vala_array_length (_tmp17_), _ ("Find on Page…"));
#line 378 "../src/MainWindow.vala"
					_tmp21_ = _tmp20_;
#line 378 "../src/MainWindow.vala"
					gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp13_, _tmp21_);
#line 378 "../src/MainWindow.vala"
					_g_free0 (_tmp21_);
#line 378 "../src/MainWindow.vala"
					_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_free), NULL);
#line 378 "../src/MainWindow.vala"
					_g_free0 (_tmp16_);
#line 1427 "MainWindow.c"
				}
#line 384 "../src/MainWindow.vala"
				_tmp22_ = self->priv->search_revealer;
#line 384 "../src/MainWindow.vala"
				gtk_revealer_set_reveal_child (_tmp22_, new_state);
#line 386 "../src/MainWindow.vala"
				break;
#line 1435 "MainWindow.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string (SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_SIDEBAR)))) {
#line 370 "../src/MainWindow.vala"
		switch (0) {
#line 1441 "MainWindow.c"
			default:
			{
#line 388 "../src/MainWindow.vala"
				if (new_state) {
#line 1446 "MainWindow.c"
					ScratchHeaderBar* _tmp23_;
					GtkToggleButton* _tmp24_;
					GtkToggleButton* _tmp25_;
					ScratchApplication* _tmp26_;
					gchar* _tmp27_;
					gchar* _tmp28_;
					gchar** _tmp29_;
					gchar** _tmp30_;
					gchar** _tmp31_;
					gint _tmp31__length1;
					gchar* _tmp32_;
					gchar* _tmp33_;
#line 389 "../src/MainWindow.vala"
					_tmp23_ = self->toolbar;
#line 389 "../src/MainWindow.vala"
					_tmp24_ = scratch_header_bar_get_sidebar_button (_tmp23_);
#line 389 "../src/MainWindow.vala"
					_tmp25_ = _tmp24_;
#line 389 "../src/MainWindow.vala"
					_tmp26_ = self->priv->_app;
#line 389 "../src/MainWindow.vala"
					_tmp27_ = g_strconcat (SCRATCH_MAIN_WINDOW_ACTION_PREFIX, name, NULL);
#line 389 "../src/MainWindow.vala"
					_tmp28_ = _tmp27_;
#line 389 "../src/MainWindow.vala"
					_tmp30_ = _tmp29_ = gtk_application_get_accels_for_action ((GtkApplication*) _tmp26_, _tmp28_);
#line 389 "../src/MainWindow.vala"
					_tmp31_ = _tmp30_;
#line 389 "../src/MainWindow.vala"
					_tmp31__length1 = _vala_array_length (_tmp29_);
#line 389 "../src/MainWindow.vala"
					_tmp32_ = granite_markup_accel_tooltip (_tmp31_, (gint) _vala_array_length (_tmp29_), _ ("Hide Projects Sidebar"));
#line 389 "../src/MainWindow.vala"
					_tmp33_ = _tmp32_;
#line 389 "../src/MainWindow.vala"
					gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp25_, _tmp33_);
#line 389 "../src/MainWindow.vala"
					_g_free0 (_tmp33_);
#line 389 "../src/MainWindow.vala"
					_tmp31_ = (_vala_array_free (_tmp31_, _tmp31__length1, (GDestroyNotify) g_free), NULL);
#line 389 "../src/MainWindow.vala"
					_g_free0 (_tmp28_);
#line 1489 "MainWindow.c"
				} else {
					ScratchHeaderBar* _tmp34_;
					GtkToggleButton* _tmp35_;
					GtkToggleButton* _tmp36_;
					ScratchApplication* _tmp37_;
					gchar* _tmp38_;
					gchar* _tmp39_;
					gchar** _tmp40_;
					gchar** _tmp41_;
					gchar** _tmp42_;
					gint _tmp42__length1;
					gchar* _tmp43_;
					gchar* _tmp44_;
#line 394 "../src/MainWindow.vala"
					_tmp34_ = self->toolbar;
#line 394 "../src/MainWindow.vala"
					_tmp35_ = scratch_header_bar_get_sidebar_button (_tmp34_);
#line 394 "../src/MainWindow.vala"
					_tmp36_ = _tmp35_;
#line 394 "../src/MainWindow.vala"
					_tmp37_ = self->priv->_app;
#line 394 "../src/MainWindow.vala"
					_tmp38_ = g_strconcat (SCRATCH_MAIN_WINDOW_ACTION_PREFIX, name, NULL);
#line 394 "../src/MainWindow.vala"
					_tmp39_ = _tmp38_;
#line 394 "../src/MainWindow.vala"
					_tmp41_ = _tmp40_ = gtk_application_get_accels_for_action ((GtkApplication*) _tmp37_, _tmp39_);
#line 394 "../src/MainWindow.vala"
					_tmp42_ = _tmp41_;
#line 394 "../src/MainWindow.vala"
					_tmp42__length1 = _vala_array_length (_tmp40_);
#line 394 "../src/MainWindow.vala"
					_tmp43_ = granite_markup_accel_tooltip (_tmp42_, (gint) _vala_array_length (_tmp40_), _ ("Show Projects Sidebar"));
#line 394 "../src/MainWindow.vala"
					_tmp44_ = _tmp43_;
#line 394 "../src/MainWindow.vala"
					gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp36_, _tmp44_);
#line 394 "../src/MainWindow.vala"
					_g_free0 (_tmp44_);
#line 394 "../src/MainWindow.vala"
					_tmp42_ = (_vala_array_free (_tmp42_, _tmp42__length1, (GDestroyNotify) g_free), NULL);
#line 394 "../src/MainWindow.vala"
					_g_free0 (_tmp39_);
#line 1533 "MainWindow.c"
				}
#line 400 "../src/MainWindow.vala"
				break;
#line 1537 "MainWindow.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string (SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_OUTLINE)))) {
#line 370 "../src/MainWindow.vala"
		switch (0) {
#line 1543 "MainWindow.c"
			default:
			{
#line 402 "../src/MainWindow.vala"
				if (new_state) {
#line 1548 "MainWindow.c"
					ScratchHeaderBar* _tmp45_;
					GtkToggleButton* _tmp46_;
					GtkToggleButton* _tmp47_;
					ScratchApplication* _tmp48_;
					gchar* _tmp49_;
					gchar* _tmp50_;
					gchar** _tmp51_;
					gchar** _tmp52_;
					gchar** _tmp53_;
					gint _tmp53__length1;
					gchar* _tmp54_;
					gchar* _tmp55_;
#line 403 "../src/MainWindow.vala"
					_tmp45_ = self->toolbar;
#line 403 "../src/MainWindow.vala"
					_tmp46_ = scratch_header_bar_get_outline_button (_tmp45_);
#line 403 "../src/MainWindow.vala"
					_tmp47_ = _tmp46_;
#line 403 "../src/MainWindow.vala"
					_tmp48_ = self->priv->_app;
#line 403 "../src/MainWindow.vala"
					_tmp49_ = g_strconcat (SCRATCH_MAIN_WINDOW_ACTION_PREFIX, name, NULL);
#line 403 "../src/MainWindow.vala"
					_tmp50_ = _tmp49_;
#line 403 "../src/MainWindow.vala"
					_tmp52_ = _tmp51_ = gtk_application_get_accels_for_action ((GtkApplication*) _tmp48_, _tmp50_);
#line 403 "../src/MainWindow.vala"
					_tmp53_ = _tmp52_;
#line 403 "../src/MainWindow.vala"
					_tmp53__length1 = _vala_array_length (_tmp51_);
#line 403 "../src/MainWindow.vala"
					_tmp54_ = granite_markup_accel_tooltip (_tmp53_, (gint) _vala_array_length (_tmp51_), _ ("Hide Symbol Outline"));
#line 403 "../src/MainWindow.vala"
					_tmp55_ = _tmp54_;
#line 403 "../src/MainWindow.vala"
					gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp47_, _tmp55_);
#line 403 "../src/MainWindow.vala"
					_g_free0 (_tmp55_);
#line 403 "../src/MainWindow.vala"
					_tmp53_ = (_vala_array_free (_tmp53_, _tmp53__length1, (GDestroyNotify) g_free), NULL);
#line 403 "../src/MainWindow.vala"
					_g_free0 (_tmp50_);
#line 1591 "MainWindow.c"
				} else {
					ScratchHeaderBar* _tmp56_;
					GtkToggleButton* _tmp57_;
					GtkToggleButton* _tmp58_;
					ScratchApplication* _tmp59_;
					gchar* _tmp60_;
					gchar* _tmp61_;
					gchar** _tmp62_;
					gchar** _tmp63_;
					gchar** _tmp64_;
					gint _tmp64__length1;
					gchar* _tmp65_;
					gchar* _tmp66_;
#line 408 "../src/MainWindow.vala"
					_tmp56_ = self->toolbar;
#line 408 "../src/MainWindow.vala"
					_tmp57_ = scratch_header_bar_get_outline_button (_tmp56_);
#line 408 "../src/MainWindow.vala"
					_tmp58_ = _tmp57_;
#line 408 "../src/MainWindow.vala"
					_tmp59_ = self->priv->_app;
#line 408 "../src/MainWindow.vala"
					_tmp60_ = g_strconcat (SCRATCH_MAIN_WINDOW_ACTION_PREFIX, name, NULL);
#line 408 "../src/MainWindow.vala"
					_tmp61_ = _tmp60_;
#line 408 "../src/MainWindow.vala"
					_tmp63_ = _tmp62_ = gtk_application_get_accels_for_action ((GtkApplication*) _tmp59_, _tmp61_);
#line 408 "../src/MainWindow.vala"
					_tmp64_ = _tmp63_;
#line 408 "../src/MainWindow.vala"
					_tmp64__length1 = _vala_array_length (_tmp62_);
#line 408 "../src/MainWindow.vala"
					_tmp65_ = granite_markup_accel_tooltip (_tmp64_, (gint) _vala_array_length (_tmp62_), _ ("Show Symbol Outline"));
#line 408 "../src/MainWindow.vala"
					_tmp66_ = _tmp65_;
#line 408 "../src/MainWindow.vala"
					gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp58_, _tmp66_);
#line 408 "../src/MainWindow.vala"
					_g_free0 (_tmp66_);
#line 408 "../src/MainWindow.vala"
					_tmp64_ = (_vala_array_free (_tmp64_, _tmp64__length1, (GDestroyNotify) g_free), NULL);
#line 408 "../src/MainWindow.vala"
					_g_free0 (_tmp61_);
#line 1635 "MainWindow.c"
				}
#line 414 "../src/MainWindow.vala"
				break;
#line 1639 "MainWindow.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string (SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_TERMINAL)))) {
#line 370 "../src/MainWindow.vala"
		switch (0) {
#line 1645 "MainWindow.c"
			default:
			{
#line 416 "../src/MainWindow.vala"
				if (new_state) {
#line 1650 "MainWindow.c"
					ScratchHeaderBar* _tmp67_;
					GtkToggleButton* _tmp68_;
					GtkToggleButton* _tmp69_;
					ScratchApplication* _tmp70_;
					gchar* _tmp71_;
					gchar* _tmp72_;
					gchar** _tmp73_;
					gchar** _tmp74_;
					gchar** _tmp75_;
					gint _tmp75__length1;
					gchar* _tmp76_;
					gchar* _tmp77_;
#line 417 "../src/MainWindow.vala"
					_tmp67_ = self->toolbar;
#line 417 "../src/MainWindow.vala"
					_tmp68_ = scratch_header_bar_get_terminal_button (_tmp67_);
#line 417 "../src/MainWindow.vala"
					_tmp69_ = _tmp68_;
#line 417 "../src/MainWindow.vala"
					_tmp70_ = self->priv->_app;
#line 417 "../src/MainWindow.vala"
					_tmp71_ = g_strconcat (SCRATCH_MAIN_WINDOW_ACTION_PREFIX, name, NULL);
#line 417 "../src/MainWindow.vala"
					_tmp72_ = _tmp71_;
#line 417 "../src/MainWindow.vala"
					_tmp74_ = _tmp73_ = gtk_application_get_accels_for_action ((GtkApplication*) _tmp70_, _tmp72_);
#line 417 "../src/MainWindow.vala"
					_tmp75_ = _tmp74_;
#line 417 "../src/MainWindow.vala"
					_tmp75__length1 = _vala_array_length (_tmp73_);
#line 417 "../src/MainWindow.vala"
					_tmp76_ = granite_markup_accel_tooltip (_tmp75_, (gint) _vala_array_length (_tmp73_), _ ("Hide Terminal"));
#line 417 "../src/MainWindow.vala"
					_tmp77_ = _tmp76_;
#line 417 "../src/MainWindow.vala"
					gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp69_, _tmp77_);
#line 417 "../src/MainWindow.vala"
					_g_free0 (_tmp77_);
#line 417 "../src/MainWindow.vala"
					_tmp75_ = (_vala_array_free (_tmp75_, _tmp75__length1, (GDestroyNotify) g_free), NULL);
#line 417 "../src/MainWindow.vala"
					_g_free0 (_tmp72_);
#line 1693 "MainWindow.c"
				} else {
					ScratchHeaderBar* _tmp78_;
					GtkToggleButton* _tmp79_;
					GtkToggleButton* _tmp80_;
					ScratchApplication* _tmp81_;
					gchar* _tmp82_;
					gchar* _tmp83_;
					gchar** _tmp84_;
					gchar** _tmp85_;
					gchar** _tmp86_;
					gint _tmp86__length1;
					gchar* _tmp87_;
					gchar* _tmp88_;
#line 422 "../src/MainWindow.vala"
					_tmp78_ = self->toolbar;
#line 422 "../src/MainWindow.vala"
					_tmp79_ = scratch_header_bar_get_terminal_button (_tmp78_);
#line 422 "../src/MainWindow.vala"
					_tmp80_ = _tmp79_;
#line 422 "../src/MainWindow.vala"
					_tmp81_ = self->priv->_app;
#line 422 "../src/MainWindow.vala"
					_tmp82_ = g_strconcat (SCRATCH_MAIN_WINDOW_ACTION_PREFIX, name, NULL);
#line 422 "../src/MainWindow.vala"
					_tmp83_ = _tmp82_;
#line 422 "../src/MainWindow.vala"
					_tmp85_ = _tmp84_ = gtk_application_get_accels_for_action ((GtkApplication*) _tmp81_, _tmp83_);
#line 422 "../src/MainWindow.vala"
					_tmp86_ = _tmp85_;
#line 422 "../src/MainWindow.vala"
					_tmp86__length1 = _vala_array_length (_tmp84_);
#line 422 "../src/MainWindow.vala"
					_tmp87_ = granite_markup_accel_tooltip (_tmp86_, (gint) _vala_array_length (_tmp84_), _ ("Show Terminal"));
#line 422 "../src/MainWindow.vala"
					_tmp88_ = _tmp87_;
#line 422 "../src/MainWindow.vala"
					gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp80_, _tmp88_);
#line 422 "../src/MainWindow.vala"
					_g_free0 (_tmp88_);
#line 422 "../src/MainWindow.vala"
					_tmp86_ = (_vala_array_free (_tmp86_, _tmp86__length1, (GDestroyNotify) g_free), NULL);
#line 422 "../src/MainWindow.vala"
					_g_free0 (_tmp83_);
#line 1737 "MainWindow.c"
				}
#line 427 "../src/MainWindow.vala"
				break;
#line 1741 "MainWindow.c"
			}
		}
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 431 "../src/MainWindow.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 431 "../src/MainWindow.vala"
	return _data2_;
#line 1754 "MainWindow.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 431 "../src/MainWindow.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1764 "MainWindow.c"
		ScratchMainWindow* self;
#line 431 "../src/MainWindow.vala"
		self = _data2_->self;
#line 431 "../src/MainWindow.vala"
		_g_object_unref0 (_data2_->view_grid);
#line 431 "../src/MainWindow.vala"
		_g_object_unref0 (self);
#line 431 "../src/MainWindow.vala"
		g_slice_free (Block2Data, _data2_);
#line 1774 "MainWindow.c"
	}
}

static void
__lambda145_ (ScratchMainWindow* self,
              GtkWidget* w)
{
#line 440 "../src/MainWindow.vala"
	g_return_if_fail (w != NULL);
#line 441 "../src/MainWindow.vala"
	scratch_main_window_set_search_text (self);
#line 1786 "MainWindow.c"
}

static void
___lambda145__gtk_widget_map (GtkWidget* _sender,
                              gpointer self)
{
#line 440 "../src/MainWindow.vala"
	__lambda145_ ((ScratchMainWindow*) self, _sender);
#line 1795 "MainWindow.c"
}

static void
__lambda146_ (ScratchMainWindow* self)
{
	ScratchWidgetsSearchBar* _tmp0_;
	GtkSearchEntry* _tmp1_;
	ScratchWidgetsSearchBar* _tmp2_;
#line 444 "../src/MainWindow.vala"
	_tmp0_ = self->search_bar;
#line 444 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_->search_entry;
#line 444 "../src/MainWindow.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp1_, "");
#line 445 "../src/MainWindow.vala"
	_tmp2_ = self->search_bar;
#line 445 "../src/MainWindow.vala"
	scratch_widgets_search_bar_highlight_none (_tmp2_);
#line 1814 "MainWindow.c"
}

static void
___lambda146__gtk_widget_unmap (GtkWidget* _sender,
                                gpointer self)
{
#line 443 "../src/MainWindow.vala"
	__lambda146_ ((ScratchMainWindow*) self);
#line 1823 "MainWindow.c"
}

static void
__lambda147_ (ScratchMainWindow* self)
{
	ScratchFolderManagerFileView* _tmp0_;
#line 448 "../src/MainWindow.vala"
	_tmp0_ = self->priv->folder_manager_view;
#line 448 "../src/MainWindow.vala"
	scratch_folder_manager_file_view_clear_badges (_tmp0_);
#line 1834 "MainWindow.c"
}

static void
___lambda147__scratch_widgets_search_bar_search_empty (ScratchWidgetsSearchBar* _sender,
                                                       gpointer self)
{
#line 447 "../src/MainWindow.vala"
	__lambda147_ ((ScratchMainWindow*) self);
#line 1843 "MainWindow.c"
}

static void
__lambda148_ (ScratchMainWindow* self,
              GdkDragContext* ctx,
              gint x,
              gint y,
              GtkSelectionData* sel,
              guint info,
              guint time)
{
	gchar** uris = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint uris_length1;
	gint _uris_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 457 "../src/MainWindow.vala"
	g_return_if_fail (ctx != NULL);
#line 457 "../src/MainWindow.vala"
	g_return_if_fail (sel != NULL);
#line 458 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_ = gtk_selection_data_get_uris (sel);
#line 458 "../src/MainWindow.vala"
	uris = _tmp1_;
#line 458 "../src/MainWindow.vala"
	uris_length1 = _vala_array_length (_tmp0_);
#line 458 "../src/MainWindow.vala"
	_uris_size_ = uris_length1;
#line 459 "../src/MainWindow.vala"
	_tmp2_ = uris;
#line 459 "../src/MainWindow.vala"
	_tmp2__length1 = uris_length1;
#line 459 "../src/MainWindow.vala"
	if (_tmp2__length1 > 0) {
#line 1880 "MainWindow.c"
		{
			gint i = 0;
#line 460 "../src/MainWindow.vala"
			i = 0;
#line 1885 "MainWindow.c"
			{
				gboolean _tmp3_ = FALSE;
#line 460 "../src/MainWindow.vala"
				_tmp3_ = TRUE;
#line 460 "../src/MainWindow.vala"
				while (TRUE) {
#line 1892 "MainWindow.c"
					gchar** _tmp5_;
					gint _tmp5__length1;
					gchar* filename = NULL;
					gchar** _tmp6_;
					gint _tmp6__length1;
					const gchar* _tmp7_;
					gchar* _tmp8_;
					GFile* file = NULL;
					const gchar* _tmp9_;
					GFile* _tmp10_;
					gboolean is_folder = FALSE;
					gboolean _tmp11_ = FALSE;
					GFile* _tmp12_;
					gboolean _tmp13_ = FALSE;
					gboolean _tmp14_;
#line 460 "../src/MainWindow.vala"
					if (!_tmp3_) {
#line 1910 "MainWindow.c"
						gint _tmp4_;
#line 460 "../src/MainWindow.vala"
						_tmp4_ = i;
#line 460 "../src/MainWindow.vala"
						i = _tmp4_ + 1;
#line 1916 "MainWindow.c"
					}
#line 460 "../src/MainWindow.vala"
					_tmp3_ = FALSE;
#line 460 "../src/MainWindow.vala"
					_tmp5_ = uris;
#line 460 "../src/MainWindow.vala"
					_tmp5__length1 = uris_length1;
#line 460 "../src/MainWindow.vala"
					if (!(i < _tmp5__length1)) {
#line 460 "../src/MainWindow.vala"
						break;
#line 1928 "MainWindow.c"
					}
#line 461 "../src/MainWindow.vala"
					_tmp6_ = uris;
#line 461 "../src/MainWindow.vala"
					_tmp6__length1 = uris_length1;
#line 461 "../src/MainWindow.vala"
					_tmp7_ = _tmp6_[i];
#line 461 "../src/MainWindow.vala"
					_tmp8_ = g_strdup (_tmp7_);
#line 461 "../src/MainWindow.vala"
					filename = _tmp8_;
#line 462 "../src/MainWindow.vala"
					_tmp9_ = filename;
#line 462 "../src/MainWindow.vala"
					_tmp10_ = g_file_new_for_uri (_tmp9_);
#line 462 "../src/MainWindow.vala"
					file = _tmp10_;
#line 465 "../src/MainWindow.vala"
					_tmp12_ = file;
#line 465 "../src/MainWindow.vala"
					_tmp14_ = scratch_services_file_handler_can_open_file (_tmp12_, &_tmp13_);
#line 465 "../src/MainWindow.vala"
					is_folder = _tmp13_;
#line 465 "../src/MainWindow.vala"
					if (_tmp14_) {
#line 465 "../src/MainWindow.vala"
						_tmp11_ = !is_folder;
#line 1956 "MainWindow.c"
					} else {
#line 465 "../src/MainWindow.vala"
						_tmp11_ = FALSE;
#line 1960 "MainWindow.c"
					}
#line 465 "../src/MainWindow.vala"
					if (_tmp11_) {
#line 1964 "MainWindow.c"
						ScratchServicesDocument* doc = NULL;
						GSimpleActionGroup* _tmp15_;
						GFile* _tmp16_;
						ScratchServicesDocument* _tmp17_;
						ScratchWidgetsDocumentView* _tmp18_;
						ScratchServicesDocument* _tmp19_;
#line 466 "../src/MainWindow.vala"
						_tmp15_ = self->priv->_actions;
#line 466 "../src/MainWindow.vala"
						_tmp16_ = file;
#line 466 "../src/MainWindow.vala"
						_tmp17_ = scratch_services_document_new (_tmp15_, _tmp16_);
#line 466 "../src/MainWindow.vala"
						g_object_ref_sink (_tmp17_);
#line 466 "../src/MainWindow.vala"
						doc = _tmp17_;
#line 467 "../src/MainWindow.vala"
						_tmp18_ = self->document_view;
#line 467 "../src/MainWindow.vala"
						_tmp19_ = doc;
#line 467 "../src/MainWindow.vala"
						scratch_widgets_document_view_open_document (_tmp18_, _tmp19_, TRUE, 0, &SELECTION_RANGE_EMPTY);
#line 465 "../src/MainWindow.vala"
						_g_object_unref0 (doc);
#line 1989 "MainWindow.c"
					}
#line 460 "../src/MainWindow.vala"
					_g_object_unref0 (file);
#line 460 "../src/MainWindow.vala"
					_g_free0 (filename);
#line 1995 "MainWindow.c"
				}
			}
		}
#line 471 "../src/MainWindow.vala"
		gtk_drag_finish (ctx, TRUE, FALSE, (guint32) time);
#line 2001 "MainWindow.c"
	}
#line 457 "../src/MainWindow.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 2005 "MainWindow.c"
}

static void
___lambda148__gtk_widget_drag_data_received (GtkWidget* _sender,
                                             GdkDragContext* context,
                                             gint x,
                                             gint y,
                                             GtkSelectionData* selection_data,
                                             guint info,
                                             guint time_,
                                             gpointer self)
{
#line 457 "../src/MainWindow.vala"
	__lambda148_ ((ScratchMainWindow*) self, context, x, y, selection_data, info, time_);
#line 2020 "MainWindow.c"
}

static void
__lambda149_ (ScratchMainWindow* self,
              const gchar* a)
{
	ScratchFolderManagerFile* file = NULL;
	ScratchFolderManagerFile* _tmp0_;
	ScratchServicesDocument* doc = NULL;
	GSimpleActionGroup* _tmp1_;
	ScratchFolderManagerFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	ScratchServicesDocument* _tmp5_;
	ScratchFolderManagerFile* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
#line 482 "../src/MainWindow.vala"
	g_return_if_fail (a != NULL);
#line 483 "../src/MainWindow.vala"
	_tmp0_ = scratch_folder_manager_file_new (a);
#line 483 "../src/MainWindow.vala"
	file = _tmp0_;
#line 484 "../src/MainWindow.vala"
	_tmp1_ = self->priv->_actions;
#line 484 "../src/MainWindow.vala"
	_tmp2_ = file;
#line 484 "../src/MainWindow.vala"
	_tmp3_ = scratch_folder_manager_file_get_file (_tmp2_);
#line 484 "../src/MainWindow.vala"
	_tmp4_ = _tmp3_;
#line 484 "../src/MainWindow.vala"
	_tmp5_ = scratch_services_document_new (_tmp1_, _tmp4_);
#line 484 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 484 "../src/MainWindow.vala"
	doc = _tmp5_;
#line 486 "../src/MainWindow.vala"
	_tmp6_ = file;
#line 486 "../src/MainWindow.vala"
	_tmp7_ = scratch_folder_manager_file_get_is_valid_textfile (_tmp6_);
#line 486 "../src/MainWindow.vala"
	_tmp8_ = _tmp7_;
#line 486 "../src/MainWindow.vala"
	if (_tmp8_) {
#line 2066 "MainWindow.c"
		ScratchServicesDocument* _tmp9_;
#line 487 "../src/MainWindow.vala"
		_tmp9_ = doc;
#line 487 "../src/MainWindow.vala"
		scratch_main_window_open_document (self, _tmp9_, TRUE, 0);
#line 2072 "MainWindow.c"
	} else {
		ScratchFolderManagerFile* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
#line 489 "../src/MainWindow.vala"
		_tmp10_ = file;
#line 489 "../src/MainWindow.vala"
		_tmp11_ = scratch_folder_manager_file_get_file (_tmp10_);
#line 489 "../src/MainWindow.vala"
		_tmp12_ = _tmp11_;
#line 489 "../src/MainWindow.vala"
		scratch_main_window_open_binary (self, _tmp12_);
#line 2085 "MainWindow.c"
	}
#line 482 "../src/MainWindow.vala"
	_g_object_unref0 (doc);
#line 482 "../src/MainWindow.vala"
	_g_object_unref0 (file);
#line 2091 "MainWindow.c"
}

static void
___lambda149__scratch_folder_manager_file_view_select (ScratchFolderManagerFileView* _sender,
                                                       const gchar* file,
                                                       gpointer self)
{
#line 482 "../src/MainWindow.vala"
	__lambda149_ ((ScratchMainWindow*) self, file);
#line 2101 "MainWindow.c"
}

static gboolean
__lambda150_ (ScratchMainWindow* self,
              ScratchFolderManagerFile* file)
{
	gboolean allow = FALSE;
	ScratchApplication* _tmp0_;
	GList* _tmp1_;
	gboolean result;
#line 496 "../src/MainWindow.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 497 "../src/MainWindow.vala"
	allow = TRUE;
#line 498 "../src/MainWindow.vala"
	_tmp0_ = self->priv->_app;
#line 498 "../src/MainWindow.vala"
	_tmp1_ = gtk_application_get_windows ((GtkApplication*) _tmp0_);
#line 2120 "MainWindow.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 498 "../src/MainWindow.vala"
		window_collection = _tmp1_;
#line 498 "../src/MainWindow.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 2128 "MainWindow.c"
			GtkWindow* _tmp2_;
			GtkWindow* window = NULL;
#line 498 "../src/MainWindow.vala"
			_tmp2_ = _g_object_ref0 ((GtkWindow*) window_it->data);
#line 498 "../src/MainWindow.vala"
			window = _tmp2_;
#line 2135 "MainWindow.c"
			{
				ScratchMainWindow* win = NULL;
				GtkWindow* _tmp3_;
				ScratchMainWindow* _tmp4_;
				ScratchMainWindow* _tmp5_;
				ScratchWidgetsDocumentView* _tmp6_;
				GList* _tmp7_;
#line 499 "../src/MainWindow.vala"
				_tmp3_ = window;
#line 499 "../src/MainWindow.vala"
				_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, SCRATCH_TYPE_MAIN_WINDOW, ScratchMainWindow));
#line 499 "../src/MainWindow.vala"
				win = _tmp4_;
#line 500 "../src/MainWindow.vala"
				_tmp5_ = win;
#line 500 "../src/MainWindow.vala"
				_tmp6_ = _tmp5_->document_view;
#line 500 "../src/MainWindow.vala"
				_tmp7_ = _tmp6_->docs;
#line 2155 "MainWindow.c"
				{
					GList* doc_collection = NULL;
					GList* doc_it = NULL;
#line 500 "../src/MainWindow.vala"
					doc_collection = _tmp7_;
#line 500 "../src/MainWindow.vala"
					for (doc_it = doc_collection; doc_it != NULL; doc_it = doc_it->next) {
#line 2163 "MainWindow.c"
						ScratchServicesDocument* _tmp8_;
						ScratchServicesDocument* doc = NULL;
#line 500 "../src/MainWindow.vala"
						_tmp8_ = _g_object_ref0 ((ScratchServicesDocument*) doc_it->data);
#line 500 "../src/MainWindow.vala"
						doc = _tmp8_;
#line 2170 "MainWindow.c"
						{
							ScratchServicesDocument* _tmp9_;
							GFile* _tmp10_;
							GFile* _tmp11_;
							GFile* _tmp12_;
							GFile* _tmp13_;
#line 501 "../src/MainWindow.vala"
							_tmp9_ = doc;
#line 501 "../src/MainWindow.vala"
							_tmp10_ = scratch_services_document_get_file (_tmp9_);
#line 501 "../src/MainWindow.vala"
							_tmp11_ = _tmp10_;
#line 501 "../src/MainWindow.vala"
							_tmp12_ = scratch_folder_manager_file_get_file (file);
#line 501 "../src/MainWindow.vala"
							_tmp13_ = _tmp12_;
#line 501 "../src/MainWindow.vala"
							if (g_file_equal (_tmp11_, _tmp13_)) {
#line 2189 "MainWindow.c"
								gboolean _tmp14_ = FALSE;
								gboolean _tmp15_ = FALSE;
#line 504 "../src/MainWindow.vala"
								if (allow) {
#line 2194 "MainWindow.c"
									ScratchServicesDocument* _tmp16_;
									gboolean _tmp17_;
									gboolean _tmp18_;
#line 504 "../src/MainWindow.vala"
									_tmp16_ = doc;
#line 504 "../src/MainWindow.vala"
									_tmp17_ = scratch_services_document_get_locked (_tmp16_);
#line 504 "../src/MainWindow.vala"
									_tmp18_ = _tmp17_;
#line 504 "../src/MainWindow.vala"
									_tmp15_ = !_tmp18_;
#line 2206 "MainWindow.c"
								} else {
#line 504 "../src/MainWindow.vala"
									_tmp15_ = FALSE;
#line 2210 "MainWindow.c"
								}
#line 504 "../src/MainWindow.vala"
								if (_tmp15_) {
#line 2214 "MainWindow.c"
									ScratchServicesDocument* _tmp19_;
#line 504 "../src/MainWindow.vala"
									_tmp19_ = doc;
#line 504 "../src/MainWindow.vala"
									_tmp14_ = _tmp19_->saved;
#line 2220 "MainWindow.c"
								} else {
#line 504 "../src/MainWindow.vala"
									_tmp14_ = FALSE;
#line 2224 "MainWindow.c"
								}
#line 504 "../src/MainWindow.vala"
								allow = _tmp14_;
#line 2228 "MainWindow.c"
							}
#line 500 "../src/MainWindow.vala"
							_g_object_unref0 (doc);
#line 2232 "MainWindow.c"
						}
					}
				}
#line 498 "../src/MainWindow.vala"
				_g_object_unref0 (win);
#line 498 "../src/MainWindow.vala"
				_g_object_unref0 (window);
#line 2240 "MainWindow.c"
			}
		}
	}
#line 509 "../src/MainWindow.vala"
	result = allow;
#line 509 "../src/MainWindow.vala"
	return result;
#line 2248 "MainWindow.c"
}

static gboolean
___lambda150__scratch_folder_manager_file_view_rename_request (ScratchFolderManagerFileView* _sender,
                                                               ScratchFolderManagerFile* file,
                                                               gpointer self)
{
	gboolean result;
	result = __lambda150_ ((ScratchMainWindow*) self, file);
#line 496 "../src/MainWindow.vala"
	return result;
#line 2260 "MainWindow.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 561 "../src/MainWindow.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 561 "../src/MainWindow.vala"
	return _data3_;
#line 2270 "MainWindow.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 561 "../src/MainWindow.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 2280 "MainWindow.c"
		ScratchMainWindow* self;
#line 561 "../src/MainWindow.vala"
		self = _data3_->self;
#line 561 "../src/MainWindow.vala"
		(_data3_->hook_func_target_destroy_notify == NULL) ? NULL : (_data3_->hook_func_target_destroy_notify (_data3_->hook_func_target), NULL);
#line 561 "../src/MainWindow.vala"
		_data3_->hook_func = NULL;
#line 561 "../src/MainWindow.vala"
		_data3_->hook_func_target = NULL;
#line 561 "../src/MainWindow.vala"
		_data3_->hook_func_target_destroy_notify = NULL;
#line 561 "../src/MainWindow.vala"
		_g_object_unref0 (self);
#line 561 "../src/MainWindow.vala"
		g_slice_free (Block3Data, _data3_);
#line 2296 "MainWindow.c"
	}
}

static void
__lambda152_ (ScratchMainWindow* self)
{
	ScratchServicesPluginsManager* _tmp0_;
	ScratchServicesPluginsManager* _tmp1_;
	ScratchHeaderBar* _tmp2_;
	ScratchServicesPluginsManager* _tmp3_;
	ScratchHeaderBar* _tmp4_;
	GMenu* _tmp5_;
#line 567 "../src/MainWindow.vala"
	_tmp0_ = self->priv->plugins;
#line 567 "../src/MainWindow.vala"
	g_signal_emit_by_name (_tmp0_, "hook-window", self);
#line 568 "../src/MainWindow.vala"
	_tmp1_ = self->priv->plugins;
#line 568 "../src/MainWindow.vala"
	_tmp2_ = self->toolbar;
#line 568 "../src/MainWindow.vala"
	g_signal_emit_by_name (_tmp1_, "hook-toolbar", _tmp2_);
#line 569 "../src/MainWindow.vala"
	_tmp3_ = self->priv->plugins;
#line 569 "../src/MainWindow.vala"
	_tmp4_ = self->toolbar;
#line 569 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_->share_menu;
#line 569 "../src/MainWindow.vala"
	g_signal_emit_by_name (_tmp3_, "hook-share-menu", (GMenuModel*) _tmp5_);
#line 2327 "MainWindow.c"
}

static void
___lambda152__scratch_main_window_hook_func (gpointer self)
{
#line 566 "../src/MainWindow.vala"
	__lambda152_ ((ScratchMainWindow*) self);
#line 2335 "MainWindow.c"
}

static void
__lambda153_ (Block3Data* _data3_)
{
	ScratchMainWindow* self;
#line 572 "../src/MainWindow.vala"
	self = _data3_->self;
#line 573 "../src/MainWindow.vala"
	_data3_->hook_func (_data3_->hook_func_target);
#line 2346 "MainWindow.c"
}

static void
___lambda153__scratch_services_plugins_manager_extension_added (ScratchServicesPluginsManager* _sender,
                                                                PeasPluginInfo* info,
                                                                gpointer self)
{
#line 572 "../src/MainWindow.vala"
	__lambda153_ (self);
#line 2356 "MainWindow.c"
}

static void
__lambda151_ (ScratchMainWindow* self)
{
	Block3Data* _data3_;
	GSettings* _tmp0_;
	CodeSidebar* _tmp1_;
	GSettings* _tmp2_;
	ScratchWidgetsDocumentView* _tmp3_;
	GSettings* _tmp4_;
	CodeTerminal* _tmp5_;
	ScratchServicesPluginsManager* _tmp6_;
#line 561 "../src/MainWindow.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 561 "../src/MainWindow.vala"
	_data3_->_ref_count_ = 1;
#line 561 "../src/MainWindow.vala"
	_data3_->self = g_object_ref (self);
#line 562 "../src/MainWindow.vala"
	_tmp0_ = scratch_saved_state;
#line 562 "../src/MainWindow.vala"
	_tmp1_ = self->sidebar;
#line 562 "../src/MainWindow.vala"
	g_settings_bind (_tmp0_, "sidebar-visible", (GObject*) _tmp1_, "visible", G_SETTINGS_BIND_DEFAULT);
#line 563 "../src/MainWindow.vala"
	_tmp2_ = scratch_saved_state;
#line 563 "../src/MainWindow.vala"
	_tmp3_ = self->document_view;
#line 563 "../src/MainWindow.vala"
	g_settings_bind (_tmp2_, "outline-visible", (GObject*) _tmp3_, "outline_visible", G_SETTINGS_BIND_DEFAULT);
#line 564 "../src/MainWindow.vala"
	_tmp4_ = scratch_saved_state;
#line 564 "../src/MainWindow.vala"
	_tmp5_ = self->priv->terminal;
#line 564 "../src/MainWindow.vala"
	g_settings_bind (_tmp4_, "terminal-visible", (GObject*) _tmp5_, "visible", G_SETTINGS_BIND_DEFAULT);
#line 566 "../src/MainWindow.vala"
	_data3_->hook_func = ___lambda152__scratch_main_window_hook_func;
#line 566 "../src/MainWindow.vala"
	_data3_->hook_func_target = g_object_ref (self);
#line 566 "../src/MainWindow.vala"
	_data3_->hook_func_target_destroy_notify = g_object_unref;
#line 572 "../src/MainWindow.vala"
	_tmp6_ = self->priv->plugins;
#line 572 "../src/MainWindow.vala"
	g_signal_connect_data (_tmp6_, "extension-added", (GCallback) ___lambda153__scratch_services_plugins_manager_extension_added, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 576 "../src/MainWindow.vala"
	_data3_->hook_func (_data3_->hook_func_target);
#line 561 "../src/MainWindow.vala"
	block3_data_unref (_data3_);
#line 561 "../src/MainWindow.vala"
	_data3_ = NULL;
#line 2410 "MainWindow.c"
}

static void
___lambda151__gtk_widget_realize (GtkWidget* _sender,
                                  gpointer self)
{
#line 561 "../src/MainWindow.vala"
	__lambda151_ ((ScratchMainWindow*) self);
#line 2419 "MainWindow.c"
}

static void
__lambda154_ (ScratchMainWindow* self)
{
	gboolean _tmp0_;
	ScratchWidgetsDocumentView* _tmp1_;
#line 580 "../src/MainWindow.vala"
	_tmp0_ = self->priv->_restore_docs;
#line 580 "../src/MainWindow.vala"
	if (_tmp0_) {
#line 581 "../src/MainWindow.vala"
		scratch_main_window_restore_opened_documents (self);
#line 2433 "MainWindow.c"
	}
#line 584 "../src/MainWindow.vala"
	_tmp1_ = self->document_view;
#line 584 "../src/MainWindow.vala"
	scratch_widgets_document_view_update_outline_visible (_tmp1_);
#line 585 "../src/MainWindow.vala"
	scratch_main_window_update_find_actions (self);
#line 2441 "MainWindow.c"
}

static void
___lambda154__gtk_widget_realize (GtkWidget* _sender,
                                  gpointer self)
{
#line 579 "../src/MainWindow.vala"
	__lambda154_ ((ScratchMainWindow*) self);
#line 2450 "MainWindow.c"
}

static void
__lambda157_ (ScratchMainWindow* self)
{
	GtkStack* _tmp0_;
	CodeWelcomeView* _tmp1_;
	const gchar* _tmp2_;
	ScratchHeaderBar* _tmp3_;
#line 589 "../src/MainWindow.vala"
	_tmp0_ = self->priv->content_stack;
#line 589 "../src/MainWindow.vala"
	_tmp1_ = self->priv->welcome_view;
#line 589 "../src/MainWindow.vala"
	gtk_stack_set_visible_child (_tmp0_, (GtkWidget*) _tmp1_);
#line 590 "../src/MainWindow.vala"
	_tmp2_ = scratch_main_window_base_title;
#line 590 "../src/MainWindow.vala"
	gtk_window_set_title ((GtkWindow*) self, _tmp2_);
#line 591 "../src/MainWindow.vala"
	_tmp3_ = self->toolbar;
#line 591 "../src/MainWindow.vala"
	scratch_header_bar_document_available (_tmp3_, FALSE);
#line 592 "../src/MainWindow.vala"
	scratch_main_window_set_widgets_sensitive (self, FALSE);
#line 2476 "MainWindow.c"
}

static void
___lambda157__scratch_widgets_document_view_request_placeholder (ScratchWidgetsDocumentView* _sender,
                                                                 gpointer self)
{
#line 588 "../src/MainWindow.vala"
	__lambda157_ ((ScratchMainWindow*) self);
#line 2485 "MainWindow.c"
}

static void
__lambda158_ (Block2Data* _data2_)
{
	ScratchMainWindow* self;
	GtkStack* _tmp0_;
	ScratchHeaderBar* _tmp1_;
#line 595 "../src/MainWindow.vala"
	self = _data2_->self;
#line 596 "../src/MainWindow.vala"
	_tmp0_ = self->priv->content_stack;
#line 596 "../src/MainWindow.vala"
	gtk_stack_set_visible_child (_tmp0_, (GtkWidget*) _data2_->view_grid);
#line 597 "../src/MainWindow.vala"
	_tmp1_ = self->toolbar;
#line 597 "../src/MainWindow.vala"
	scratch_header_bar_document_available (_tmp1_, TRUE);
#line 598 "../src/MainWindow.vala"
	scratch_main_window_set_widgets_sensitive (self, TRUE);
#line 599 "../src/MainWindow.vala"
	scratch_main_window_update_find_actions (self);
#line 2508 "MainWindow.c"
}

static void
___lambda158__scratch_widgets_document_view_tab_added (ScratchWidgetsDocumentView* _sender,
                                                       ScratchServicesDocument* document,
                                                       gpointer self)
{
#line 595 "../src/MainWindow.vala"
	__lambda158_ (self);
#line 2518 "MainWindow.c"
}

static void
__lambda159_ (ScratchMainWindow* self,
              ScratchServicesDocument* doc)
{
	ScratchFolderManagerItem* selected_item = NULL;
	ScratchFolderManagerFileView* _tmp0_;
	CodeWidgetsSourceListItem* _tmp1_;
	CodeWidgetsSourceListItem* _tmp2_;
	ScratchFolderManagerItem* _tmp3_;
	gboolean _tmp4_ = FALSE;
	ScratchFolderManagerItem* _tmp5_;
#line 602 "../src/MainWindow.vala"
	g_return_if_fail (doc != NULL);
#line 603 "../src/MainWindow.vala"
	scratch_main_window_update_find_actions (self);
#line 604 "../src/MainWindow.vala"
	_tmp0_ = self->priv->folder_manager_view;
#line 604 "../src/MainWindow.vala"
	_tmp1_ = code_widgets_source_list_get_selected ((CodeWidgetsSourceList*) _tmp0_);
#line 604 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 604 "../src/MainWindow.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, SCRATCH_FOLDER_MANAGER_TYPE_ITEM, ScratchFolderManagerItem));
#line 604 "../src/MainWindow.vala"
	selected_item = _tmp3_;
#line 605 "../src/MainWindow.vala"
	_tmp5_ = selected_item;
#line 605 "../src/MainWindow.vala"
	if (_tmp5_ != NULL) {
#line 2550 "MainWindow.c"
		ScratchFolderManagerItem* _tmp6_;
		ScratchFolderManagerFile* _tmp7_;
		ScratchFolderManagerFile* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
#line 605 "../src/MainWindow.vala"
		_tmp6_ = selected_item;
#line 605 "../src/MainWindow.vala"
		_tmp7_ = scratch_folder_manager_item_get_file (_tmp6_);
#line 605 "../src/MainWindow.vala"
		_tmp8_ = _tmp7_;
#line 605 "../src/MainWindow.vala"
		_tmp9_ = scratch_folder_manager_file_get_file (_tmp8_);
#line 605 "../src/MainWindow.vala"
		_tmp10_ = _tmp9_;
#line 605 "../src/MainWindow.vala"
		_tmp11_ = scratch_services_document_get_file (doc);
#line 605 "../src/MainWindow.vala"
		_tmp12_ = _tmp11_;
#line 605 "../src/MainWindow.vala"
		_tmp4_ = g_file_equal (_tmp10_, _tmp12_);
#line 2574 "MainWindow.c"
	} else {
#line 605 "../src/MainWindow.vala"
		_tmp4_ = FALSE;
#line 2578 "MainWindow.c"
	}
#line 605 "../src/MainWindow.vala"
	if (_tmp4_) {
#line 2582 "MainWindow.c"
		ScratchFolderManagerFileView* _tmp13_;
#line 607 "../src/MainWindow.vala"
		_tmp13_ = self->priv->folder_manager_view;
#line 607 "../src/MainWindow.vala"
		code_widgets_source_list_set_selected ((CodeWidgetsSourceList*) _tmp13_, NULL);
#line 2588 "MainWindow.c"
	}
#line 602 "../src/MainWindow.vala"
	_g_object_unref0 (selected_item);
#line 2592 "MainWindow.c"
}

static void
___lambda159__scratch_widgets_document_view_tab_removed (ScratchWidgetsDocumentView* _sender,
                                                         ScratchServicesDocument* document,
                                                         gpointer self)
{
#line 602 "../src/MainWindow.vala"
	__lambda159_ ((ScratchMainWindow*) self, document);
#line 2602 "MainWindow.c"
}

static void
__lambda160_ (ScratchMainWindow* self,
              ScratchServicesDocument* doc)
{
#line 612 "../src/MainWindow.vala"
	if (doc != NULL) {
#line 2611 "MainWindow.c"
		ScratchWidgetsSearchBar* _tmp0_;
		ScratchWidgetsSourceView* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		ScratchHeaderBar* _tmp7_;
		ScratchServicesGitManager* _tmp8_;
		ScratchWidgetsSourceView* _tmp9_;
		ScratchFolderManagerProjectFolderItem* _tmp10_;
		ScratchFolderManagerProjectFolderItem* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		ScratchFolderManagerFileView* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		ScratchServicesPluginsManager* _tmp20_;
		GSimpleActionGroup* _tmp21_;
		GSimpleAction* _tmp22_;
		GSimpleAction* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
#line 613 "../src/MainWindow.vala"
		_tmp0_ = self->search_bar;
#line 613 "../src/MainWindow.vala"
		_tmp1_ = doc->source_view;
#line 613 "../src/MainWindow.vala"
		scratch_widgets_search_bar_set_text_view (_tmp0_, _tmp1_);
#line 616 "../src/MainWindow.vala"
		_tmp2_ = scratch_services_document_get_basename (doc);
#line 616 "../src/MainWindow.vala"
		_tmp3_ = _tmp2_;
#line 616 "../src/MainWindow.vala"
		_tmp4_ = scratch_main_window_base_title;
#line 616 "../src/MainWindow.vala"
		_tmp5_ = g_strdup_printf (_ ("%s - %s"), _tmp3_, _tmp4_);
#line 616 "../src/MainWindow.vala"
		_tmp6_ = _tmp5_;
#line 616 "../src/MainWindow.vala"
		gtk_window_set_title ((GtkWindow*) self, _tmp6_);
#line 616 "../src/MainWindow.vala"
		_g_free0 (_tmp6_);
#line 616 "../src/MainWindow.vala"
		_g_free0 (_tmp3_);
#line 618 "../src/MainWindow.vala"
		_tmp7_ = self->toolbar;
#line 618 "../src/MainWindow.vala"
		scratch_header_bar_set_document_focus (_tmp7_, doc);
#line 619 "../src/MainWindow.vala"
		_tmp8_ = self->priv->git_manager;
#line 619 "../src/MainWindow.vala"
		_tmp9_ = doc->source_view;
#line 619 "../src/MainWindow.vala"
		_tmp10_ = scratch_widgets_source_view_get_project (_tmp9_);
#line 619 "../src/MainWindow.vala"
		_tmp11_ = _tmp10_;
#line 619 "../src/MainWindow.vala"
		_tmp12_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp11_);
#line 619 "../src/MainWindow.vala"
		_tmp13_ = _tmp12_;
#line 619 "../src/MainWindow.vala"
		_tmp14_ = _tmp13_;
#line 619 "../src/MainWindow.vala"
		scratch_services_git_manager_set_active_project_path (_tmp8_, _tmp14_);
#line 619 "../src/MainWindow.vala"
		_g_free0 (_tmp14_);
#line 620 "../src/MainWindow.vala"
		_tmp15_ = self->priv->folder_manager_view;
#line 620 "../src/MainWindow.vala"
		_tmp16_ = scratch_services_document_get_file (doc);
#line 620 "../src/MainWindow.vala"
		_tmp17_ = _tmp16_;
#line 620 "../src/MainWindow.vala"
		_tmp18_ = g_file_get_path (_tmp17_);
#line 620 "../src/MainWindow.vala"
		_tmp19_ = _tmp18_;
#line 620 "../src/MainWindow.vala"
		scratch_folder_manager_file_view_select_path (_tmp15_, _tmp19_);
#line 620 "../src/MainWindow.vala"
		_g_free0 (_tmp19_);
#line 623 "../src/MainWindow.vala"
		_tmp20_ = self->priv->plugins;
#line 623 "../src/MainWindow.vala"
		g_signal_emit_by_name (_tmp20_, "hook-document", doc);
#line 626 "../src/MainWindow.vala"
		_tmp21_ = self->priv->_actions;
#line 626 "../src/MainWindow.vala"
		_tmp22_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_SAVE_AS, _tmp21_);
#line 626 "../src/MainWindow.vala"
		_tmp23_ = _tmp22_;
#line 626 "../src/MainWindow.vala"
		_tmp24_ = scratch_services_document_get_file (doc);
#line 626 "../src/MainWindow.vala"
		_tmp25_ = _tmp24_;
#line 626 "../src/MainWindow.vala"
		g_simple_action_set_enabled (_tmp23_, _tmp25_ != NULL);
#line 626 "../src/MainWindow.vala"
		_g_object_unref0 (_tmp23_);
#line 627 "../src/MainWindow.vala"
		scratch_services_document_check_undoable_actions (doc);
#line 2716 "MainWindow.c"
	} else {
		const gchar* _tmp26_;
		GSimpleActionGroup* _tmp27_;
		GSimpleAction* _tmp28_;
		GSimpleAction* _tmp29_;
#line 629 "../src/MainWindow.vala"
		_tmp26_ = scratch_main_window_base_title;
#line 629 "../src/MainWindow.vala"
		gtk_window_set_title ((GtkWindow*) self, _tmp26_);
#line 630 "../src/MainWindow.vala"
		_tmp27_ = self->priv->_actions;
#line 630 "../src/MainWindow.vala"
		_tmp28_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_SAVE_AS, _tmp27_);
#line 630 "../src/MainWindow.vala"
		_tmp29_ = _tmp28_;
#line 630 "../src/MainWindow.vala"
		g_simple_action_set_enabled (_tmp29_, FALSE);
#line 630 "../src/MainWindow.vala"
		_g_object_unref0 (_tmp29_);
#line 2736 "MainWindow.c"
	}
}

static void
___lambda160__scratch_widgets_document_view_document_change (ScratchWidgetsDocumentView* _sender,
                                                             ScratchServicesDocument* document,
                                                             ScratchWidgetsDocumentView* parent,
                                                             gpointer self)
{
#line 611 "../src/MainWindow.vala"
	__lambda160_ ((ScratchMainWindow*) self, document);
#line 2748 "MainWindow.c"
}

static void
__lambda161_ (ScratchMainWindow* self)
{
	ScratchFolderManagerFileView* _tmp0_;
	CodeTerminal* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 635 "../src/MainWindow.vala"
	_tmp0_ = self->priv->folder_manager_view;
#line 635 "../src/MainWindow.vala"
	scratch_folder_manager_file_view_collapse_other_projects (_tmp0_, NULL);
#line 636 "../src/MainWindow.vala"
	_tmp1_ = self->priv->terminal;
#line 636 "../src/MainWindow.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 636 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 636 "../src/MainWindow.vala"
	if (_tmp3_) {
#line 2770 "MainWindow.c"
		GSimpleAction* open_in_terminal_action = NULL;
		GSimpleActionGroup* _tmp4_;
		GSimpleAction* _tmp5_;
		GVariant* param = NULL;
		ScratchServicesGitManager* _tmp6_;
		ScratchServicesGitManager* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GVariant* _tmp10_;
		GVariant* _tmp11_;
		GSimpleAction* _tmp12_;
		GVariant* _tmp13_;
#line 637 "../src/MainWindow.vala"
		_tmp4_ = self->priv->_actions;
#line 637 "../src/MainWindow.vala"
		_tmp5_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_OPEN_IN_TERMINAL, _tmp4_);
#line 637 "../src/MainWindow.vala"
		open_in_terminal_action = _tmp5_;
#line 638 "../src/MainWindow.vala"
		_tmp6_ = scratch_services_git_manager_get_instance ();
#line 638 "../src/MainWindow.vala"
		_tmp7_ = _tmp6_;
#line 638 "../src/MainWindow.vala"
		_tmp8_ = scratch_services_git_manager_get_default_build_dir (_tmp7_, NULL);
#line 638 "../src/MainWindow.vala"
		_tmp9_ = _tmp8_;
#line 638 "../src/MainWindow.vala"
		_tmp10_ = g_variant_new_string (_tmp9_);
#line 638 "../src/MainWindow.vala"
		g_variant_ref_sink (_tmp10_);
#line 638 "../src/MainWindow.vala"
		_tmp11_ = _tmp10_;
#line 638 "../src/MainWindow.vala"
		_g_free0 (_tmp9_);
#line 638 "../src/MainWindow.vala"
		_g_object_unref0 (_tmp7_);
#line 638 "../src/MainWindow.vala"
		param = _tmp11_;
#line 639 "../src/MainWindow.vala"
		_tmp12_ = open_in_terminal_action;
#line 639 "../src/MainWindow.vala"
		_tmp13_ = param;
#line 639 "../src/MainWindow.vala"
		g_signal_emit_by_name (_tmp12_, "activate", _tmp13_);
#line 636 "../src/MainWindow.vala"
		_g_variant_unref0 (param);
#line 636 "../src/MainWindow.vala"
		_g_object_unref0 (open_in_terminal_action);
#line 2819 "MainWindow.c"
	}
}

static void
___lambda161__code_choose_project_button_project_chosen (CodeChooseProjectButton* _sender,
                                                         gpointer self)
{
#line 634 "../src/MainWindow.vala"
	__lambda161_ ((ScratchMainWindow*) self);
#line 2829 "MainWindow.c"
}

static void
scratch_main_window_init_layout (ScratchMainWindow* self)
{
	Block2Data* _data2_;
	ScratchHeaderBar* _tmp0_;
	ScratchHeaderBar* _tmp1_;
	const gchar* _tmp2_;
	ScratchWidgetsSearchBar* _tmp3_;
	GtkRevealer* _tmp4_;
	GtkRevealer* _tmp5_;
	ScratchWidgetsSearchBar* _tmp6_;
	ScratchWidgetsSearchBar* _tmp7_;
	ScratchWidgetsSearchBar* _tmp8_;
	GtkSearchEntry* _tmp9_;
	ScratchWidgetsSearchBar* _tmp10_;
	CodeWelcomeView* _tmp11_;
	ScratchWidgetsDocumentView* _tmp12_;
	GtkTargetEntry target = {0};
	GtkTargetEntry _tmp13_ = {0};
	CodeWelcomeView* _tmp14_;
	GtkTargetEntry _tmp15_;
	GtkTargetEntry* _tmp16_;
	GtkTargetEntry* _tmp17_;
	gint _tmp17__length1;
	CodeWelcomeView* _tmp18_;
	CodeSidebar* _tmp19_;
	ScratchServicesPluginsManager* _tmp20_;
	ScratchFolderManagerFileView* _tmp21_;
	CodeSidebar* _tmp22_;
	ScratchFolderManagerFileView* _tmp23_;
	ScratchFolderManagerFileView* _tmp24_;
	ScratchFolderManagerFileView* _tmp25_;
	ScratchFolderManagerFileView* _tmp26_;
	ScratchFolderManagerFileView* _tmp27_;
	CodeTerminal* _tmp28_ = NULL;
	GtkGrid* _tmp29_ = NULL;
	GtkRevealer* _tmp30_;
	ScratchWidgetsDocumentView* _tmp31_;
	GtkStack* _tmp32_ = NULL;
	GtkStack* _tmp33_;
	GtkStack* _tmp34_;
	CodeWelcomeView* _tmp35_;
	GtkStack* _tmp36_;
	gint width = 0;
	gint height = 0;
	gint _tmp37_ = 0;
	gint _tmp38_ = 0;
	GtkPaned* _tmp39_;
	GtkPaned* _tmp40_;
	GtkPaned* _tmp41_;
	GtkStack* _tmp42_;
	GtkPaned* _tmp43_;
	CodeTerminal* _tmp44_;
	GtkBox* box = NULL;
	GtkBox* _tmp45_;
	ScratchHeaderBar* _tmp46_;
	GtkPaned* _tmp47_;
	GtkPaned* _tmp48_;
	GtkPaned* _tmp49_;
	CodeSidebar* _tmp50_;
	GtkPaned* _tmp51_;
	GtkPaned* _tmp52_;
	HdyHeaderGroup* header_group = NULL;
	HdyHeaderGroup* _tmp53_;
	CodeSidebar* _tmp54_;
	HdyHeaderBar* _tmp55_;
	HdyHeaderBar* _tmp56_;
	ScratchHeaderBar* _tmp57_;
	GtkSizeGroup* size_group = NULL;
	GtkSizeGroup* _tmp58_;
	CodeSidebar* _tmp59_;
	HdyHeaderBar* _tmp60_;
	HdyHeaderBar* _tmp61_;
	ScratchHeaderBar* _tmp62_;
	GtkRevealer* _tmp63_;
	ScratchWidgetsDocumentView* _tmp64_;
	ScratchWidgetsDocumentView* _tmp65_;
	ScratchWidgetsDocumentView* _tmp66_;
	ScratchWidgetsDocumentView* _tmp67_;
	ScratchWidgetsDocumentView* _tmp68_;
	CodeSidebar* _tmp69_;
	CodeChooseProjectButton* _tmp70_;
	CodeChooseProjectButton* _tmp71_;
#line 431 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 431 "../src/MainWindow.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 431 "../src/MainWindow.vala"
	_data2_->_ref_count_ = 1;
#line 431 "../src/MainWindow.vala"
	_data2_->self = g_object_ref (self);
#line 432 "../src/MainWindow.vala"
	_tmp0_ = scratch_header_bar_new ();
#line 432 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 432 "../src/MainWindow.vala"
	_g_object_unref0 (self->toolbar);
#line 432 "../src/MainWindow.vala"
	self->toolbar = _tmp0_;
#line 433 "../src/MainWindow.vala"
	_tmp1_ = self->toolbar;
#line 433 "../src/MainWindow.vala"
	_tmp2_ = scratch_main_window_base_title;
#line 433 "../src/MainWindow.vala"
	hdy_header_bar_set_title ((HdyHeaderBar*) _tmp1_, _tmp2_);
#line 436 "../src/MainWindow.vala"
	_tmp3_ = scratch_widgets_search_bar_new (self);
#line 436 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 436 "../src/MainWindow.vala"
	_g_object_unref0 (self->search_bar);
#line 436 "../src/MainWindow.vala"
	self->search_bar = _tmp3_;
#line 437 "../src/MainWindow.vala"
	_tmp4_ = (GtkRevealer*) gtk_revealer_new ();
#line 437 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 437 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->search_revealer);
#line 437 "../src/MainWindow.vala"
	self->priv->search_revealer = _tmp4_;
#line 438 "../src/MainWindow.vala"
	_tmp5_ = self->priv->search_revealer;
#line 438 "../src/MainWindow.vala"
	_tmp6_ = self->search_bar;
#line 438 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 440 "../src/MainWindow.vala"
	_tmp7_ = self->search_bar;
#line 440 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp7_, "map", (GCallback) ___lambda145__gtk_widget_map, self, G_CONNECT_AFTER);
#line 443 "../src/MainWindow.vala"
	_tmp8_ = self->search_bar;
#line 443 "../src/MainWindow.vala"
	_tmp9_ = _tmp8_->search_entry;
#line 443 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp9_, "unmap", (GCallback) ___lambda146__gtk_widget_unmap, self, G_CONNECT_AFTER);
#line 447 "../src/MainWindow.vala"
	_tmp10_ = self->search_bar;
#line 447 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp10_, "search-empty", (GCallback) ___lambda147__scratch_widgets_search_bar_search_empty, self, 0);
#line 451 "../src/MainWindow.vala"
	_tmp11_ = code_welcome_view_new (self);
#line 451 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp11_);
#line 451 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->welcome_view);
#line 451 "../src/MainWindow.vala"
	self->priv->welcome_view = _tmp11_;
#line 452 "../src/MainWindow.vala"
	_tmp12_ = scratch_widgets_document_view_new (self);
#line 452 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp12_);
#line 452 "../src/MainWindow.vala"
	_g_object_unref0 (self->document_view);
#line 452 "../src/MainWindow.vala"
	self->document_view = _tmp12_;
#line 454 "../src/MainWindow.vala"
	_tmp13_.target = "text/uri-list";
#line 454 "../src/MainWindow.vala"
	_tmp13_.flags = (guint) 0;
#line 454 "../src/MainWindow.vala"
	_tmp13_.info = (guint) 0;
#line 454 "../src/MainWindow.vala"
	target = _tmp13_;
#line 455 "../src/MainWindow.vala"
	_tmp14_ = self->priv->welcome_view;
#line 455 "../src/MainWindow.vala"
	_tmp15_ = target;
#line 455 "../src/MainWindow.vala"
	_tmp16_ = g_new0 (GtkTargetEntry, 1);
#line 455 "../src/MainWindow.vala"
	_tmp16_[0] = _tmp15_;
#line 455 "../src/MainWindow.vala"
	_tmp17_ = _tmp16_;
#line 455 "../src/MainWindow.vala"
	_tmp17__length1 = 1;
#line 455 "../src/MainWindow.vala"
	gtk_drag_dest_set ((GtkWidget*) _tmp14_, GTK_DEST_DEFAULT_ALL, _tmp17_, (gint) 1, GDK_ACTION_COPY);
#line 455 "../src/MainWindow.vala"
	_tmp17_ = (g_free (_tmp17_), NULL);
#line 457 "../src/MainWindow.vala"
	_tmp18_ = self->priv->welcome_view;
#line 457 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp18_, "drag-data-received", (GCallback) ___lambda148__gtk_widget_drag_data_received, self, 0);
#line 475 "../src/MainWindow.vala"
	_tmp19_ = code_sidebar_new ();
#line 475 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp19_);
#line 475 "../src/MainWindow.vala"
	_g_object_unref0 (self->sidebar);
#line 475 "../src/MainWindow.vala"
	self->sidebar = _tmp19_;
#line 477 "../src/MainWindow.vala"
	_tmp20_ = self->priv->plugins;
#line 477 "../src/MainWindow.vala"
	_tmp21_ = scratch_folder_manager_file_view_new (_tmp20_);
#line 477 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp21_);
#line 477 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->folder_manager_view);
#line 477 "../src/MainWindow.vala"
	self->priv->folder_manager_view = _tmp21_;
#line 479 "../src/MainWindow.vala"
	_tmp22_ = self->sidebar;
#line 479 "../src/MainWindow.vala"
	_tmp23_ = self->priv->folder_manager_view;
#line 479 "../src/MainWindow.vala"
	code_sidebar_add_tab (_tmp22_, (CodePaneSwitcher*) _tmp23_);
#line 480 "../src/MainWindow.vala"
	_tmp24_ = self->priv->folder_manager_view;
#line 480 "../src/MainWindow.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp24_);
#line 482 "../src/MainWindow.vala"
	_tmp25_ = self->priv->folder_manager_view;
#line 482 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp25_, "select", (GCallback) ___lambda149__scratch_folder_manager_file_view_select, self, 0);
#line 494 "../src/MainWindow.vala"
	_tmp26_ = self->priv->folder_manager_view;
#line 494 "../src/MainWindow.vala"
	scratch_folder_manager_file_view_restore_saved_state (_tmp26_);
#line 496 "../src/MainWindow.vala"
	_tmp27_ = self->priv->folder_manager_view;
#line 496 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp27_, "rename-request", (GCallback) ___lambda150__scratch_folder_manager_file_view_rename_request, self, 0);
#line 512 "../src/MainWindow.vala"
	_tmp28_ = code_terminal_new ();
#line 512 "../src/MainWindow.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp28_, TRUE);
#line 512 "../src/MainWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp28_, FALSE);
#line 512 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp28_);
#line 512 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->terminal);
#line 512 "../src/MainWindow.vala"
	self->priv->terminal = _tmp28_;
#line 517 "../src/MainWindow.vala"
	_tmp29_ = (GtkGrid*) gtk_grid_new ();
#line 517 "../src/MainWindow.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp29_, GTK_ORIENTATION_VERTICAL);
#line 517 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp29_);
#line 517 "../src/MainWindow.vala"
	_data2_->view_grid = _tmp29_;
#line 520 "../src/MainWindow.vala"
	_tmp30_ = self->priv->search_revealer;
#line 520 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _data2_->view_grid, (GtkWidget*) _tmp30_);
#line 521 "../src/MainWindow.vala"
	_tmp31_ = self->document_view;
#line 521 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _data2_->view_grid, (GtkWidget*) _tmp31_);
#line 523 "../src/MainWindow.vala"
	_tmp32_ = (GtkStack*) gtk_stack_new ();
#line 523 "../src/MainWindow.vala"
	g_object_set ((GtkWidget*) _tmp32_, "expand", TRUE, NULL);
#line 523 "../src/MainWindow.vala"
	g_object_set ((GtkWidget*) _tmp32_, "width-request", 200, NULL);
#line 523 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp32_);
#line 523 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->content_stack);
#line 523 "../src/MainWindow.vala"
	self->priv->content_stack = _tmp32_;
#line 528 "../src/MainWindow.vala"
	_tmp33_ = self->priv->content_stack;
#line 528 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _data2_->view_grid);
#line 529 "../src/MainWindow.vala"
	_tmp34_ = self->priv->content_stack;
#line 529 "../src/MainWindow.vala"
	_tmp35_ = self->priv->welcome_view;
#line 529 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
#line 530 "../src/MainWindow.vala"
	_tmp36_ = self->priv->content_stack;
#line 530 "../src/MainWindow.vala"
	gtk_stack_set_visible_child (_tmp36_, (GtkWidget*) _data2_->view_grid);
#line 534 "../src/MainWindow.vala"
	gtk_window_get_size ((GtkWindow*) self, &_tmp37_, &_tmp38_);
#line 534 "../src/MainWindow.vala"
	width = _tmp37_;
#line 534 "../src/MainWindow.vala"
	height = _tmp38_;
#line 536 "../src/MainWindow.vala"
	_tmp39_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_VERTICAL);
#line 536 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp39_);
#line 536 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->vp);
#line 536 "../src/MainWindow.vala"
	self->priv->vp = _tmp39_;
#line 537 "../src/MainWindow.vala"
	_tmp40_ = self->priv->vp;
#line 537 "../src/MainWindow.vala"
	gtk_paned_set_position (_tmp40_, height - 150);
#line 538 "../src/MainWindow.vala"
	_tmp41_ = self->priv->vp;
#line 538 "../src/MainWindow.vala"
	_tmp42_ = self->priv->content_stack;
#line 538 "../src/MainWindow.vala"
	gtk_paned_pack1 (_tmp41_, (GtkWidget*) _tmp42_, TRUE, FALSE);
#line 539 "../src/MainWindow.vala"
	_tmp43_ = self->priv->vp;
#line 539 "../src/MainWindow.vala"
	_tmp44_ = self->priv->terminal;
#line 539 "../src/MainWindow.vala"
	gtk_paned_pack2 (_tmp43_, (GtkWidget*) _tmp44_, FALSE, FALSE);
#line 541 "../src/MainWindow.vala"
	_tmp45_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 541 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp45_);
#line 541 "../src/MainWindow.vala"
	box = _tmp45_;
#line 542 "../src/MainWindow.vala"
	_tmp46_ = self->toolbar;
#line 542 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) _tmp46_);
#line 543 "../src/MainWindow.vala"
	_tmp47_ = self->priv->vp;
#line 543 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) _tmp47_);
#line 545 "../src/MainWindow.vala"
	_tmp48_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
#line 545 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp48_);
#line 545 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->hp1);
#line 545 "../src/MainWindow.vala"
	self->priv->hp1 = _tmp48_;
#line 546 "../src/MainWindow.vala"
	_tmp49_ = self->priv->hp1;
#line 546 "../src/MainWindow.vala"
	_tmp50_ = self->sidebar;
#line 546 "../src/MainWindow.vala"
	gtk_paned_pack1 (_tmp49_, (GtkWidget*) _tmp50_, FALSE, FALSE);
#line 547 "../src/MainWindow.vala"
	_tmp51_ = self->priv->hp1;
#line 547 "../src/MainWindow.vala"
	gtk_paned_pack2 (_tmp51_, (GtkWidget*) box, TRUE, FALSE);
#line 549 "../src/MainWindow.vala"
	_tmp52_ = self->priv->hp1;
#line 549 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp52_);
#line 551 "../src/MainWindow.vala"
	_tmp53_ = hdy_header_group_new ();
#line 551 "../src/MainWindow.vala"
	header_group = _tmp53_;
#line 552 "../src/MainWindow.vala"
	_tmp54_ = self->sidebar;
#line 552 "../src/MainWindow.vala"
	_tmp55_ = code_sidebar_get_headerbar (_tmp54_);
#line 552 "../src/MainWindow.vala"
	_tmp56_ = _tmp55_;
#line 552 "../src/MainWindow.vala"
	hdy_header_group_add_header_bar (header_group, _tmp56_);
#line 553 "../src/MainWindow.vala"
	_tmp57_ = self->toolbar;
#line 553 "../src/MainWindow.vala"
	hdy_header_group_add_header_bar (header_group, (HdyHeaderBar*) _tmp57_);
#line 555 "../src/MainWindow.vala"
	_tmp58_ = gtk_size_group_new (GTK_SIZE_GROUP_VERTICAL);
#line 555 "../src/MainWindow.vala"
	size_group = _tmp58_;
#line 556 "../src/MainWindow.vala"
	_tmp59_ = self->sidebar;
#line 556 "../src/MainWindow.vala"
	_tmp60_ = code_sidebar_get_headerbar (_tmp59_);
#line 556 "../src/MainWindow.vala"
	_tmp61_ = _tmp60_;
#line 556 "../src/MainWindow.vala"
	gtk_size_group_add_widget (size_group, (GtkWidget*) _tmp61_);
#line 557 "../src/MainWindow.vala"
	_tmp62_ = self->toolbar;
#line 557 "../src/MainWindow.vala"
	gtk_size_group_add_widget (size_group, (GtkWidget*) _tmp62_);
#line 559 "../src/MainWindow.vala"
	_tmp63_ = self->priv->search_revealer;
#line 559 "../src/MainWindow.vala"
	gtk_revealer_set_reveal_child (_tmp63_, FALSE);
#line 561 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) ___lambda151__gtk_widget_realize, self, 0);
#line 579 "../src/MainWindow.vala"
	_tmp64_ = self->document_view;
#line 579 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp64_, "realize", (GCallback) ___lambda154__gtk_widget_realize, self, 0);
#line 588 "../src/MainWindow.vala"
	_tmp65_ = self->document_view;
#line 588 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp65_, "request-placeholder", (GCallback) ___lambda157__scratch_widgets_document_view_request_placeholder, self, 0);
#line 595 "../src/MainWindow.vala"
	_tmp66_ = self->document_view;
#line 595 "../src/MainWindow.vala"
	g_signal_connect_data (_tmp66_, "tab-added", (GCallback) ___lambda158__scratch_widgets_document_view_tab_added, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 602 "../src/MainWindow.vala"
	_tmp67_ = self->document_view;
#line 602 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp67_, "tab-removed", (GCallback) ___lambda159__scratch_widgets_document_view_tab_removed, self, 0);
#line 611 "../src/MainWindow.vala"
	_tmp68_ = self->document_view;
#line 611 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp68_, "document-change", (GCallback) ___lambda160__scratch_widgets_document_view_document_change, self, 0);
#line 634 "../src/MainWindow.vala"
	_tmp69_ = self->sidebar;
#line 634 "../src/MainWindow.vala"
	_tmp70_ = code_sidebar_get_choose_project_button (_tmp69_);
#line 634 "../src/MainWindow.vala"
	_tmp71_ = _tmp70_;
#line 634 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp71_, "project-chosen", (GCallback) ___lambda161__code_choose_project_button_project_chosen, self, 0);
#line 643 "../src/MainWindow.vala"
	scratch_main_window_set_widgets_sensitive (self, FALSE);
#line 431 "../src/MainWindow.vala"
	_g_object_unref0 (size_group);
#line 431 "../src/MainWindow.vala"
	_g_object_unref0 (header_group);
#line 431 "../src/MainWindow.vala"
	_g_object_unref0 (box);
#line 431 "../src/MainWindow.vala"
	block2_data_unref (_data2_);
#line 431 "../src/MainWindow.vala"
	_data2_ = NULL;
#line 3255 "MainWindow.c"
}

static void
scratch_main_window_open_binary (ScratchMainWindow* self,
                                 GFile* file)
{
	GError* _inner_error0_ = NULL;
#line 646 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 646 "../src/MainWindow.vala"
	g_return_if_fail (file != NULL);
#line 647 "../src/MainWindow.vala"
	if (!g_file_query_exists (file, NULL)) {
#line 648 "../src/MainWindow.vala"
		return;
#line 3271 "MainWindow.c"
	}
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 652 "../src/MainWindow.vala"
		_tmp0_ = g_file_get_uri (file);
#line 652 "../src/MainWindow.vala"
		_tmp1_ = _tmp0_;
#line 652 "../src/MainWindow.vala"
		g_app_info_launch_default_for_uri (_tmp1_, NULL, &_inner_error0_);
#line 652 "../src/MainWindow.vala"
		_g_free0 (_tmp1_);
#line 652 "../src/MainWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3286 "MainWindow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 651 "../src/MainWindow.vala"
		e = _inner_error0_;
#line 651 "../src/MainWindow.vala"
		_inner_error0_ = NULL;
#line 654 "../src/MainWindow.vala"
		_tmp2_ = e;
#line 654 "../src/MainWindow.vala"
		_tmp3_ = _tmp2_->message;
#line 654 "../src/MainWindow.vala"
		g_critical ("MainWindow.vala:654: %s", _tmp3_);
#line 651 "../src/MainWindow.vala"
		_g_error_free0 (e);
#line 3308 "MainWindow.c"
	}
	__finally0:
#line 651 "../src/MainWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 651 "../src/MainWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 651 "../src/MainWindow.vala"
		g_clear_error (&_inner_error0_);
#line 651 "../src/MainWindow.vala"
		return;
#line 3319 "MainWindow.c"
	}
}

static gboolean
__lambda155_ (ScratchMainWindow* self)
{
	ScratchWidgetsDocumentView* _tmp0_;
	gboolean result;
#line 699 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 699 "../src/MainWindow.vala"
	scratch_widgets_document_view_request_placeholder_if_empty (_tmp0_);
#line 700 "../src/MainWindow.vala"
	scratch_main_window_set_restore_override (self, NULL);
#line 701 "../src/MainWindow.vala"
	result = G_SOURCE_REMOVE;
#line 701 "../src/MainWindow.vala"
	return result;
#line 3338 "MainWindow.c"
}

static gboolean
___lambda155__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda155_ ((ScratchMainWindow*) self);
#line 698 "../src/MainWindow.vala"
	return result;
#line 3348 "MainWindow.c"
}

static void
scratch_main_window_restore_opened_documents (ScratchMainWindow* self)
{
	GSettings* _tmp0_;
#line 658 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 659 "../src/MainWindow.vala"
	_tmp0_ = scratch_privacy_settings;
#line 659 "../src/MainWindow.vala"
	if (g_settings_get_boolean (_tmp0_, "remember-recent-files")) {
#line 3361 "MainWindow.c"
		GVariant* doc_infos = NULL;
		GSettings* _tmp1_;
		GVariant* _tmp2_;
		GVariantIter* doc_info_iter = NULL;
		GVariant* _tmp3_;
		GVariantIter* _tmp4_;
		gchar* focused_document = NULL;
		GSettings* _tmp5_;
		gchar* _tmp6_;
		gchar* uri = NULL;
		gint pos = 0;
		gboolean was_restore_overriden = FALSE;
#line 660 "../src/MainWindow.vala"
		_tmp1_ = scratch_settings;
#line 660 "../src/MainWindow.vala"
		_tmp2_ = g_settings_get_value (_tmp1_, "opened-files");
#line 660 "../src/MainWindow.vala"
		doc_infos = _tmp2_;
#line 661 "../src/MainWindow.vala"
		_tmp3_ = doc_infos;
#line 661 "../src/MainWindow.vala"
		_tmp4_ = g_variant_iter_new (_tmp3_);
#line 661 "../src/MainWindow.vala"
		doc_info_iter = _tmp4_;
#line 662 "../src/MainWindow.vala"
		_tmp5_ = scratch_settings;
#line 662 "../src/MainWindow.vala"
		_tmp6_ = g_settings_get_string (_tmp5_, "focused-document");
#line 662 "../src/MainWindow.vala"
		focused_document = _tmp6_;
#line 665 "../src/MainWindow.vala"
		was_restore_overriden = FALSE;
#line 666 "../src/MainWindow.vala"
		while (TRUE) {
#line 3396 "MainWindow.c"
			GVariantIter* _tmp7_;
			gchar* _tmp8_ = NULL;
			gint _tmp9_ = 0;
			gboolean _tmp10_;
			const gchar* _tmp11_;
#line 666 "../src/MainWindow.vala"
			_tmp7_ = doc_info_iter;
#line 666 "../src/MainWindow.vala"
			_tmp10_ = g_variant_iter_next (_tmp7_, "(si)", &_tmp8_, &_tmp9_, NULL);
#line 666 "../src/MainWindow.vala"
			_g_free0 (uri);
#line 666 "../src/MainWindow.vala"
			uri = _tmp8_;
#line 666 "../src/MainWindow.vala"
			pos = _tmp9_;
#line 666 "../src/MainWindow.vala"
			if (!_tmp10_) {
#line 666 "../src/MainWindow.vala"
				break;
#line 3416 "MainWindow.c"
			}
#line 667 "../src/MainWindow.vala"
			_tmp11_ = uri;
#line 667 "../src/MainWindow.vala"
			if (g_strcmp0 (_tmp11_, "") != 0) {
#line 3422 "MainWindow.c"
				GFile* file = NULL;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				gboolean _tmp15_;
				GFile* _tmp20_;
#line 669 "../src/MainWindow.vala"
				_tmp12_ = uri;
#line 669 "../src/MainWindow.vala"
				_tmp13_ = g_uri_parse_scheme (_tmp12_);
#line 669 "../src/MainWindow.vala"
				_tmp14_ = _tmp13_;
#line 669 "../src/MainWindow.vala"
				_tmp15_ = _tmp14_ != NULL;
#line 669 "../src/MainWindow.vala"
				_g_free0 (_tmp14_);
#line 669 "../src/MainWindow.vala"
				if (_tmp15_) {
#line 3441 "MainWindow.c"
					const gchar* _tmp16_;
					GFile* _tmp17_;
#line 670 "../src/MainWindow.vala"
					_tmp16_ = uri;
#line 670 "../src/MainWindow.vala"
					_tmp17_ = g_file_new_for_uri (_tmp16_);
#line 670 "../src/MainWindow.vala"
					_g_object_unref0 (file);
#line 670 "../src/MainWindow.vala"
					file = _tmp17_;
#line 3452 "MainWindow.c"
				} else {
					const gchar* _tmp18_;
					GFile* _tmp19_;
#line 672 "../src/MainWindow.vala"
					_tmp18_ = uri;
#line 672 "../src/MainWindow.vala"
					_tmp19_ = g_file_new_for_commandline_arg (_tmp18_);
#line 672 "../src/MainWindow.vala"
					_g_object_unref0 (file);
#line 672 "../src/MainWindow.vala"
					file = _tmp19_;
#line 3464 "MainWindow.c"
				}
#line 677 "../src/MainWindow.vala"
				_tmp20_ = file;
#line 677 "../src/MainWindow.vala"
				if (g_file_query_exists (_tmp20_, NULL)) {
#line 3470 "MainWindow.c"
					ScratchServicesDocument* doc = NULL;
					GSimpleActionGroup* _tmp21_;
					GFile* _tmp22_;
					ScratchServicesDocument* _tmp23_;
					gboolean is_focused = FALSE;
					GFile* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					const gchar* _tmp27_;
					gboolean _tmp28_;
					gboolean _tmp29_ = FALSE;
					ScratchServicesDocument* _tmp30_;
#line 679 "../src/MainWindow.vala"
					_tmp21_ = self->priv->_actions;
#line 679 "../src/MainWindow.vala"
					_tmp22_ = file;
#line 679 "../src/MainWindow.vala"
					_tmp23_ = scratch_services_document_new (_tmp21_, _tmp22_);
#line 679 "../src/MainWindow.vala"
					g_object_ref_sink (_tmp23_);
#line 679 "../src/MainWindow.vala"
					doc = _tmp23_;
#line 680 "../src/MainWindow.vala"
					_tmp24_ = file;
#line 680 "../src/MainWindow.vala"
					_tmp25_ = g_file_get_uri (_tmp24_);
#line 680 "../src/MainWindow.vala"
					_tmp26_ = _tmp25_;
#line 680 "../src/MainWindow.vala"
					_tmp27_ = focused_document;
#line 680 "../src/MainWindow.vala"
					_tmp28_ = g_strcmp0 (_tmp26_, _tmp27_) == 0;
#line 680 "../src/MainWindow.vala"
					_g_free0 (_tmp26_);
#line 680 "../src/MainWindow.vala"
					is_focused = _tmp28_;
#line 681 "../src/MainWindow.vala"
					_tmp30_ = doc;
#line 681 "../src/MainWindow.vala"
					if (scratch_services_document_exists (_tmp30_, NULL)) {
#line 681 "../src/MainWindow.vala"
						_tmp29_ = TRUE;
#line 3513 "MainWindow.c"
					} else {
						ScratchServicesDocument* _tmp31_;
						gboolean _tmp32_;
						gboolean _tmp33_;
#line 681 "../src/MainWindow.vala"
						_tmp31_ = doc;
#line 681 "../src/MainWindow.vala"
						_tmp32_ = scratch_services_document_get_is_file_temporary (_tmp31_);
#line 681 "../src/MainWindow.vala"
						_tmp33_ = _tmp32_;
#line 681 "../src/MainWindow.vala"
						_tmp29_ = !_tmp33_;
#line 3526 "MainWindow.c"
					}
#line 681 "../src/MainWindow.vala"
					if (_tmp29_) {
#line 3530 "MainWindow.c"
						gboolean _tmp34_ = FALSE;
						RestoreOverride* _tmp35_;
#line 682 "../src/MainWindow.vala"
						_tmp35_ = self->priv->_restore_override;
#line 682 "../src/MainWindow.vala"
						if (_tmp35_ != NULL) {
#line 3537 "MainWindow.c"
							GFile* _tmp36_;
							gchar* _tmp37_;
							gchar* _tmp38_;
							RestoreOverride* _tmp39_;
							GFile* _tmp40_;
							GFile* _tmp41_;
							gchar* _tmp42_;
							gchar* _tmp43_;
#line 682 "../src/MainWindow.vala"
							_tmp36_ = file;
#line 682 "../src/MainWindow.vala"
							_tmp37_ = g_file_get_path (_tmp36_);
#line 682 "../src/MainWindow.vala"
							_tmp38_ = _tmp37_;
#line 682 "../src/MainWindow.vala"
							_tmp39_ = self->priv->_restore_override;
#line 682 "../src/MainWindow.vala"
							_tmp40_ = restore_override_get_file (_tmp39_);
#line 682 "../src/MainWindow.vala"
							_tmp41_ = _tmp40_;
#line 682 "../src/MainWindow.vala"
							_tmp42_ = g_file_get_path (_tmp41_);
#line 682 "../src/MainWindow.vala"
							_tmp43_ = _tmp42_;
#line 682 "../src/MainWindow.vala"
							_tmp34_ = g_strcmp0 (_tmp38_, _tmp43_) == 0;
#line 682 "../src/MainWindow.vala"
							_g_free0 (_tmp43_);
#line 682 "../src/MainWindow.vala"
							_g_free0 (_tmp38_);
#line 3568 "MainWindow.c"
						} else {
#line 682 "../src/MainWindow.vala"
							_tmp34_ = FALSE;
#line 3572 "MainWindow.c"
						}
#line 682 "../src/MainWindow.vala"
						if (_tmp34_) {
#line 3576 "MainWindow.c"
							ScratchServicesDocument* _tmp44_;
							RestoreOverride* _tmp45_;
							SelectionRange _tmp46_ = {0};
							SelectionRange _tmp47_;
#line 683 "../src/MainWindow.vala"
							_tmp44_ = doc;
#line 683 "../src/MainWindow.vala"
							_tmp45_ = self->priv->_restore_override;
#line 683 "../src/MainWindow.vala"
							restore_override_get_range (_tmp45_, &_tmp46_);
#line 683 "../src/MainWindow.vala"
							_tmp47_ = _tmp46_;
#line 683 "../src/MainWindow.vala"
							scratch_main_window_open_document_at_selected_range (self, _tmp44_, TRUE, &_tmp47_, TRUE);
#line 684 "../src/MainWindow.vala"
							was_restore_overriden = TRUE;
#line 3593 "MainWindow.c"
						} else {
							gboolean _tmp48_ = FALSE;
							ScratchServicesDocument* _tmp49_;
#line 686 "../src/MainWindow.vala"
							if (was_restore_overriden) {
#line 686 "../src/MainWindow.vala"
								_tmp48_ = FALSE;
#line 3601 "MainWindow.c"
							} else {
#line 686 "../src/MainWindow.vala"
								_tmp48_ = is_focused;
#line 3605 "MainWindow.c"
							}
#line 686 "../src/MainWindow.vala"
							_tmp49_ = doc;
#line 686 "../src/MainWindow.vala"
							scratch_main_window_open_document (self, _tmp49_, _tmp48_, pos);
#line 3611 "MainWindow.c"
						}
					}
#line 690 "../src/MainWindow.vala"
					if (is_focused) {
#line 3616 "MainWindow.c"
						ScratchFolderManagerFileView* _tmp50_;
						GFile* _tmp51_;
						gchar* _tmp52_;
						gchar* _tmp53_;
#line 691 "../src/MainWindow.vala"
						_tmp50_ = self->priv->folder_manager_view;
#line 691 "../src/MainWindow.vala"
						_tmp51_ = file;
#line 691 "../src/MainWindow.vala"
						_tmp52_ = g_file_get_path (_tmp51_);
#line 691 "../src/MainWindow.vala"
						_tmp53_ = _tmp52_;
#line 691 "../src/MainWindow.vala"
						scratch_folder_manager_file_view_expand_to_path (_tmp50_, _tmp53_);
#line 691 "../src/MainWindow.vala"
						_g_free0 (_tmp53_);
#line 3633 "MainWindow.c"
					}
#line 677 "../src/MainWindow.vala"
					_g_object_unref0 (doc);
#line 3637 "MainWindow.c"
				}
#line 667 "../src/MainWindow.vala"
				_g_object_unref0 (file);
#line 3641 "MainWindow.c"
			}
		}
#line 659 "../src/MainWindow.vala"
		_g_free0 (uri);
#line 659 "../src/MainWindow.vala"
		_g_free0 (focused_document);
#line 659 "../src/MainWindow.vala"
		_g_variant_iter_free0 (doc_info_iter);
#line 659 "../src/MainWindow.vala"
		_g_variant_unref0 (doc_infos);
#line 3652 "MainWindow.c"
	}
#line 698 "../src/MainWindow.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda155__gsource_func, g_object_ref (self), g_object_unref);
#line 3656 "MainWindow.c"
}

static GVariant*
_variant_new1 (gboolean value)
{
#line 711 "../src/MainWindow.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 3664 "MainWindow.c"
}

static gboolean
scratch_main_window_on_key_pressed (ScratchMainWindow* self,
                                    guint keyval,
                                    guint keycode,
                                    GdkModifierType state)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 707 "../src/MainWindow.vala"
	static GQuark _tmp2_label0 = 0;
#line 3678 "MainWindow.c"
	gboolean result;
#line 706 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 707 "../src/MainWindow.vala"
	_tmp0_ = gdk_keyval_name (keyval);
#line 707 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 707 "../src/MainWindow.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 707 "../src/MainWindow.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("Escape")))) {
#line 707 "../src/MainWindow.vala"
		switch (0) {
#line 3692 "MainWindow.c"
			default:
			{
				GtkRevealer* _tmp4_;
#line 709 "../src/MainWindow.vala"
				_tmp4_ = self->priv->search_revealer;
#line 709 "../src/MainWindow.vala"
				if (gtk_revealer_get_child_revealed (_tmp4_)) {
#line 3700 "MainWindow.c"
					GSimpleAction* fetch_action = NULL;
					GSimpleActionGroup* _tmp5_;
					GSimpleAction* _tmp6_;
					GSimpleAction* _tmp7_;
					GVariant* _tmp8_;
					ScratchWidgetsDocumentView* _tmp9_;
					ScratchServicesDocument* _tmp10_;
					ScratchServicesDocument* _tmp11_;
					ScratchWidgetsSourceView* _tmp12_;
#line 710 "../src/MainWindow.vala"
					_tmp5_ = self->priv->_actions;
#line 710 "../src/MainWindow.vala"
					_tmp6_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_SHOW_FIND, _tmp5_);
#line 710 "../src/MainWindow.vala"
					fetch_action = _tmp6_;
#line 711 "../src/MainWindow.vala"
					_tmp7_ = fetch_action;
#line 711 "../src/MainWindow.vala"
					_tmp8_ = _variant_new1 (FALSE);
#line 711 "../src/MainWindow.vala"
					g_simple_action_set_state (_tmp7_, _tmp8_);
#line 711 "../src/MainWindow.vala"
					_g_variant_unref0 (_tmp8_);
#line 712 "../src/MainWindow.vala"
					_tmp9_ = self->document_view;
#line 712 "../src/MainWindow.vala"
					_tmp10_ = scratch_widgets_document_view_get_current_document (_tmp9_);
#line 712 "../src/MainWindow.vala"
					_tmp11_ = _tmp10_;
#line 712 "../src/MainWindow.vala"
					_tmp12_ = _tmp11_->source_view;
#line 712 "../src/MainWindow.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 709 "../src/MainWindow.vala"
					_g_object_unref0 (fetch_action);
#line 3736 "MainWindow.c"
				}
#line 715 "../src/MainWindow.vala"
				break;
#line 3740 "MainWindow.c"
			}
		}
	}
#line 719 "../src/MainWindow.vala"
	result = FALSE;
#line 719 "../src/MainWindow.vala"
	return result;
#line 3748 "MainWindow.c"
}

static gboolean
scratch_main_window_real_delete_event (GtkWidget* base,
                                       GdkEventAny* event)
{
	ScratchMainWindow * self;
	gboolean result;
#line 722 "../src/MainWindow.vala"
	self = (ScratchMainWindow*) base;
#line 722 "../src/MainWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 723 "../src/MainWindow.vala"
	scratch_main_window_action_quit (self);
#line 724 "../src/MainWindow.vala"
	result = TRUE;
#line 724 "../src/MainWindow.vala"
	return result;
#line 3767 "MainWindow.c"
}

static void
scratch_main_window_set_widgets_sensitive (ScratchMainWindow* self,
                                           gboolean val)
{
	GSimpleActionGroup* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleActionGroup* _tmp6_;
	GSimpleAction* _tmp7_;
	GSimpleAction* _tmp8_;
	GSimpleActionGroup* _tmp9_;
	GSimpleAction* _tmp10_;
	GSimpleAction* _tmp11_;
	GSimpleActionGroup* _tmp12_;
	GSimpleAction* _tmp13_;
	GSimpleAction* _tmp14_;
	GSimpleActionGroup* _tmp15_;
	GSimpleAction* _tmp16_;
	GSimpleAction* _tmp17_;
	GSimpleActionGroup* _tmp18_;
	GSimpleAction* _tmp19_;
	GSimpleAction* _tmp20_;
	GSimpleActionGroup* _tmp21_;
	GSimpleAction* _tmp22_;
	GSimpleAction* _tmp23_;
	ScratchWidgetsSearchBar* _tmp24_;
	ScratchHeaderBar* _tmp25_;
	GtkMenuButton* _tmp26_;
#line 728 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 730 "../src/MainWindow.vala"
	_tmp0_ = self->priv->_actions;
#line 730 "../src/MainWindow.vala"
	_tmp1_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_SHOW_FIND, _tmp0_);
#line 730 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 730 "../src/MainWindow.vala"
	g_simple_action_set_enabled (_tmp2_, val);
#line 730 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp2_);
#line 731 "../src/MainWindow.vala"
	_tmp3_ = self->priv->_actions;
#line 731 "../src/MainWindow.vala"
	_tmp4_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_GO_TO, _tmp3_);
#line 731 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 731 "../src/MainWindow.vala"
	g_simple_action_set_enabled (_tmp5_, val);
#line 731 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp5_);
#line 732 "../src/MainWindow.vala"
	_tmp6_ = self->priv->_actions;
#line 732 "../src/MainWindow.vala"
	_tmp7_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_SHOW_REPLACE, _tmp6_);
#line 732 "../src/MainWindow.vala"
	_tmp8_ = _tmp7_;
#line 732 "../src/MainWindow.vala"
	g_simple_action_set_enabled (_tmp8_, val);
#line 732 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp8_);
#line 734 "../src/MainWindow.vala"
	_tmp9_ = self->priv->_actions;
#line 734 "../src/MainWindow.vala"
	_tmp10_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_SAVE, _tmp9_);
#line 734 "../src/MainWindow.vala"
	_tmp11_ = _tmp10_;
#line 734 "../src/MainWindow.vala"
	g_simple_action_set_enabled (_tmp11_, val);
#line 734 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp11_);
#line 735 "../src/MainWindow.vala"
	_tmp12_ = self->priv->_actions;
#line 735 "../src/MainWindow.vala"
	_tmp13_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_SAVE_AS, _tmp12_);
#line 735 "../src/MainWindow.vala"
	_tmp14_ = _tmp13_;
#line 735 "../src/MainWindow.vala"
	g_simple_action_set_enabled (_tmp14_, val);
#line 735 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp14_);
#line 736 "../src/MainWindow.vala"
	_tmp15_ = self->priv->_actions;
#line 736 "../src/MainWindow.vala"
	_tmp16_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_UNDO, _tmp15_);
#line 736 "../src/MainWindow.vala"
	_tmp17_ = _tmp16_;
#line 736 "../src/MainWindow.vala"
	g_simple_action_set_enabled (_tmp17_, val);
#line 736 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp17_);
#line 737 "../src/MainWindow.vala"
	_tmp18_ = self->priv->_actions;
#line 737 "../src/MainWindow.vala"
	_tmp19_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_REDO, _tmp18_);
#line 737 "../src/MainWindow.vala"
	_tmp20_ = _tmp19_;
#line 737 "../src/MainWindow.vala"
	g_simple_action_set_enabled (_tmp20_, val);
#line 737 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp20_);
#line 738 "../src/MainWindow.vala"
	_tmp21_ = self->priv->_actions;
#line 738 "../src/MainWindow.vala"
	_tmp22_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_REVERT, _tmp21_);
#line 738 "../src/MainWindow.vala"
	_tmp23_ = _tmp22_;
#line 738 "../src/MainWindow.vala"
	g_simple_action_set_enabled (_tmp23_, val);
#line 738 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp23_);
#line 739 "../src/MainWindow.vala"
	_tmp24_ = self->search_bar;
#line 739 "../src/MainWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, val);
#line 740 "../src/MainWindow.vala"
	_tmp25_ = self->toolbar;
#line 740 "../src/MainWindow.vala"
	_tmp26_ = _tmp25_->share_menu_button;
#line 740 "../src/MainWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp26_, val);
#line 3893 "MainWindow.c"
}

ScratchServicesDocument*
scratch_main_window_get_current_document (ScratchMainWindow* self)
{
	ScratchWidgetsDocumentView* _tmp0_;
	ScratchServicesDocument* _tmp1_;
	ScratchServicesDocument* _tmp2_;
	ScratchServicesDocument* _tmp3_;
	ScratchServicesDocument* result;
#line 744 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 745 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 745 "../src/MainWindow.vala"
	_tmp1_ = scratch_widgets_document_view_get_current_document (_tmp0_);
#line 745 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 745 "../src/MainWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 745 "../src/MainWindow.vala"
	result = _tmp3_;
#line 745 "../src/MainWindow.vala"
	return result;
#line 3918 "MainWindow.c"
}

ScratchServicesDocument*
scratch_main_window_get_focused_document (ScratchMainWindow* self)
{
	ScratchWidgetsDocumentView* _tmp0_;
	ScratchServicesDocument* _tmp1_;
	ScratchServicesDocument* _tmp2_;
	ScratchServicesDocument* _tmp3_;
	ScratchServicesDocument* result;
#line 749 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 750 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 750 "../src/MainWindow.vala"
	_tmp1_ = scratch_widgets_document_view_get_current_document (_tmp0_);
#line 750 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 750 "../src/MainWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 750 "../src/MainWindow.vala"
	result = _tmp3_;
#line 750 "../src/MainWindow.vala"
	return result;
#line 3943 "MainWindow.c"
}

void
scratch_main_window_open_folder (ScratchMainWindow* self,
                                 GFile* folder)
{
	ScratchFolderManagerFile* foldermanager_file = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	ScratchFolderManagerFile* _tmp2_;
	ScratchFolderManagerFile* _tmp3_;
	ScratchFolderManagerFileView* _tmp4_;
#line 753 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 753 "../src/MainWindow.vala"
	g_return_if_fail (folder != NULL);
#line 754 "../src/MainWindow.vala"
	_tmp0_ = g_file_get_path (folder);
#line 754 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 754 "../src/MainWindow.vala"
	_tmp2_ = scratch_folder_manager_file_new (_tmp1_);
#line 754 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 754 "../src/MainWindow.vala"
	_g_free0 (_tmp1_);
#line 754 "../src/MainWindow.vala"
	foldermanager_file = _tmp3_;
#line 755 "../src/MainWindow.vala"
	_tmp4_ = self->priv->folder_manager_view;
#line 755 "../src/MainWindow.vala"
	scratch_folder_manager_file_view_open_folder (_tmp4_, foldermanager_file);
#line 753 "../src/MainWindow.vala"
	_g_object_unref0 (foldermanager_file);
#line 3978 "MainWindow.c"
}

void
scratch_main_window_open_document (ScratchMainWindow* self,
                                   ScratchServicesDocument* doc,
                                   gboolean focus,
                                   gint cursor_position)
{
	ScratchFolderManagerProjectFolderItem* project = NULL;
	ScratchFolderManagerFileView* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	ScratchFolderManagerProjectFolderItem* _tmp3_;
	ScratchWidgetsSourceView* _tmp4_;
	ScratchWidgetsDocumentView* _tmp5_;
#line 758 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 758 "../src/MainWindow.vala"
	g_return_if_fail (doc != NULL);
#line 762 "../src/MainWindow.vala"
	_tmp0_ = self->priv->folder_manager_view;
#line 762 "../src/MainWindow.vala"
	_tmp1_ = scratch_services_document_get_file (doc);
#line 762 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 762 "../src/MainWindow.vala"
	_tmp3_ = scratch_folder_manager_file_view_get_project_for_file (_tmp0_, _tmp2_);
#line 762 "../src/MainWindow.vala"
	project = _tmp3_;
#line 763 "../src/MainWindow.vala"
	_tmp4_ = doc->source_view;
#line 763 "../src/MainWindow.vala"
	scratch_widgets_source_view_set_project (_tmp4_, project);
#line 764 "../src/MainWindow.vala"
	_tmp5_ = self->document_view;
#line 764 "../src/MainWindow.vala"
	scratch_widgets_document_view_open_document (_tmp5_, doc, focus, cursor_position, &SELECTION_RANGE_EMPTY);
#line 758 "../src/MainWindow.vala"
	_g_object_unref0 (project);
#line 4018 "MainWindow.c"
}

void
scratch_main_window_open_document_at_selected_range (ScratchMainWindow* self,
                                                     ScratchServicesDocument* doc,
                                                     gboolean focus,
                                                     SelectionRange* range,
                                                     gboolean is_override)
{
	gboolean _tmp0_ = FALSE;
	RestoreOverride* _tmp1_;
	ScratchFolderManagerProjectFolderItem* project = NULL;
	ScratchFolderManagerFileView* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	ScratchFolderManagerProjectFolderItem* _tmp5_;
	ScratchWidgetsSourceView* _tmp6_;
	ScratchFolderManagerProjectFolderItem* _tmp7_;
	ScratchWidgetsDocumentView* _tmp8_;
	SelectionRange _tmp9_;
#line 767 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 767 "../src/MainWindow.vala"
	g_return_if_fail (doc != NULL);
#line 767 "../src/MainWindow.vala"
	g_return_if_fail (range != NULL);
#line 771 "../src/MainWindow.vala"
	_tmp1_ = self->priv->_restore_override;
#line 771 "../src/MainWindow.vala"
	if (_tmp1_ != NULL) {
#line 771 "../src/MainWindow.vala"
		_tmp0_ = is_override == FALSE;
#line 4051 "MainWindow.c"
	} else {
#line 771 "../src/MainWindow.vala"
		_tmp0_ = FALSE;
#line 4055 "MainWindow.c"
	}
#line 771 "../src/MainWindow.vala"
	if (_tmp0_) {
#line 772 "../src/MainWindow.vala"
		return;
#line 4061 "MainWindow.c"
	}
#line 775 "../src/MainWindow.vala"
	_tmp2_ = self->priv->folder_manager_view;
#line 775 "../src/MainWindow.vala"
	_tmp3_ = scratch_services_document_get_file (doc);
#line 775 "../src/MainWindow.vala"
	_tmp4_ = _tmp3_;
#line 775 "../src/MainWindow.vala"
	_tmp5_ = scratch_folder_manager_file_view_get_project_for_file (_tmp2_, _tmp4_);
#line 775 "../src/MainWindow.vala"
	project = _tmp5_;
#line 776 "../src/MainWindow.vala"
	_tmp6_ = doc->source_view;
#line 776 "../src/MainWindow.vala"
	_tmp7_ = project;
#line 776 "../src/MainWindow.vala"
	scratch_widgets_source_view_set_project (_tmp6_, _tmp7_);
#line 777 "../src/MainWindow.vala"
	_tmp8_ = self->document_view;
#line 777 "../src/MainWindow.vala"
	_tmp9_ = *range;
#line 777 "../src/MainWindow.vala"
	scratch_widgets_document_view_open_document (_tmp8_, doc, focus, 0, &_tmp9_);
#line 767 "../src/MainWindow.vala"
	_g_object_unref0 (project);
#line 4087 "MainWindow.c"
}

void
scratch_main_window_close_document (ScratchMainWindow* self,
                                    ScratchServicesDocument* doc)
{
	ScratchWidgetsDocumentView* _tmp0_;
#line 781 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 781 "../src/MainWindow.vala"
	g_return_if_fail (doc != NULL);
#line 782 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 782 "../src/MainWindow.vala"
	scratch_widgets_document_view_close_document (_tmp0_, doc);
#line 4103 "MainWindow.c"
}

static void
scratch_main_window_check_unsaved_changes_data_free (gpointer _data)
{
	ScratchMainWindowCheckUnsavedChangesData* _data_;
	_data_ = _data;
#line 22 "../src/MainWindow.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/MainWindow.vala"
	g_slice_free (ScratchMainWindowCheckUnsavedChangesData, _data_);
#line 4115 "MainWindow.c"
}

static void
scratch_main_window_check_unsaved_changes (ScratchMainWindow* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	ScratchMainWindowCheckUnsavedChangesData* _data_;
	ScratchMainWindow* _tmp0_;
#line 22 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/MainWindow.vala"
	_data_ = g_slice_new0 (ScratchMainWindowCheckUnsavedChangesData);
#line 22 "../src/MainWindow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/MainWindow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, scratch_main_window_check_unsaved_changes_data_free);
#line 22 "../src/MainWindow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/MainWindow.vala"
	_data_->self = _tmp0_;
#line 22 "../src/MainWindow.vala"
	scratch_main_window_check_unsaved_changes_co (_data_);
#line 4139 "MainWindow.c"
}

static gboolean
scratch_main_window_check_unsaved_changes_finish (ScratchMainWindow* self,
                                                  GAsyncResult* _res_)
{
	gboolean result;
	ScratchMainWindowCheckUnsavedChangesData* _data_;
#line 22 "../src/MainWindow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 22 "../src/MainWindow.vala"
	result = _data_->result;
#line 22 "../src/MainWindow.vala"
	return result;
#line 4154 "MainWindow.c"
}

static void
scratch_main_window_check_unsaved_changes_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	ScratchMainWindowCheckUnsavedChangesData* _data_;
#line 789 "../src/MainWindow.vala"
	_data_ = _user_data_;
#line 789 "../src/MainWindow.vala"
	_data_->_source_object_ = source_object;
#line 789 "../src/MainWindow.vala"
	_data_->_res_ = _res_;
#line 789 "../src/MainWindow.vala"
	scratch_main_window_check_unsaved_changes_co (_data_);
#line 4171 "MainWindow.c"
}

static gboolean
scratch_main_window_check_unsaved_changes_co (ScratchMainWindowCheckUnsavedChangesData* _data_)
{
#line 786 "../src/MainWindow.vala"
	switch (_data_->_state_) {
#line 786 "../src/MainWindow.vala"
		case 0:
#line 4181 "MainWindow.c"
		goto _state_0;
#line 786 "../src/MainWindow.vala"
		case 1:
#line 4185 "MainWindow.c"
		goto _state_1;
		default:
#line 786 "../src/MainWindow.vala"
		g_assert_not_reached ();
#line 4190 "MainWindow.c"
	}
	_state_0:
#line 787 "../src/MainWindow.vala"
	_data_->_tmp0_ = _data_->self->document_view;
#line 787 "../src/MainWindow.vala"
	_data_->_tmp0_->is_closing = TRUE;
#line 788 "../src/MainWindow.vala"
	_data_->_tmp1_ = _data_->self->document_view;
#line 788 "../src/MainWindow.vala"
	_data_->_tmp2_ = _data_->_tmp1_->docs;
#line 4201 "MainWindow.c"
	{
#line 788 "../src/MainWindow.vala"
		_data_->doc_collection = _data_->_tmp2_;
#line 788 "../src/MainWindow.vala"
		for (_data_->doc_it = _data_->doc_collection; _data_->doc_it != NULL; _data_->doc_it = _data_->doc_it->next) {
#line 788 "../src/MainWindow.vala"
			_data_->_tmp3_ = _g_object_ref0 ((ScratchServicesDocument*) _data_->doc_it->data);
#line 788 "../src/MainWindow.vala"
			_data_->doc = _data_->_tmp3_;
#line 4211 "MainWindow.c"
			{
#line 789 "../src/MainWindow.vala"
				_data_->_tmp4_ = _data_->doc;
#line 789 "../src/MainWindow.vala"
				_data_->_state_ = 1;
#line 789 "../src/MainWindow.vala"
				scratch_services_document_do_close (_data_->_tmp4_, TRUE, scratch_main_window_check_unsaved_changes_ready, _data_);
#line 789 "../src/MainWindow.vala"
				return FALSE;
#line 4221 "MainWindow.c"
				_state_1:
#line 789 "../src/MainWindow.vala"
				if (!scratch_services_document_do_close_finish (_data_->_tmp4_, _data_->_res_)) {
#line 790 "../src/MainWindow.vala"
					_data_->_tmp5_ = _data_->self->document_view;
#line 790 "../src/MainWindow.vala"
					_data_->_tmp6_ = _data_->doc;
#line 790 "../src/MainWindow.vala"
					scratch_widgets_document_view_set_current_document (_data_->_tmp5_, _data_->_tmp6_);
#line 791 "../src/MainWindow.vala"
					_data_->result = FALSE;
#line 791 "../src/MainWindow.vala"
					_g_object_unref0 (_data_->doc);
#line 791 "../src/MainWindow.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 791 "../src/MainWindow.vala"
					if (_data_->_state_ != 0) {
#line 791 "../src/MainWindow.vala"
						while (!g_task_get_completed (_data_->_async_result)) {
#line 791 "../src/MainWindow.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4243 "MainWindow.c"
						}
					}
#line 791 "../src/MainWindow.vala"
					g_object_unref (_data_->_async_result);
#line 791 "../src/MainWindow.vala"
					return FALSE;
#line 4250 "MainWindow.c"
				}
#line 788 "../src/MainWindow.vala"
				_g_object_unref0 (_data_->doc);
#line 4254 "MainWindow.c"
			}
		}
	}
#line 795 "../src/MainWindow.vala"
	_data_->result = TRUE;
#line 795 "../src/MainWindow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 795 "../src/MainWindow.vala"
	if (_data_->_state_ != 0) {
#line 795 "../src/MainWindow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 795 "../src/MainWindow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4268 "MainWindow.c"
		}
	}
#line 795 "../src/MainWindow.vala"
	g_object_unref (_data_->_async_result);
#line 795 "../src/MainWindow.vala"
	return FALSE;
#line 4275 "MainWindow.c"
}

static void
scratch_main_window_restore_saved_state_extra (ScratchMainWindow* self)
{
	GtkPaned* _tmp0_;
	GSettings* _tmp1_;
	GtkPaned* _tmp2_;
	GSettings* _tmp3_;
#line 799 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 801 "../src/MainWindow.vala"
	_tmp0_ = self->priv->hp1;
#line 801 "../src/MainWindow.vala"
	_tmp1_ = scratch_saved_state;
#line 801 "../src/MainWindow.vala"
	gtk_paned_set_position (_tmp0_, g_settings_get_int (_tmp1_, "hp1-size"));
#line 802 "../src/MainWindow.vala"
	_tmp2_ = self->priv->vp;
#line 802 "../src/MainWindow.vala"
	_tmp3_ = scratch_saved_state;
#line 802 "../src/MainWindow.vala"
	gtk_paned_set_position (_tmp2_, g_settings_get_int (_tmp3_, "vp-size"));
#line 4299 "MainWindow.c"
}

static void
scratch_main_window_create_unsaved_documents_directory (ScratchMainWindow* self)
{
	GFile* directory = NULL;
	ScratchApplication* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 805 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 806 "../src/MainWindow.vala"
	_tmp0_ = self->priv->_app;
#line 806 "../src/MainWindow.vala"
	_tmp1_ = scratch_application_get_data_home_folder_unsaved (_tmp0_);
#line 806 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 806 "../src/MainWindow.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 806 "../src/MainWindow.vala"
	directory = _tmp3_;
#line 807 "../src/MainWindow.vala"
	_tmp4_ = directory;
#line 807 "../src/MainWindow.vala"
	if (!g_file_query_exists (_tmp4_, NULL)) {
#line 4328 "MainWindow.c"
		{
			GFile* _tmp5_;
			GFile* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 809 "../src/MainWindow.vala"
			_tmp5_ = directory;
#line 809 "../src/MainWindow.vala"
			g_file_make_directory_with_parents (_tmp5_, NULL, &_inner_error0_);
#line 809 "../src/MainWindow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4340 "MainWindow.c"
				goto __catch0_g_error;
			}
#line 810 "../src/MainWindow.vala"
			_tmp6_ = directory;
#line 810 "../src/MainWindow.vala"
			_tmp7_ = g_file_get_path (_tmp6_);
#line 810 "../src/MainWindow.vala"
			_tmp8_ = _tmp7_;
#line 810 "../src/MainWindow.vala"
			g_debug ("MainWindow.vala:810: created 'unsaved' directory: %s", _tmp8_);
#line 810 "../src/MainWindow.vala"
			_g_free0 (_tmp8_);
#line 4353 "MainWindow.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GFile* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			GError* _tmp12_;
			const gchar* _tmp13_;
#line 808 "../src/MainWindow.vala"
			e = _inner_error0_;
#line 808 "../src/MainWindow.vala"
			_inner_error0_ = NULL;
#line 812 "../src/MainWindow.vala"
			_tmp9_ = directory;
#line 812 "../src/MainWindow.vala"
			_tmp10_ = g_file_get_path (_tmp9_);
#line 812 "../src/MainWindow.vala"
			_tmp11_ = _tmp10_;
#line 812 "../src/MainWindow.vala"
			_tmp12_ = e;
#line 812 "../src/MainWindow.vala"
			_tmp13_ = _tmp12_->message;
#line 812 "../src/MainWindow.vala"
			g_critical ("MainWindow.vala:812: Unable to create the 'unsaved' directory: '%s': %" \
"s", _tmp11_, _tmp13_);
#line 812 "../src/MainWindow.vala"
			_g_free0 (_tmp11_);
#line 808 "../src/MainWindow.vala"
			_g_error_free0 (e);
#line 4384 "MainWindow.c"
		}
		__finally0:
#line 808 "../src/MainWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 808 "../src/MainWindow.vala"
			_g_object_unref0 (directory);
#line 808 "../src/MainWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 808 "../src/MainWindow.vala"
			g_clear_error (&_inner_error0_);
#line 808 "../src/MainWindow.vala"
			return;
#line 4397 "MainWindow.c"
		}
	}
#line 805 "../src/MainWindow.vala"
	_g_object_unref0 (directory);
#line 4402 "MainWindow.c"
}

static void
scratch_main_window_update_saved_state (ScratchMainWindow* self)
{
	GdkWindowState state = 0U;
	GdkWindow* _tmp0_;
	GSettings* _tmp7_;
	GtkPaned* _tmp8_;
	GSettings* _tmp9_;
	GtkPaned* _tmp10_;
#line 817 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 819 "../src/MainWindow.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 819 "../src/MainWindow.vala"
	state = gdk_window_get_state (_tmp0_);
#line 820 "../src/MainWindow.vala"
	if ((state & GDK_WINDOW_STATE_MAXIMIZED) == GDK_WINDOW_STATE_MAXIMIZED) {
#line 4422 "MainWindow.c"
		GSettings* _tmp1_;
#line 821 "../src/MainWindow.vala"
		_tmp1_ = scratch_saved_state;
#line 821 "../src/MainWindow.vala"
		g_settings_set_enum (_tmp1_, "window-state", (gint) SCRATCH_SCRATCH_WINDOW_STATE_MAXIMIZED);
#line 4428 "MainWindow.c"
	} else {
#line 822 "../src/MainWindow.vala"
		if ((state & GDK_WINDOW_STATE_FULLSCREEN) == GDK_WINDOW_STATE_FULLSCREEN) {
#line 4432 "MainWindow.c"
			GSettings* _tmp2_;
#line 823 "../src/MainWindow.vala"
			_tmp2_ = scratch_saved_state;
#line 823 "../src/MainWindow.vala"
			g_settings_set_enum (_tmp2_, "window-state", (gint) SCRATCH_SCRATCH_WINDOW_STATE_FULLSCREEN);
#line 4438 "MainWindow.c"
		} else {
			GSettings* _tmp3_;
			gint width = 0;
			gint height = 0;
			gint _tmp4_ = 0;
			gint _tmp5_ = 0;
			GSettings* _tmp6_;
#line 825 "../src/MainWindow.vala"
			_tmp3_ = scratch_saved_state;
#line 825 "../src/MainWindow.vala"
			g_settings_set_enum (_tmp3_, "window-state", (gint) SCRATCH_SCRATCH_WINDOW_STATE_NORMAL);
#line 828 "../src/MainWindow.vala"
			gtk_window_get_size ((GtkWindow*) self, &_tmp4_, &_tmp5_);
#line 828 "../src/MainWindow.vala"
			width = _tmp4_;
#line 828 "../src/MainWindow.vala"
			height = _tmp5_;
#line 829 "../src/MainWindow.vala"
			_tmp6_ = scratch_saved_state;
#line 829 "../src/MainWindow.vala"
			g_settings_set (_tmp6_, "window-size", "(ii)", width, height);
#line 4460 "MainWindow.c"
		}
	}
#line 833 "../src/MainWindow.vala"
	_tmp7_ = scratch_saved_state;
#line 833 "../src/MainWindow.vala"
	_tmp8_ = self->priv->hp1;
#line 833 "../src/MainWindow.vala"
	g_settings_set_int (_tmp7_, "hp1-size", gtk_paned_get_position (_tmp8_));
#line 834 "../src/MainWindow.vala"
	_tmp9_ = scratch_saved_state;
#line 834 "../src/MainWindow.vala"
	_tmp10_ = self->priv->vp;
#line 834 "../src/MainWindow.vala"
	g_settings_set_int (_tmp9_, "vp-size", gtk_paned_get_position (_tmp10_));
#line 4475 "MainWindow.c"
}

gboolean
scratch_main_window_quit_source_func (ScratchMainWindow* self)
{
	gboolean result;
#line 838 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 839 "../src/MainWindow.vala"
	scratch_main_window_action_quit (self);
#line 840 "../src/MainWindow.vala"
	result = FALSE;
#line 840 "../src/MainWindow.vala"
	return result;
#line 4490 "MainWindow.c"
}

static void
scratch_main_window_handle_quit (ScratchMainWindow* self)
{
	ScratchWidgetsDocumentView* _tmp0_;
#line 844 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 845 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 845 "../src/MainWindow.vala"
	scratch_widgets_document_view_save_opened_files (_tmp0_);
#line 846 "../src/MainWindow.vala"
	scratch_main_window_update_saved_state (self);
#line 4505 "MainWindow.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 4536 "MainWindow.c"
}

void
scratch_main_window_set_default_zoom (ScratchMainWindow* self)
{
	CodeTerminal* _tmp0_;
	GSettings* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 849 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 850 "../src/MainWindow.vala"
	_tmp0_ = self->priv->terminal;
#line 850 "../src/MainWindow.vala"
	code_terminal_set_default_font_size (_tmp0_);
#line 851 "../src/MainWindow.vala"
	_tmp1_ = scratch_settings;
#line 851 "../src/MainWindow.vala"
	_tmp2_ = scratch_main_window_get_current_font (self);
#line 851 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 851 "../src/MainWindow.vala"
	_tmp4_ = g_strconcat (_tmp3_, " ", NULL);
#line 851 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 851 "../src/MainWindow.vala"
	_tmp6_ = double_to_string (scratch_main_window_get_default_font_size (self));
#line 851 "../src/MainWindow.vala"
	_tmp7_ = _tmp6_;
#line 851 "../src/MainWindow.vala"
	_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 851 "../src/MainWindow.vala"
	_tmp9_ = _tmp8_;
#line 851 "../src/MainWindow.vala"
	g_settings_set_string (_tmp1_, "font", _tmp9_);
#line 851 "../src/MainWindow.vala"
	_g_free0 (_tmp9_);
#line 851 "../src/MainWindow.vala"
	_g_free0 (_tmp7_);
#line 851 "../src/MainWindow.vala"
	_g_free0 (_tmp5_);
#line 851 "../src/MainWindow.vala"
	_g_free0 (_tmp3_);
#line 4586 "MainWindow.c"
}

void
scratch_main_window_action_zoom_in (ScratchMainWindow* self)
{
	CodeTerminal* _tmp0_;
#line 855 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 856 "../src/MainWindow.vala"
	_tmp0_ = self->priv->terminal;
#line 856 "../src/MainWindow.vala"
	code_terminal_increment_size (_tmp0_);
#line 857 "../src/MainWindow.vala"
	scratch_main_window_zooming (self, GDK_SCROLL_UP);
#line 4601 "MainWindow.c"
}

void
scratch_main_window_action_zoom_out (ScratchMainWindow* self)
{
	CodeTerminal* _tmp0_;
#line 861 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 862 "../src/MainWindow.vala"
	_tmp0_ = self->priv->terminal;
#line 862 "../src/MainWindow.vala"
	code_terminal_decrement_size (_tmp0_);
#line 863 "../src/MainWindow.vala"
	scratch_main_window_zooming (self, GDK_SCROLL_DOWN);
#line 4616 "MainWindow.c"
}

static void
scratch_main_window_zooming (ScratchMainWindow* self,
                             GdkScrollDirection direction)
{
	gchar* font = NULL;
	gchar* _tmp0_;
	gint font_size = 0;
	GSettings* _tmp1_;
	gchar* new_font = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GSettings* _tmp13_;
	const gchar* _tmp14_;
#line 866 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 867 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_current_font (self);
#line 867 "../src/MainWindow.vala"
	font = _tmp0_;
#line 868 "../src/MainWindow.vala"
	font_size = (gint) scratch_main_window_get_current_font_size (self);
#line 869 "../src/MainWindow.vala"
	_tmp1_ = scratch_settings;
#line 869 "../src/MainWindow.vala"
	if (g_settings_get_boolean (_tmp1_, "use-system-font")) {
#line 4649 "MainWindow.c"
		GSettings* _tmp2_;
		gchar* _tmp3_;
#line 870 "../src/MainWindow.vala"
		_tmp2_ = scratch_settings;
#line 870 "../src/MainWindow.vala"
		g_settings_set_boolean (_tmp2_, "use-system-font", FALSE);
#line 871 "../src/MainWindow.vala"
		_tmp3_ = scratch_main_window_get_default_font (self);
#line 871 "../src/MainWindow.vala"
		_g_free0 (font);
#line 871 "../src/MainWindow.vala"
		font = _tmp3_;
#line 872 "../src/MainWindow.vala"
		font_size = (gint) scratch_main_window_get_default_font_size (self);
#line 4664 "MainWindow.c"
	}
#line 875 "../src/MainWindow.vala"
	if (direction == GDK_SCROLL_DOWN) {
#line 4668 "MainWindow.c"
		gint _tmp4_;
#line 876 "../src/MainWindow.vala"
		_tmp4_ = font_size;
#line 876 "../src/MainWindow.vala"
		font_size = _tmp4_ - 1;
#line 877 "../src/MainWindow.vala"
		if (font_size < SCRATCH_MAIN_WINDOW_FONT_SIZE_MIN) {
#line 878 "../src/MainWindow.vala"
			_g_free0 (font);
#line 878 "../src/MainWindow.vala"
			return;
#line 4680 "MainWindow.c"
		}
	} else {
#line 880 "../src/MainWindow.vala"
		if (direction == GDK_SCROLL_UP) {
#line 4685 "MainWindow.c"
			gint _tmp5_;
#line 881 "../src/MainWindow.vala"
			_tmp5_ = font_size;
#line 881 "../src/MainWindow.vala"
			font_size = _tmp5_ + 1;
#line 882 "../src/MainWindow.vala"
			if (font_size > SCRATCH_MAIN_WINDOW_FONT_SIZE_MAX) {
#line 883 "../src/MainWindow.vala"
				_g_free0 (font);
#line 883 "../src/MainWindow.vala"
				return;
#line 4697 "MainWindow.c"
			}
		}
	}
#line 887 "../src/MainWindow.vala"
	_tmp6_ = font;
#line 887 "../src/MainWindow.vala"
	_tmp7_ = g_strconcat (_tmp6_, " ", NULL);
#line 887 "../src/MainWindow.vala"
	_tmp8_ = _tmp7_;
#line 887 "../src/MainWindow.vala"
	_tmp9_ = g_strdup_printf ("%i", font_size);
#line 887 "../src/MainWindow.vala"
	_tmp10_ = _tmp9_;
#line 887 "../src/MainWindow.vala"
	_tmp11_ = g_strconcat (_tmp8_, _tmp10_, NULL);
#line 887 "../src/MainWindow.vala"
	_tmp12_ = _tmp11_;
#line 887 "../src/MainWindow.vala"
	_g_free0 (_tmp10_);
#line 887 "../src/MainWindow.vala"
	_g_free0 (_tmp8_);
#line 887 "../src/MainWindow.vala"
	new_font = _tmp12_;
#line 888 "../src/MainWindow.vala"
	_tmp13_ = scratch_settings;
#line 888 "../src/MainWindow.vala"
	_tmp14_ = new_font;
#line 888 "../src/MainWindow.vala"
	g_settings_set_string (_tmp13_, "font", _tmp14_);
#line 866 "../src/MainWindow.vala"
	_g_free0 (new_font);
#line 866 "../src/MainWindow.vala"
	_g_free0 (font);
#line 4731 "MainWindow.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 4754 "MainWindow.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 4763 "MainWindow.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 4782 "MainWindow.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 4786 "MainWindow.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 4792 "MainWindow.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 4802 "MainWindow.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 4810 "MainWindow.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 4814 "MainWindow.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 4820 "MainWindow.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 4830 "MainWindow.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1194 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1194 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1195 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1195 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1197 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1197 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 4854 "MainWindow.c"
		gchar* _tmp2_;
#line 1198 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1198 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1198 "glib-2.0.vapi"
		return result;
#line 4862 "MainWindow.c"
	} else {
#line 1200 "glib-2.0.vapi"
		result = -1;
#line 1200 "glib-2.0.vapi"
		return result;
#line 4868 "MainWindow.c"
	}
}

gchar*
scratch_main_window_get_current_font (ScratchMainWindow* self)
{
	gchar* font = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* font_family = NULL;
	gchar* _tmp2_;
	gchar* result;
#line 891 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 892 "../src/MainWindow.vala"
	_tmp0_ = scratch_settings;
#line 892 "../src/MainWindow.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "font");
#line 892 "../src/MainWindow.vala"
	font = _tmp1_;
#line 893 "../src/MainWindow.vala"
	_tmp2_ = string_substring (font, (glong) 0, (glong) string_last_index_of (font, " ", 0));
#line 893 "../src/MainWindow.vala"
	font_family = _tmp2_;
#line 894 "../src/MainWindow.vala"
	result = font_family;
#line 894 "../src/MainWindow.vala"
	_g_free0 (font);
#line 894 "../src/MainWindow.vala"
	return result;
#line 4899 "MainWindow.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result;
#line 1003 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 1004 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 1004 "glib-2.0.vapi"
	return result;
#line 4912 "MainWindow.c"
}

gdouble
scratch_main_window_get_current_font_size (ScratchMainWindow* self)
{
	gchar* font = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* font_size = NULL;
	gchar* _tmp2_;
	gdouble result;
#line 897 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 898 "../src/MainWindow.vala"
	_tmp0_ = scratch_settings;
#line 898 "../src/MainWindow.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "font");
#line 898 "../src/MainWindow.vala"
	font = _tmp1_;
#line 899 "../src/MainWindow.vala"
	_tmp2_ = string_substring (font, (glong) (string_last_index_of (font, " ", 0) + 1), (glong) -1);
#line 899 "../src/MainWindow.vala"
	font_size = _tmp2_;
#line 900 "../src/MainWindow.vala"
	result = double_parse (font_size);
#line 900 "../src/MainWindow.vala"
	_g_free0 (font_size);
#line 900 "../src/MainWindow.vala"
	_g_free0 (font);
#line 900 "../src/MainWindow.vala"
	return result;
#line 4944 "MainWindow.c"
}

gchar*
scratch_main_window_get_default_font (ScratchMainWindow* self)
{
	gchar* font = NULL;
	ScratchApplication* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* font_family = NULL;
	gchar* _tmp4_;
	gchar* result;
#line 903 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 904 "../src/MainWindow.vala"
	_tmp0_ = self->priv->_app;
#line 904 "../src/MainWindow.vala"
	_tmp1_ = scratch_application_get_default_font (_tmp0_);
#line 904 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 904 "../src/MainWindow.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 904 "../src/MainWindow.vala"
	font = _tmp3_;
#line 905 "../src/MainWindow.vala"
	_tmp4_ = string_substring (font, (glong) 0, (glong) string_last_index_of (font, " ", 0));
#line 905 "../src/MainWindow.vala"
	font_family = _tmp4_;
#line 906 "../src/MainWindow.vala"
	result = font_family;
#line 906 "../src/MainWindow.vala"
	_g_free0 (font);
#line 906 "../src/MainWindow.vala"
	return result;
#line 4980 "MainWindow.c"
}

gdouble
scratch_main_window_get_default_font_size (ScratchMainWindow* self)
{
	gchar* font = NULL;
	ScratchApplication* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* font_size = NULL;
	gchar* _tmp4_;
	gdouble result;
#line 909 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 910 "../src/MainWindow.vala"
	_tmp0_ = self->priv->_app;
#line 910 "../src/MainWindow.vala"
	_tmp1_ = scratch_application_get_default_font (_tmp0_);
#line 910 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 910 "../src/MainWindow.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 910 "../src/MainWindow.vala"
	font = _tmp3_;
#line 911 "../src/MainWindow.vala"
	_tmp4_ = string_substring (font, (glong) (string_last_index_of (font, " ", 0) + 1), (glong) -1);
#line 911 "../src/MainWindow.vala"
	font_size = _tmp4_;
#line 912 "../src/MainWindow.vala"
	result = double_parse (font_size);
#line 912 "../src/MainWindow.vala"
	_g_free0 (font_size);
#line 912 "../src/MainWindow.vala"
	_g_free0 (font);
#line 912 "../src/MainWindow.vala"
	return result;
#line 5018 "MainWindow.c"
}

static void
scratch_main_window_action_set_default_zoom (ScratchMainWindow* self)
{
#line 916 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 917 "../src/MainWindow.vala"
	scratch_main_window_set_default_zoom (self);
#line 5028 "MainWindow.c"
}

static void
___lambda138_ (ScratchMainWindow* self)
{
#line 926 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->preferences_dialog);
#line 926 "../src/MainWindow.vala"
	self->priv->preferences_dialog = NULL;
#line 5038 "MainWindow.c"
}

static void
____lambda138__gtk_widget_destroy (GtkWidget* _sender,
                                   gpointer self)
{
#line 925 "../src/MainWindow.vala"
	___lambda138_ ((ScratchMainWindow*) self);
#line 5047 "MainWindow.c"
}

static void
scratch_main_window_action_preferences (ScratchMainWindow* self)
{
	GraniteDialog* _tmp0_;
	GraniteDialog* _tmp5_;
#line 920 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 921 "../src/MainWindow.vala"
	_tmp0_ = self->priv->preferences_dialog;
#line 921 "../src/MainWindow.vala"
	if (_tmp0_ == NULL) {
#line 5061 "MainWindow.c"
		ScratchServicesPluginsManager* _tmp1_;
		ScratchDialogsPreferences* _tmp2_;
		GraniteDialog* _tmp3_;
		GraniteDialog* _tmp4_;
#line 922 "../src/MainWindow.vala"
		_tmp1_ = self->priv->plugins;
#line 922 "../src/MainWindow.vala"
		_tmp2_ = scratch_dialogs_preferences_new ((GtkWindow*) self, _tmp1_);
#line 922 "../src/MainWindow.vala"
		g_object_ref_sink (_tmp2_);
#line 922 "../src/MainWindow.vala"
		_g_object_unref0 (self->priv->preferences_dialog);
#line 922 "../src/MainWindow.vala"
		self->priv->preferences_dialog = (GraniteDialog*) _tmp2_;
#line 923 "../src/MainWindow.vala"
		_tmp3_ = self->priv->preferences_dialog;
#line 923 "../src/MainWindow.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp3_);
#line 925 "../src/MainWindow.vala"
		_tmp4_ = self->priv->preferences_dialog;
#line 925 "../src/MainWindow.vala"
		g_signal_connect_object ((GtkWidget*) _tmp4_, "destroy", (GCallback) ____lambda138__gtk_widget_destroy, self, 0);
#line 5084 "MainWindow.c"
	}
#line 930 "../src/MainWindow.vala"
	_tmp5_ = self->priv->preferences_dialog;
#line 930 "../src/MainWindow.vala"
	gtk_window_present ((GtkWindow*) _tmp5_);
#line 5090 "MainWindow.c"
}

static void
__lambda140_ (ScratchMainWindow* self,
              GObject* obj,
              GAsyncResult* res)
{
#line 935 "../src/MainWindow.vala"
	g_return_if_fail (res != NULL);
#line 936 "../src/MainWindow.vala"
	if (scratch_main_window_check_unsaved_changes_finish (self, res)) {
#line 937 "../src/MainWindow.vala"
		gtk_widget_destroy ((GtkWidget*) self);
#line 5104 "MainWindow.c"
	}
}

static void
___lambda140__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 935 "../src/MainWindow.vala"
	__lambda140_ ((ScratchMainWindow*) self, source_object, res);
#line 935 "../src/MainWindow.vala"
	g_object_unref (self);
#line 5117 "MainWindow.c"
}

static void
scratch_main_window_action_quit (ScratchMainWindow* self)
{
#line 933 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 934 "../src/MainWindow.vala"
	scratch_main_window_handle_quit (self);
#line 935 "../src/MainWindow.vala"
	scratch_main_window_check_unsaved_changes (self, ___lambda140__gasync_ready_callback, g_object_ref (self));
#line 5129 "MainWindow.c"
}

static void
_g_free0_ (gpointer var)
{
#line 967 "../src/MainWindow.vala"
	var = (g_free (var), NULL);
#line 5137 "MainWindow.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 967 "../src/MainWindow.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 5145 "MainWindow.c"
}

static void
scratch_main_window_action_open (ScratchMainWindow* self)
{
	GtkFileFilter* all_files_filter = NULL;
	GtkFileFilter* _tmp0_;
	GtkFileFilter* _tmp1_;
	GtkFileFilter* _tmp2_;
	GtkFileFilter* text_files_filter = NULL;
	GtkFileFilter* _tmp3_;
	GtkFileFilter* _tmp4_;
	GtkFileFilter* _tmp5_;
	GtkFileChooserNative* file_chooser = NULL;
	GtkFileChooserNative* _tmp6_;
	GtkFileChooserNative* _tmp7_;
	GtkFileFilter* _tmp8_;
	GtkFileFilter* _tmp9_;
	GtkFileChooserNative* _tmp10_;
	GtkFileFilter* _tmp11_;
	GtkFileFilter* _tmp12_;
	GtkFileChooserNative* _tmp13_;
	const gchar* _tmp14_ = NULL;
	const gchar* _tmp15_;
	GtkFileChooserNative* _tmp17_;
	gint response = 0;
	GtkFileChooserNative* _tmp18_;
	GtkFileChooserNative* _tmp19_;
#line 942 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 943 "../src/MainWindow.vala"
	_tmp0_ = gtk_file_filter_new ();
#line 943 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 943 "../src/MainWindow.vala"
	all_files_filter = _tmp0_;
#line 944 "../src/MainWindow.vala"
	_tmp1_ = all_files_filter;
#line 944 "../src/MainWindow.vala"
	gtk_file_filter_set_name (_tmp1_, _ ("All files"));
#line 945 "../src/MainWindow.vala"
	_tmp2_ = all_files_filter;
#line 945 "../src/MainWindow.vala"
	gtk_file_filter_add_pattern (_tmp2_, "*");
#line 947 "../src/MainWindow.vala"
	_tmp3_ = gtk_file_filter_new ();
#line 947 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 947 "../src/MainWindow.vala"
	text_files_filter = _tmp3_;
#line 948 "../src/MainWindow.vala"
	_tmp4_ = text_files_filter;
#line 948 "../src/MainWindow.vala"
	gtk_file_filter_set_name (_tmp4_, _ ("Text files"));
#line 949 "../src/MainWindow.vala"
	_tmp5_ = text_files_filter;
#line 949 "../src/MainWindow.vala"
	gtk_file_filter_add_mime_type (_tmp5_, "text/*");
#line 951 "../src/MainWindow.vala"
	_tmp6_ = gtk_file_chooser_native_new (_ ("Open some files"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("Open"), _ ("Cancel"));
#line 951 "../src/MainWindow.vala"
	file_chooser = _tmp6_;
#line 958 "../src/MainWindow.vala"
	_tmp7_ = file_chooser;
#line 958 "../src/MainWindow.vala"
	_tmp8_ = text_files_filter;
#line 958 "../src/MainWindow.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 958 "../src/MainWindow.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp7_, _tmp9_);
#line 959 "../src/MainWindow.vala"
	_tmp10_ = file_chooser;
#line 959 "../src/MainWindow.vala"
	_tmp11_ = all_files_filter;
#line 959 "../src/MainWindow.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 959 "../src/MainWindow.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp10_, _tmp12_);
#line 960 "../src/MainWindow.vala"
	_tmp13_ = file_chooser;
#line 960 "../src/MainWindow.vala"
	gtk_file_chooser_set_select_multiple ((GtkFileChooser*) _tmp13_, TRUE);
#line 961 "../src/MainWindow.vala"
	_tmp15_ = scratch_utils_last_path;
#line 961 "../src/MainWindow.vala"
	_tmp14_ = _tmp15_;
#line 961 "../src/MainWindow.vala"
	if (_tmp14_ == NULL) {
#line 5234 "MainWindow.c"
		const gchar* _tmp16_;
#line 961 "../src/MainWindow.vala"
		_tmp16_ = g_get_home_dir ();
#line 961 "../src/MainWindow.vala"
		_tmp14_ = _tmp16_;
#line 5240 "MainWindow.c"
	}
#line 961 "../src/MainWindow.vala"
	_tmp17_ = file_chooser;
#line 961 "../src/MainWindow.vala"
	gtk_file_chooser_set_current_folder_uri ((GtkFileChooser*) _tmp17_, _tmp14_);
#line 963 "../src/MainWindow.vala"
	_tmp18_ = file_chooser;
#line 963 "../src/MainWindow.vala"
	response = gtk_native_dialog_run ((GtkNativeDialog*) _tmp18_);
#line 964 "../src/MainWindow.vala"
	_tmp19_ = file_chooser;
#line 964 "../src/MainWindow.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp19_);
#line 966 "../src/MainWindow.vala"
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 5256 "MainWindow.c"
		GtkFileChooserNative* _tmp20_;
		GSList* _tmp21_;
#line 967 "../src/MainWindow.vala"
		_tmp20_ = file_chooser;
#line 967 "../src/MainWindow.vala"
		_tmp21_ = gtk_file_chooser_get_uris ((GtkFileChooser*) _tmp20_);
#line 5263 "MainWindow.c"
		{
			GSList* uri_collection = NULL;
			GSList* uri_it = NULL;
#line 967 "../src/MainWindow.vala"
			uri_collection = _tmp21_;
#line 967 "../src/MainWindow.vala"
			for (uri_it = uri_collection; uri_it != NULL; uri_it = uri_it->next) {
#line 5271 "MainWindow.c"
				gchar* _tmp22_;
				gchar* uri = NULL;
#line 967 "../src/MainWindow.vala"
				_tmp22_ = g_strdup ((const gchar*) uri_it->data);
#line 967 "../src/MainWindow.vala"
				uri = _tmp22_;
#line 5278 "MainWindow.c"
				{
					const gchar* _tmp23_;
					gchar* _tmp24_;
					GFile* file = NULL;
					const gchar* _tmp25_;
					GFile* _tmp26_;
					ScratchServicesDocument* doc = NULL;
					GSimpleActionGroup* _tmp27_;
					GFile* _tmp28_;
					ScratchServicesDocument* _tmp29_;
					ScratchServicesDocument* _tmp30_;
#line 969 "../src/MainWindow.vala"
					_tmp23_ = uri;
#line 969 "../src/MainWindow.vala"
					_tmp24_ = g_path_get_dirname (_tmp23_);
#line 969 "../src/MainWindow.vala"
					_g_free0 (scratch_utils_last_path);
#line 969 "../src/MainWindow.vala"
					scratch_utils_last_path = _tmp24_;
#line 971 "../src/MainWindow.vala"
					_tmp25_ = uri;
#line 971 "../src/MainWindow.vala"
					_tmp26_ = g_file_new_for_uri (_tmp25_);
#line 971 "../src/MainWindow.vala"
					file = _tmp26_;
#line 972 "../src/MainWindow.vala"
					_tmp27_ = self->priv->_actions;
#line 972 "../src/MainWindow.vala"
					_tmp28_ = file;
#line 972 "../src/MainWindow.vala"
					_tmp29_ = scratch_services_document_new (_tmp27_, _tmp28_);
#line 972 "../src/MainWindow.vala"
					g_object_ref_sink (_tmp29_);
#line 972 "../src/MainWindow.vala"
					doc = _tmp29_;
#line 973 "../src/MainWindow.vala"
					_tmp30_ = doc;
#line 973 "../src/MainWindow.vala"
					scratch_main_window_open_document (self, _tmp30_, TRUE, 0);
#line 967 "../src/MainWindow.vala"
					_g_object_unref0 (doc);
#line 967 "../src/MainWindow.vala"
					_g_object_unref0 (file);
#line 967 "../src/MainWindow.vala"
					_g_free0 (uri);
#line 5324 "MainWindow.c"
				}
			}
#line 967 "../src/MainWindow.vala"
			(uri_collection == NULL) ? NULL : (uri_collection = (_g_slist_free__g_free0_ (uri_collection), NULL));
#line 5329 "MainWindow.c"
		}
	}
#line 942 "../src/MainWindow.vala"
	_g_object_unref0 (file_chooser);
#line 942 "../src/MainWindow.vala"
	_g_object_unref0 (text_files_filter);
#line 942 "../src/MainWindow.vala"
	_g_object_unref0 (all_files_filter);
#line 5338 "MainWindow.c"
}

static void
____lambda137_ (ScratchMainWindow* self,
                GFile* glib_file)
{
	ScratchFolderManagerFile* foldermanager_file = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	ScratchFolderManagerFile* _tmp2_;
	ScratchFolderManagerFile* _tmp3_;
	ScratchFolderManagerFileView* _tmp4_;
#line 990 "../src/MainWindow.vala"
	g_return_if_fail (glib_file != NULL);
#line 991 "../src/MainWindow.vala"
	_tmp0_ = g_file_get_path (glib_file);
#line 991 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 991 "../src/MainWindow.vala"
	_tmp2_ = scratch_folder_manager_file_new (_tmp1_);
#line 991 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 991 "../src/MainWindow.vala"
	_g_free0 (_tmp1_);
#line 991 "../src/MainWindow.vala"
	foldermanager_file = _tmp3_;
#line 992 "../src/MainWindow.vala"
	_tmp4_ = self->priv->folder_manager_view;
#line 992 "../src/MainWindow.vala"
	scratch_folder_manager_file_view_open_folder (_tmp4_, foldermanager_file);
#line 990 "../src/MainWindow.vala"
	_g_object_unref0 (foldermanager_file);
#line 5371 "MainWindow.c"
}

static void
_____lambda137__gfunc (gconstpointer data,
                       gpointer self)
{
#line 990 "../src/MainWindow.vala"
	____lambda137_ ((ScratchMainWindow*) self, (GFile*) data);
#line 5380 "MainWindow.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 990 "../src/MainWindow.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 5388 "MainWindow.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 990 "../src/MainWindow.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 5396 "MainWindow.c"
}

static void
scratch_main_window_action_open_folder (ScratchMainWindow* self,
                                        GSimpleAction* action,
                                        GVariant* param)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 978 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 978 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 979 "../src/MainWindow.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 979 "../src/MainWindow.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 979 "../src/MainWindow.vala"
	path = _tmp1_;
#line 980 "../src/MainWindow.vala"
	_tmp2_ = path;
#line 980 "../src/MainWindow.vala"
	if (g_strcmp0 (_tmp2_, "") == 0) {
#line 5422 "MainWindow.c"
		GtkFileChooserNative* chooser = NULL;
		GtkFileChooserNative* _tmp3_;
		GtkFileChooserNative* _tmp4_;
		GtkFileChooserNative* _tmp5_;
		GtkFileChooserNative* _tmp9_;
#line 981 "../src/MainWindow.vala"
		_tmp3_ = gtk_file_chooser_native_new ("Select a folder.", (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, _ ("_Open"), _ ("_Cancel"));
#line 981 "../src/MainWindow.vala"
		chooser = _tmp3_;
#line 987 "../src/MainWindow.vala"
		_tmp4_ = chooser;
#line 987 "../src/MainWindow.vala"
		gtk_file_chooser_set_select_multiple ((GtkFileChooser*) _tmp4_, TRUE);
#line 989 "../src/MainWindow.vala"
		_tmp5_ = chooser;
#line 989 "../src/MainWindow.vala"
		if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp5_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 5440 "MainWindow.c"
			GtkFileChooserNative* _tmp6_;
			GSList* _tmp7_;
			GSList* _tmp8_;
#line 990 "../src/MainWindow.vala"
			_tmp6_ = chooser;
#line 990 "../src/MainWindow.vala"
			_tmp7_ = gtk_file_chooser_get_files ((GtkFileChooser*) _tmp6_);
#line 990 "../src/MainWindow.vala"
			_tmp8_ = _tmp7_;
#line 990 "../src/MainWindow.vala"
			g_slist_foreach (_tmp8_, _____lambda137__gfunc, self);
#line 990 "../src/MainWindow.vala"
			(_tmp8_ == NULL) ? NULL : (_tmp8_ = (_g_slist_free__g_object_unref0_ (_tmp8_), NULL));
#line 5454 "MainWindow.c"
		}
#line 996 "../src/MainWindow.vala"
		_tmp9_ = chooser;
#line 996 "../src/MainWindow.vala"
		gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp9_);
#line 980 "../src/MainWindow.vala"
		_g_object_unref0 (chooser);
#line 5462 "MainWindow.c"
	} else {
		ScratchFolderManagerFileView* _tmp10_;
		const gchar* _tmp11_;
		ScratchFolderManagerFile* _tmp12_;
		ScratchFolderManagerFile* _tmp13_;
#line 998 "../src/MainWindow.vala"
		_tmp10_ = self->priv->folder_manager_view;
#line 998 "../src/MainWindow.vala"
		_tmp11_ = path;
#line 998 "../src/MainWindow.vala"
		_tmp12_ = scratch_folder_manager_file_new (_tmp11_);
#line 998 "../src/MainWindow.vala"
		_tmp13_ = _tmp12_;
#line 998 "../src/MainWindow.vala"
		scratch_folder_manager_file_view_open_folder (_tmp10_, _tmp13_);
#line 998 "../src/MainWindow.vala"
		_g_object_unref0 (_tmp13_);
#line 5480 "MainWindow.c"
	}
#line 978 "../src/MainWindow.vala"
	_g_free0 (path);
#line 5484 "MainWindow.c"
}

static void
scratch_main_window_action_collapse_all_folders (ScratchMainWindow* self)
{
	ScratchFolderManagerFileView* _tmp0_;
#line 1002 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1003 "../src/MainWindow.vala"
	_tmp0_ = self->priv->folder_manager_view;
#line 1003 "../src/MainWindow.vala"
	scratch_folder_manager_file_view_collapse_all (_tmp0_);
#line 5497 "MainWindow.c"
}

static void
scratch_main_window_action_order_folders (ScratchMainWindow* self)
{
	ScratchFolderManagerFileView* _tmp0_;
#line 1006 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1007 "../src/MainWindow.vala"
	_tmp0_ = self->priv->folder_manager_view;
#line 1007 "../src/MainWindow.vala"
	scratch_folder_manager_file_view_order_folders (_tmp0_);
#line 5510 "MainWindow.c"
}

static void
scratch_main_window_action_save (ScratchMainWindow* self)
{
	ScratchServicesDocument* doc = NULL;
	ScratchServicesDocument* _tmp0_;
	ScratchServicesDocument* _tmp1_;
#line 1010 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1011 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_current_document (self);
#line 1011 "../src/MainWindow.vala"
	doc = _tmp0_;
#line 1012 "../src/MainWindow.vala"
	_tmp1_ = doc;
#line 1012 "../src/MainWindow.vala"
	if (_tmp1_ != NULL) {
#line 5529 "MainWindow.c"
		ScratchServicesDocument* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 1013 "../src/MainWindow.vala"
		_tmp2_ = doc;
#line 1013 "../src/MainWindow.vala"
		_tmp3_ = scratch_services_document_get_is_file_temporary (_tmp2_);
#line 1013 "../src/MainWindow.vala"
		_tmp4_ = _tmp3_;
#line 1013 "../src/MainWindow.vala"
		if (_tmp4_ == TRUE) {
#line 1014 "../src/MainWindow.vala"
			scratch_main_window_action_save_as (self);
#line 5543 "MainWindow.c"
		} else {
			ScratchServicesDocument* _tmp5_;
#line 1016 "../src/MainWindow.vala"
			_tmp5_ = doc;
#line 1016 "../src/MainWindow.vala"
			scratch_services_document_save_request (_tmp5_);
#line 5550 "MainWindow.c"
		}
	}
#line 1010 "../src/MainWindow.vala"
	_g_object_unref0 (doc);
#line 5555 "MainWindow.c"
}

static void
scratch_main_window_action_save_as (ScratchMainWindow* self)
{
	ScratchServicesDocument* doc = NULL;
	ScratchServicesDocument* _tmp0_;
	ScratchServicesDocument* _tmp1_;
#line 1021 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1022 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_current_document (self);
#line 1022 "../src/MainWindow.vala"
	doc = _tmp0_;
#line 1023 "../src/MainWindow.vala"
	_tmp1_ = doc;
#line 1023 "../src/MainWindow.vala"
	if (_tmp1_ != NULL) {
#line 5574 "MainWindow.c"
		ScratchServicesDocument* _tmp2_;
#line 1024 "../src/MainWindow.vala"
		_tmp2_ = doc;
#line 1024 "../src/MainWindow.vala"
		scratch_services_document_save_as_with_hold (_tmp2_, NULL, NULL);
#line 5580 "MainWindow.c"
	}
#line 1021 "../src/MainWindow.vala"
	_g_object_unref0 (doc);
#line 5584 "MainWindow.c"
}

static void
scratch_main_window_action_undo (ScratchMainWindow* self)
{
	ScratchServicesDocument* doc = NULL;
	ScratchServicesDocument* _tmp0_;
	ScratchServicesDocument* _tmp1_;
#line 1028 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1029 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_current_document (self);
#line 1029 "../src/MainWindow.vala"
	doc = _tmp0_;
#line 1030 "../src/MainWindow.vala"
	_tmp1_ = doc;
#line 1030 "../src/MainWindow.vala"
	if (_tmp1_ != NULL) {
#line 5603 "MainWindow.c"
		ScratchServicesDocument* _tmp2_;
#line 1031 "../src/MainWindow.vala"
		_tmp2_ = doc;
#line 1031 "../src/MainWindow.vala"
		scratch_services_document_undo (_tmp2_);
#line 5609 "MainWindow.c"
	}
#line 1028 "../src/MainWindow.vala"
	_g_object_unref0 (doc);
#line 5613 "MainWindow.c"
}

static void
scratch_main_window_action_redo (ScratchMainWindow* self)
{
	ScratchServicesDocument* doc = NULL;
	ScratchServicesDocument* _tmp0_;
	ScratchServicesDocument* _tmp1_;
#line 1035 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1036 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_current_document (self);
#line 1036 "../src/MainWindow.vala"
	doc = _tmp0_;
#line 1037 "../src/MainWindow.vala"
	_tmp1_ = doc;
#line 1037 "../src/MainWindow.vala"
	if (_tmp1_ != NULL) {
#line 5632 "MainWindow.c"
		ScratchServicesDocument* _tmp2_;
#line 1038 "../src/MainWindow.vala"
		_tmp2_ = doc;
#line 1038 "../src/MainWindow.vala"
		scratch_services_document_redo (_tmp2_);
#line 5638 "MainWindow.c"
	}
#line 1035 "../src/MainWindow.vala"
	_g_object_unref0 (doc);
#line 5642 "MainWindow.c"
}

static void
scratch_main_window_action_revert (ScratchMainWindow* self)
{
	ScratchDialogsRestoreConfirmationDialog* confirmation_dialog = NULL;
	ScratchDialogsRestoreConfirmationDialog* _tmp0_;
	ScratchDialogsRestoreConfirmationDialog* _tmp1_;
	ScratchDialogsRestoreConfirmationDialog* _tmp5_;
#line 1042 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1043 "../src/MainWindow.vala"
	_tmp0_ = scratch_dialogs_restore_confirmation_dialog_new (self);
#line 1043 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 1043 "../src/MainWindow.vala"
	confirmation_dialog = _tmp0_;
#line 1044 "../src/MainWindow.vala"
	_tmp1_ = confirmation_dialog;
#line 1044 "../src/MainWindow.vala"
	if (gtk_dialog_run ((GtkDialog*) _tmp1_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 5664 "MainWindow.c"
		ScratchServicesDocument* doc = NULL;
		ScratchServicesDocument* _tmp2_;
		ScratchServicesDocument* _tmp3_;
#line 1045 "../src/MainWindow.vala"
		_tmp2_ = scratch_main_window_get_current_document (self);
#line 1045 "../src/MainWindow.vala"
		doc = _tmp2_;
#line 1046 "../src/MainWindow.vala"
		_tmp3_ = doc;
#line 1046 "../src/MainWindow.vala"
		if (_tmp3_ != NULL) {
#line 5676 "MainWindow.c"
			ScratchServicesDocument* _tmp4_;
#line 1047 "../src/MainWindow.vala"
			_tmp4_ = doc;
#line 1047 "../src/MainWindow.vala"
			scratch_services_document_revert (_tmp4_);
#line 5682 "MainWindow.c"
		}
#line 1044 "../src/MainWindow.vala"
		_g_object_unref0 (doc);
#line 5686 "MainWindow.c"
	}
#line 1050 "../src/MainWindow.vala"
	_tmp5_ = confirmation_dialog;
#line 1050 "../src/MainWindow.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp5_);
#line 1042 "../src/MainWindow.vala"
	_g_object_unref0 (confirmation_dialog);
#line 5694 "MainWindow.c"
}

static void
scratch_main_window_action_duplicate (ScratchMainWindow* self)
{
	ScratchServicesDocument* doc = NULL;
	ScratchServicesDocument* _tmp0_;
	ScratchServicesDocument* _tmp1_;
#line 1053 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1054 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_current_document (self);
#line 1054 "../src/MainWindow.vala"
	doc = _tmp0_;
#line 1055 "../src/MainWindow.vala"
	_tmp1_ = doc;
#line 1055 "../src/MainWindow.vala"
	if (_tmp1_ != NULL) {
#line 5713 "MainWindow.c"
		ScratchServicesDocument* _tmp2_;
#line 1056 "../src/MainWindow.vala"
		_tmp2_ = doc;
#line 1056 "../src/MainWindow.vala"
		scratch_services_document_duplicate_selection (_tmp2_);
#line 5719 "MainWindow.c"
	}
#line 1053 "../src/MainWindow.vala"
	_g_object_unref0 (doc);
#line 5723 "MainWindow.c"
}

static void
scratch_main_window_action_new_tab (ScratchMainWindow* self)
{
	ScratchWidgetsDocumentView* _tmp0_;
#line 1060 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1061 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 1061 "../src/MainWindow.vala"
	scratch_widgets_document_view_new_document (_tmp0_);
#line 5736 "MainWindow.c"
}

static void
scratch_main_window_action_new_tab_from_clipboard (ScratchMainWindow* self)
{
	gchar* text_from_clipboard = NULL;
	GtkClipboard* _tmp0_;
	gchar* _tmp1_;
	ScratchWidgetsDocumentView* _tmp2_;
#line 1064 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1065 "../src/MainWindow.vala"
	_tmp0_ = self->clipboard;
#line 1065 "../src/MainWindow.vala"
	_tmp1_ = gtk_clipboard_wait_for_text (_tmp0_);
#line 1065 "../src/MainWindow.vala"
	text_from_clipboard = _tmp1_;
#line 1066 "../src/MainWindow.vala"
	_tmp2_ = self->document_view;
#line 1066 "../src/MainWindow.vala"
	scratch_widgets_document_view_new_document_from_clipboard (_tmp2_, text_from_clipboard);
#line 1064 "../src/MainWindow.vala"
	_g_free0 (text_from_clipboard);
#line 5760 "MainWindow.c"
}

static void
scratch_main_window_action_fullscreen (ScratchMainWindow* self)
{
	GdkWindow* _tmp0_;
#line 1069 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1070 "../src/MainWindow.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 1070 "../src/MainWindow.vala"
	if ((gdk_window_get_state (_tmp0_) & GDK_WINDOW_STATE_FULLSCREEN) == GDK_WINDOW_STATE_FULLSCREEN) {
#line 1071 "../src/MainWindow.vala"
		gtk_window_unfullscreen ((GtkWindow*) self);
#line 5775 "MainWindow.c"
	} else {
#line 1073 "../src/MainWindow.vala"
		gtk_window_fullscreen ((GtkWindow*) self);
#line 5779 "MainWindow.c"
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 1077 "../src/MainWindow.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 1077 "../src/MainWindow.vala"
	return _data4_;
#line 5790 "MainWindow.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 1077 "../src/MainWindow.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 5800 "MainWindow.c"
		ScratchMainWindow* self;
#line 1077 "../src/MainWindow.vala"
		self = _data4_->self;
#line 1077 "../src/MainWindow.vala"
		_g_free0 (_data4_->close_path);
#line 1077 "../src/MainWindow.vala"
		_g_object_unref0 (self);
#line 1077 "../src/MainWindow.vala"
		g_slice_free (Block4Data, _data4_);
#line 5810 "MainWindow.c"
	}
}

static void
__lambda141_ (Block4Data* _data4_,
              ScratchServicesDocument* doc)
{
	ScratchMainWindow* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gboolean _tmp5_;
#line 1089 "../src/MainWindow.vala"
	self = _data4_->self;
#line 1089 "../src/MainWindow.vala"
	g_return_if_fail (doc != NULL);
#line 1090 "../src/MainWindow.vala"
	_tmp0_ = scratch_services_document_get_file (doc);
#line 1090 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 1090 "../src/MainWindow.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 1090 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 1090 "../src/MainWindow.vala"
	_tmp4_ = _data4_->close_path;
#line 1090 "../src/MainWindow.vala"
	_tmp5_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
#line 1090 "../src/MainWindow.vala"
	_g_free0 (_tmp3_);
#line 1090 "../src/MainWindow.vala"
	if (_tmp5_) {
#line 5845 "MainWindow.c"
		ScratchWidgetsDocumentView* _tmp6_;
#line 1091 "../src/MainWindow.vala"
		_tmp6_ = self->document_view;
#line 1091 "../src/MainWindow.vala"
		scratch_widgets_document_view_close_document (_tmp6_, doc);
#line 5851 "MainWindow.c"
	}
}

static void
___lambda141__gfunc (gconstpointer data,
                     gpointer self)
{
#line 1089 "../src/MainWindow.vala"
	__lambda141_ (self, (ScratchServicesDocument*) data);
#line 5861 "MainWindow.c"
}

static void
scratch_main_window_action_close_tab (ScratchMainWindow* self,
                                      GSimpleAction* action,
                                      GVariant* param)
{
	Block4Data* _data4_;
	gchar* _tmp0_;
	const gchar* _tmp3_;
	GList* docs = NULL;
	ScratchWidgetsDocumentView* _tmp5_;
	GList* _tmp6_;
	GList* _tmp7_;
#line 1077 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1077 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 1077 "../src/MainWindow.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 1077 "../src/MainWindow.vala"
	_data4_->_ref_count_ = 1;
#line 1077 "../src/MainWindow.vala"
	_data4_->self = g_object_ref (self);
#line 1078 "../src/MainWindow.vala"
	_tmp0_ = g_strdup ("");
#line 1078 "../src/MainWindow.vala"
	_data4_->close_path = _tmp0_;
#line 1079 "../src/MainWindow.vala"
	if (param != NULL) {
#line 5892 "MainWindow.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 1080 "../src/MainWindow.vala"
		_tmp1_ = g_variant_get_string (param, NULL);
#line 1080 "../src/MainWindow.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 1080 "../src/MainWindow.vala"
		_g_free0 (_data4_->close_path);
#line 1080 "../src/MainWindow.vala"
		_data4_->close_path = _tmp2_;
#line 5903 "MainWindow.c"
	}
#line 1083 "../src/MainWindow.vala"
	_tmp3_ = _data4_->close_path;
#line 1083 "../src/MainWindow.vala"
	if (g_strcmp0 (_tmp3_, "") == 0) {
#line 5909 "MainWindow.c"
		ScratchWidgetsDocumentView* _tmp4_;
#line 1084 "../src/MainWindow.vala"
		_tmp4_ = self->document_view;
#line 1084 "../src/MainWindow.vala"
		scratch_widgets_document_view_close_document (_tmp4_, NULL);
#line 1085 "../src/MainWindow.vala"
		block4_data_unref (_data4_);
#line 1085 "../src/MainWindow.vala"
		_data4_ = NULL;
#line 1085 "../src/MainWindow.vala"
		return;
#line 5921 "MainWindow.c"
	}
#line 1088 "../src/MainWindow.vala"
	_tmp5_ = self->document_view;
#line 1088 "../src/MainWindow.vala"
	_tmp6_ = _tmp5_->docs;
#line 1088 "../src/MainWindow.vala"
	docs = _tmp6_;
#line 1089 "../src/MainWindow.vala"
	_tmp7_ = docs;
#line 1089 "../src/MainWindow.vala"
	g_list_foreach (_tmp7_, ___lambda141__gfunc, _data4_);
#line 1077 "../src/MainWindow.vala"
	block4_data_unref (_data4_);
#line 1077 "../src/MainWindow.vala"
	_data4_ = NULL;
#line 5937 "MainWindow.c"
}

static void
scratch_main_window_action_duplicate_tab (ScratchMainWindow* self)
{
	ScratchWidgetsDocumentView* _tmp0_;
#line 1096 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1097 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 1097 "../src/MainWindow.vala"
	scratch_widgets_document_view_duplicate_tab (_tmp0_);
#line 5950 "MainWindow.c"
}

static void
scratch_main_window_action_close_tabs_to_right (ScratchMainWindow* self)
{
	ScratchWidgetsDocumentView* _tmp0_;
#line 1100 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1101 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 1101 "../src/MainWindow.vala"
	scratch_widgets_document_view_close_tabs_to_right (_tmp0_);
#line 5963 "MainWindow.c"
}

static void
scratch_main_window_action_close_other_tabs (ScratchMainWindow* self)
{
	ScratchWidgetsDocumentView* _tmp0_;
#line 1104 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1105 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 1105 "../src/MainWindow.vala"
	scratch_widgets_document_view_close_other_tabs (_tmp0_);
#line 5976 "MainWindow.c"
}

static void
scratch_main_window_action_hide_project_docs (ScratchMainWindow* self,
                                              GSimpleAction* action,
                                              GVariant* param)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1108 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1108 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 1109 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_target_path_for_actions (self, param, FALSE);
#line 1109 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 1109 "../src/MainWindow.vala"
	scratch_main_window_close_project_docs (self, _tmp1_, TRUE);
#line 1109 "../src/MainWindow.vala"
	_g_free0 (_tmp1_);
#line 5998 "MainWindow.c"
}

static void
scratch_main_window_action_close_project_docs (ScratchMainWindow* self,
                                               GSimpleAction* action,
                                               GVariant* param)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1112 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1112 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 1113 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_target_path_for_actions (self, param, FALSE);
#line 1113 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 1113 "../src/MainWindow.vala"
	scratch_main_window_close_project_docs (self, _tmp1_, FALSE);
#line 1113 "../src/MainWindow.vala"
	_g_free0 (_tmp1_);
#line 6020 "MainWindow.c"
}

static void
scratch_main_window_action_restore_project_docs (ScratchMainWindow* self,
                                                 GSimpleAction* action,
                                                 GVariant* param)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1116 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1116 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 1117 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_target_path_for_actions (self, param, FALSE);
#line 1117 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 1117 "../src/MainWindow.vala"
	scratch_main_window_restore_project_docs (self, _tmp1_);
#line 1117 "../src/MainWindow.vala"
	_g_free0 (_tmp1_);
#line 6042 "MainWindow.c"
}

static void
scratch_main_window_action_restore_closed_tab (ScratchMainWindow* self,
                                               GSimpleAction* action,
                                               GVariant* param)
{
	ScratchWidgetsDocumentView* _tmp0_;
	const gchar* _tmp1_;
#line 1120 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1120 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 1121 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 1121 "../src/MainWindow.vala"
	_tmp1_ = g_variant_get_string (param, NULL);
#line 1121 "../src/MainWindow.vala"
	scratch_widgets_document_view_restore_closed_tab (_tmp0_, _tmp1_);
#line 6062 "MainWindow.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 1124 "../src/MainWindow.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 1124 "../src/MainWindow.vala"
	return _data5_;
#line 6072 "MainWindow.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 1124 "../src/MainWindow.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 6082 "MainWindow.c"
		ScratchMainWindow* self;
#line 1124 "../src/MainWindow.vala"
		self = _data5_->self;
#line 1124 "../src/MainWindow.vala"
		_g_free0 (_data5_->project_path);
#line 1124 "../src/MainWindow.vala"
		_g_object_unref0 (self);
#line 1124 "../src/MainWindow.vala"
		g_slice_free (Block5Data, _data5_);
#line 6092 "MainWindow.c"
	}
}

static void
__lambda142_ (Block5Data* _data5_,
              ScratchServicesDocument* doc)
{
	ScratchMainWindow* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
#line 1126 "../src/MainWindow.vala"
	self = _data5_->self;
#line 1126 "../src/MainWindow.vala"
	g_return_if_fail (doc != NULL);
#line 1127 "../src/MainWindow.vala"
	_tmp0_ = scratch_services_document_get_file (doc);
#line 1127 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 1127 "../src/MainWindow.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 1127 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 1127 "../src/MainWindow.vala"
	_tmp4_ = g_strconcat (_data5_->project_path, G_DIR_SEPARATOR_S, NULL);
#line 1127 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 1127 "../src/MainWindow.vala"
	_tmp6_ = g_str_has_prefix (_tmp3_, _tmp5_);
#line 1127 "../src/MainWindow.vala"
	_g_free0 (_tmp5_);
#line 1127 "../src/MainWindow.vala"
	_g_free0 (_tmp3_);
#line 1127 "../src/MainWindow.vala"
	if (_tmp6_) {
#line 6132 "MainWindow.c"
		ScratchWidgetsDocumentView* _tmp7_;
#line 1128 "../src/MainWindow.vala"
		_tmp7_ = self->document_view;
#line 1128 "../src/MainWindow.vala"
		scratch_widgets_document_view_close_document (_tmp7_, doc);
#line 1129 "../src/MainWindow.vala"
		if (_data5_->make_restorable) {
#line 6140 "MainWindow.c"
			ScratchServicesDocumentManager* _tmp8_;
#line 1130 "../src/MainWindow.vala"
			_tmp8_ = self->priv->document_manager;
#line 1130 "../src/MainWindow.vala"
			scratch_services_document_manager_make_restorable (_tmp8_, doc);
#line 6146 "MainWindow.c"
		}
	}
}

static void
___lambda142__gfunc (gconstpointer data,
                     gpointer self)
{
#line 1126 "../src/MainWindow.vala"
	__lambda142_ (self, (ScratchServicesDocument*) data);
#line 6157 "MainWindow.c"
}

static void
scratch_main_window_close_project_docs (ScratchMainWindow* self,
                                        const gchar* project_path,
                                        gboolean make_restorable)
{
	Block5Data* _data5_;
	gchar* _tmp0_;
	GList* docs = NULL;
	ScratchWidgetsDocumentView* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
#line 1124 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1124 "../src/MainWindow.vala"
	g_return_if_fail (project_path != NULL);
#line 1124 "../src/MainWindow.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 1124 "../src/MainWindow.vala"
	_data5_->_ref_count_ = 1;
#line 1124 "../src/MainWindow.vala"
	_data5_->self = g_object_ref (self);
#line 1124 "../src/MainWindow.vala"
	_tmp0_ = g_strdup (project_path);
#line 1124 "../src/MainWindow.vala"
	_g_free0 (_data5_->project_path);
#line 1124 "../src/MainWindow.vala"
	_data5_->project_path = _tmp0_;
#line 1124 "../src/MainWindow.vala"
	_data5_->make_restorable = make_restorable;
#line 1125 "../src/MainWindow.vala"
	_tmp1_ = self->document_view;
#line 1125 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_->docs;
#line 1125 "../src/MainWindow.vala"
	docs = _tmp2_;
#line 1126 "../src/MainWindow.vala"
	_tmp3_ = docs;
#line 1126 "../src/MainWindow.vala"
	g_list_foreach (_tmp3_, ___lambda142__gfunc, _data5_);
#line 1135 "../src/MainWindow.vala"
	if (!_data5_->make_restorable) {
#line 6201 "MainWindow.c"
		ScratchServicesDocumentManager* _tmp4_;
#line 1136 "../src/MainWindow.vala"
		_tmp4_ = self->priv->document_manager;
#line 1136 "../src/MainWindow.vala"
		scratch_services_document_manager_remove_project (_tmp4_, _data5_->project_path);
#line 6207 "MainWindow.c"
	}
#line 1124 "../src/MainWindow.vala"
	block5_data_unref (_data5_);
#line 1124 "../src/MainWindow.vala"
	_data5_ = NULL;
#line 6213 "MainWindow.c"
}

static gboolean
__lambda143_ (ScratchMainWindow* self,
              gchar* doc_path)
{
	ScratchServicesDocument* doc = NULL;
	GSimpleActionGroup* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	ScratchServicesDocument* _tmp3_;
	ScratchServicesDocument* _tmp4_;
	gboolean result;
#line 1141 "../src/MainWindow.vala"
	g_return_val_if_fail (doc_path != NULL, FALSE);
#line 1142 "../src/MainWindow.vala"
	_tmp0_ = self->priv->_actions;
#line 1142 "../src/MainWindow.vala"
	_tmp1_ = g_file_new_for_path (doc_path);
#line 1142 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 1142 "../src/MainWindow.vala"
	_tmp3_ = scratch_services_document_new (_tmp0_, _tmp2_);
#line 1142 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 1142 "../src/MainWindow.vala"
	_tmp4_ = _tmp3_;
#line 1142 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp2_);
#line 1142 "../src/MainWindow.vala"
	doc = _tmp4_;
#line 1143 "../src/MainWindow.vala"
	scratch_main_window_open_document (self, doc, TRUE, 0);
#line 1144 "../src/MainWindow.vala"
	result = TRUE;
#line 1144 "../src/MainWindow.vala"
	_g_object_unref0 (doc);
#line 1144 "../src/MainWindow.vala"
	_g_free0 (doc_path);
#line 1144 "../src/MainWindow.vala"
	return result;
#line 6255 "MainWindow.c"
}

static gboolean
___lambda143__gee_forall_func (gpointer g,
                               gpointer self)
{
	gboolean result;
	result = __lambda143_ ((ScratchMainWindow*) self, (gchar*) g);
#line 1141 "../src/MainWindow.vala"
	return result;
#line 6266 "MainWindow.c"
}

static void
scratch_main_window_restore_project_docs (ScratchMainWindow* self,
                                          const gchar* project_path)
{
	ScratchServicesDocumentManager* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
#line 1140 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1140 "../src/MainWindow.vala"
	g_return_if_fail (project_path != NULL);
#line 1141 "../src/MainWindow.vala"
	_tmp0_ = self->priv->document_manager;
#line 1141 "../src/MainWindow.vala"
	_tmp1_ = scratch_services_document_manager_take_restorable_paths (_tmp0_, project_path);
#line 1141 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 1141 "../src/MainWindow.vala"
	gee_traversable_foreach ((GeeTraversable*) _tmp2_, ___lambda143__gee_forall_func, self);
#line 1141 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp2_);
#line 6290 "MainWindow.c"
}

static GVariant*
_variant_new2 (gboolean value)
{
#line 1158 "../src/MainWindow.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 6298 "MainWindow.c"
}

static void
scratch_main_window_action_fetch (ScratchMainWindow* self,
                                  GSimpleAction* action,
                                  GVariant* param)
{
	const gchar* _tmp0_ = NULL;
	gchar* _tmp2_;
	GtkRevealer* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 1150 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1150 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 1151 "../src/MainWindow.vala"
	if (param != NULL) {
#line 6317 "MainWindow.c"
		const gchar* _tmp1_;
#line 1151 "../src/MainWindow.vala"
		_tmp1_ = g_variant_get_string (param, NULL);
#line 1151 "../src/MainWindow.vala"
		_tmp0_ = _tmp1_;
#line 6323 "MainWindow.c"
	} else {
#line 1151 "../src/MainWindow.vala"
		_tmp0_ = "";
#line 6327 "MainWindow.c"
	}
#line 1151 "../src/MainWindow.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 1151 "../src/MainWindow.vala"
	_g_free0 (self->priv->current_search_term);
#line 1151 "../src/MainWindow.vala"
	self->priv->current_search_term = _tmp2_;
#line 1152 "../src/MainWindow.vala"
	_tmp3_ = self->priv->search_revealer;
#line 1152 "../src/MainWindow.vala"
	_tmp4_ = gtk_revealer_get_child_revealed (_tmp3_);
#line 1152 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 1152 "../src/MainWindow.vala"
	if (!_tmp5_) {
#line 6343 "MainWindow.c"
		GSimpleAction* show_find_action = NULL;
		GSimpleActionGroup* _tmp6_;
		GSimpleAction* _tmp7_;
		GSimpleAction* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 1153 "../src/MainWindow.vala"
		_tmp6_ = self->priv->_actions;
#line 1153 "../src/MainWindow.vala"
		_tmp7_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_SHOW_FIND, _tmp6_);
#line 1153 "../src/MainWindow.vala"
		show_find_action = _tmp7_;
#line 1154 "../src/MainWindow.vala"
		_tmp8_ = show_find_action;
#line 1154 "../src/MainWindow.vala"
		_tmp9_ = g_action_get_enabled ((GAction*) _tmp8_);
#line 1154 "../src/MainWindow.vala"
		_tmp10_ = _tmp9_;
#line 1154 "../src/MainWindow.vala"
		if (_tmp10_) {
#line 6364 "MainWindow.c"
			GSimpleAction* _tmp11_;
			GVariant* _tmp12_;
#line 1158 "../src/MainWindow.vala"
			_tmp11_ = show_find_action;
#line 1158 "../src/MainWindow.vala"
			_tmp12_ = _variant_new2 (TRUE);
#line 1158 "../src/MainWindow.vala"
			g_simple_action_set_state (_tmp11_, _tmp12_);
#line 1158 "../src/MainWindow.vala"
			_g_variant_unref0 (_tmp12_);
#line 6375 "MainWindow.c"
		}
#line 1152 "../src/MainWindow.vala"
		_g_object_unref0 (show_find_action);
#line 6379 "MainWindow.c"
	} else {
#line 1161 "../src/MainWindow.vala"
		scratch_main_window_set_search_text (self);
#line 6383 "MainWindow.c"
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 1168 "../src/MainWindow.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 1168 "../src/MainWindow.vala"
	return _data6_;
#line 6394 "MainWindow.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 1168 "../src/MainWindow.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 6404 "MainWindow.c"
		ScratchMainWindow* self;
#line 1168 "../src/MainWindow.vala"
		self = _data6_->self;
#line 1168 "../src/MainWindow.vala"
		_g_object_unref0 (self);
#line 1168 "../src/MainWindow.vala"
		g_slice_free (Block6Data, _data6_);
#line 6412 "MainWindow.c"
	}
}

static void
___lambda139_ (Block6Data* _data6_)
{
	ScratchMainWindow* self;
	ScratchWidgetsSearchBar* _tmp0_;
	GtkSearchEntry* _tmp1_;
	ScratchWidgetsSearchBar* _tmp2_;
#line 1172 "../src/MainWindow.vala"
	self = _data6_->self;
#line 1173 "../src/MainWindow.vala"
	_tmp0_ = self->search_bar;
#line 1173 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_->replace_entry;
#line 1173 "../src/MainWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp1_);
#line 1174 "../src/MainWindow.vala"
	_tmp2_ = self->search_bar;
#line 1174 "../src/MainWindow.vala"
	g_signal_handler_disconnect ((GObject*) _tmp2_, _data6_->map_handler);
#line 6435 "MainWindow.c"
}

static void
____lambda139__gtk_widget_map (GtkWidget* _sender,
                               gpointer self)
{
#line 1172 "../src/MainWindow.vala"
	___lambda139_ (self);
#line 6444 "MainWindow.c"
}

static void
scratch_main_window_action_show_replace (ScratchMainWindow* self,
                                         GSimpleAction* action)
{
	GtkRevealer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1165 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1165 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 1166 "../src/MainWindow.vala"
	scratch_main_window_action_fetch (self, action, NULL);
#line 1168 "../src/MainWindow.vala"
	_tmp0_ = self->priv->search_revealer;
#line 1168 "../src/MainWindow.vala"
	_tmp1_ = gtk_revealer_get_child_revealed (_tmp0_);
#line 1168 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 1168 "../src/MainWindow.vala"
	if (_tmp2_) {
#line 6468 "MainWindow.c"
		ScratchWidgetsSearchBar* _tmp3_;
		GtkSearchEntry* _tmp4_;
#line 1169 "../src/MainWindow.vala"
		_tmp3_ = self->search_bar;
#line 1169 "../src/MainWindow.vala"
		_tmp4_ = _tmp3_->replace_entry;
#line 1169 "../src/MainWindow.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp4_);
#line 6477 "MainWindow.c"
	} else {
		Block6Data* _data6_;
		ScratchWidgetsSearchBar* _tmp5_;
		gulong _tmp6_;
#line 1168 "../src/MainWindow.vala"
		_data6_ = g_slice_new0 (Block6Data);
#line 1168 "../src/MainWindow.vala"
		_data6_->_ref_count_ = 1;
#line 1168 "../src/MainWindow.vala"
		_data6_->self = g_object_ref (self);
#line 1171 "../src/MainWindow.vala"
		_data6_->map_handler = (gulong) 0;
#line 1172 "../src/MainWindow.vala"
		_tmp5_ = self->search_bar;
#line 1172 "../src/MainWindow.vala"
		_tmp6_ = g_signal_connect_data ((GtkWidget*) _tmp5_, "map", (GCallback) ____lambda139__gtk_widget_map, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, G_CONNECT_AFTER);
#line 1172 "../src/MainWindow.vala"
		_data6_->map_handler = _tmp6_;
#line 1168 "../src/MainWindow.vala"
		block6_data_unref (_data6_);
#line 1168 "../src/MainWindow.vala"
		_data6_ = NULL;
#line 6500 "MainWindow.c"
	}
}

static void
scratch_main_window_action_find_next (ScratchMainWindow* self)
{
	ScratchWidgetsSearchBar* _tmp0_;
#line 1179 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1180 "../src/MainWindow.vala"
	_tmp0_ = self->search_bar;
#line 1180 "../src/MainWindow.vala"
	scratch_widgets_search_bar_search_next (_tmp0_);
#line 6514 "MainWindow.c"
}

static void
scratch_main_window_action_find_previous (ScratchMainWindow* self)
{
	ScratchWidgetsSearchBar* _tmp0_;
#line 1183 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1184 "../src/MainWindow.vala"
	_tmp0_ = self->search_bar;
#line 1184 "../src/MainWindow.vala"
	scratch_widgets_search_bar_search_previous (_tmp0_);
#line 6527 "MainWindow.c"
}

static void
scratch_main_window_action_find_global (ScratchMainWindow* self,
                                        GSimpleAction* action,
                                        GVariant* param)
{
	ScratchServicesDocument* current_doc = NULL;
	ScratchServicesDocument* _tmp0_;
	gchar* selected_text = NULL;
	gchar* _tmp1_;
	ScratchServicesDocument* _tmp2_;
	const gchar* _tmp5_;
	const gchar* _tmp12_ = NULL;
	ScratchWidgetsSearchBar* _tmp13_;
	GtkSearchEntry* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	gchar* term = NULL;
	gchar* _tmp22_;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	const gchar* _tmp25_;
	ScratchFolderManagerFileView* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
#line 1187 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1187 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 1188 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_current_document (self);
#line 1188 "../src/MainWindow.vala"
	current_doc = _tmp0_;
#line 1189 "../src/MainWindow.vala"
	_tmp1_ = g_strdup ("");
#line 1189 "../src/MainWindow.vala"
	selected_text = _tmp1_;
#line 1190 "../src/MainWindow.vala"
	_tmp2_ = current_doc;
#line 1190 "../src/MainWindow.vala"
	if (_tmp2_ != NULL) {
#line 6571 "MainWindow.c"
		ScratchServicesDocument* _tmp3_;
		gchar* _tmp4_;
#line 1191 "../src/MainWindow.vala"
		_tmp3_ = current_doc;
#line 1191 "../src/MainWindow.vala"
		_tmp4_ = scratch_services_document_get_selected_text (_tmp3_, FALSE);
#line 1191 "../src/MainWindow.vala"
		_g_free0 (selected_text);
#line 1191 "../src/MainWindow.vala"
		selected_text = _tmp4_;
#line 6582 "MainWindow.c"
	}
#line 1194 "../src/MainWindow.vala"
	_tmp5_ = selected_text;
#line 1194 "../src/MainWindow.vala"
	if (g_strcmp0 (_tmp5_, "") != 0) {
#line 6588 "MainWindow.c"
		const gchar* _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gint _tmp9__length1;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 1195 "../src/MainWindow.vala"
		_tmp6_ = selected_text;
#line 1195 "../src/MainWindow.vala"
		_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, "\n", 2);
#line 1195 "../src/MainWindow.vala"
		_tmp9_ = _tmp8_;
#line 1195 "../src/MainWindow.vala"
		_tmp9__length1 = _vala_array_length (_tmp7_);
#line 1195 "../src/MainWindow.vala"
		_tmp10_ = _tmp9_[0];
#line 1195 "../src/MainWindow.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 1195 "../src/MainWindow.vala"
		_g_free0 (selected_text);
#line 1195 "../src/MainWindow.vala"
		selected_text = _tmp11_;
#line 1195 "../src/MainWindow.vala"
		_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 6614 "MainWindow.c"
	}
#line 1198 "../src/MainWindow.vala"
	_tmp13_ = self->search_bar;
#line 1198 "../src/MainWindow.vala"
	_tmp14_ = _tmp13_->search_entry;
#line 1198 "../src/MainWindow.vala"
	g_object_get ((GtkWidget*) _tmp14_, "has-focus", &_tmp15_, NULL);
#line 1198 "../src/MainWindow.vala"
	_tmp16_ = _tmp15_;
#line 1198 "../src/MainWindow.vala"
	if (_tmp16_) {
#line 6626 "MainWindow.c"
		ScratchWidgetsSearchBar* _tmp17_;
		GtkSearchEntry* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
#line 1199 "../src/MainWindow.vala"
		_tmp17_ = self->search_bar;
#line 1199 "../src/MainWindow.vala"
		_tmp18_ = _tmp17_->search_entry;
#line 1199 "../src/MainWindow.vala"
		_tmp19_ = gtk_entry_get_text ((GtkEntry*) _tmp18_);
#line 1199 "../src/MainWindow.vala"
		_tmp20_ = _tmp19_;
#line 1199 "../src/MainWindow.vala"
		_tmp12_ = _tmp20_;
#line 6641 "MainWindow.c"
	} else {
		const gchar* _tmp21_;
#line 1199 "../src/MainWindow.vala"
		_tmp21_ = selected_text;
#line 1199 "../src/MainWindow.vala"
		_tmp12_ = _tmp21_;
#line 6648 "MainWindow.c"
	}
#line 1198 "../src/MainWindow.vala"
	_tmp22_ = g_strdup (_tmp12_);
#line 1198 "../src/MainWindow.vala"
	term = _tmp22_;
#line 1202 "../src/MainWindow.vala"
	_tmp25_ = term;
#line 1202 "../src/MainWindow.vala"
	if (g_strcmp0 (_tmp25_, "") == 0) {
#line 6658 "MainWindow.c"
		ScratchWidgetsSearchBar* _tmp26_;
		GtkSearchEntry* _tmp27_;
		gboolean _tmp28_;
		gboolean _tmp29_;
#line 1203 "../src/MainWindow.vala"
		_tmp26_ = self->search_bar;
#line 1203 "../src/MainWindow.vala"
		_tmp27_ = _tmp26_->search_entry;
#line 1203 "../src/MainWindow.vala"
		g_object_get ((GtkWidget*) _tmp27_, "has-focus", &_tmp28_, NULL);
#line 1203 "../src/MainWindow.vala"
		_tmp29_ = _tmp28_;
#line 1203 "../src/MainWindow.vala"
		_tmp24_ = !_tmp29_;
#line 6673 "MainWindow.c"
	} else {
#line 1202 "../src/MainWindow.vala"
		_tmp24_ = FALSE;
#line 6677 "MainWindow.c"
	}
#line 1202 "../src/MainWindow.vala"
	if (_tmp24_) {
#line 6681 "MainWindow.c"
		GtkRevealer* _tmp30_;
		gboolean _tmp31_;
		gboolean _tmp32_;
#line 1204 "../src/MainWindow.vala"
		_tmp30_ = self->priv->search_revealer;
#line 1204 "../src/MainWindow.vala"
		_tmp31_ = gtk_revealer_get_reveal_child (_tmp30_);
#line 1204 "../src/MainWindow.vala"
		_tmp32_ = _tmp31_;
#line 1204 "../src/MainWindow.vala"
		_tmp23_ = _tmp32_;
#line 6693 "MainWindow.c"
	} else {
#line 1202 "../src/MainWindow.vala"
		_tmp23_ = FALSE;
#line 6697 "MainWindow.c"
	}
#line 1202 "../src/MainWindow.vala"
	if (_tmp23_) {
#line 6701 "MainWindow.c"
		ScratchWidgetsSearchBar* _tmp33_;
		GtkSearchEntry* _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
		gchar* _tmp37_;
#line 1206 "../src/MainWindow.vala"
		_tmp33_ = self->search_bar;
#line 1206 "../src/MainWindow.vala"
		_tmp34_ = _tmp33_->search_entry;
#line 1206 "../src/MainWindow.vala"
		_tmp35_ = gtk_entry_get_text ((GtkEntry*) _tmp34_);
#line 1206 "../src/MainWindow.vala"
		_tmp36_ = _tmp35_;
#line 1206 "../src/MainWindow.vala"
		_tmp37_ = g_strdup (_tmp36_);
#line 1206 "../src/MainWindow.vala"
		_g_free0 (term);
#line 1206 "../src/MainWindow.vala"
		term = _tmp37_;
#line 6721 "MainWindow.c"
	}
#line 1209 "../src/MainWindow.vala"
	_tmp38_ = self->priv->folder_manager_view;
#line 1209 "../src/MainWindow.vala"
	_tmp39_ = scratch_main_window_get_target_path_for_actions (self, param, FALSE);
#line 1209 "../src/MainWindow.vala"
	_tmp40_ = _tmp39_;
#line 1209 "../src/MainWindow.vala"
	_tmp41_ = term;
#line 1209 "../src/MainWindow.vala"
	scratch_folder_manager_file_view_search_global (_tmp38_, _tmp40_, _tmp41_);
#line 1209 "../src/MainWindow.vala"
	_g_free0 (_tmp40_);
#line 1187 "../src/MainWindow.vala"
	_g_free0 (term);
#line 1187 "../src/MainWindow.vala"
	_g_free0 (selected_text);
#line 1187 "../src/MainWindow.vala"
	_g_object_unref0 (current_doc);
#line 6741 "MainWindow.c"
}

static gboolean
__lambda156_ (ScratchMainWindow* self)
{
	gboolean is_current_doc = FALSE;
	ScratchServicesDocument* _tmp0_;
	ScratchServicesDocument* _tmp1_;
	gboolean _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleActionGroup* _tmp6_;
	GSimpleAction* _tmp7_;
	GSimpleAction* _tmp8_;
	GSimpleActionGroup* _tmp9_;
	GSimpleAction* _tmp10_;
	GSimpleAction* _tmp11_;
	GSimpleActionGroup* _tmp12_;
	GSimpleAction* _tmp13_;
	GSimpleAction* _tmp14_;
	gboolean is_active_project = FALSE;
	ScratchServicesGitManager* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	GSimpleActionGroup* _tmp18_;
	GSimpleAction* _tmp19_;
	GSimpleAction* _tmp20_;
	gboolean result;
#line 1215 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_current_document (self);
#line 1215 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 1215 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_ != NULL;
#line 1215 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 1215 "../src/MainWindow.vala"
	is_current_doc = _tmp2_;
#line 1216 "../src/MainWindow.vala"
	_tmp3_ = self->priv->_actions;
#line 1216 "../src/MainWindow.vala"
	_tmp4_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_FIND, _tmp3_);
#line 1216 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 1216 "../src/MainWindow.vala"
	g_simple_action_set_enabled (_tmp5_, is_current_doc);
#line 1216 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp5_);
#line 1217 "../src/MainWindow.vala"
	_tmp6_ = self->priv->_actions;
#line 1217 "../src/MainWindow.vala"
	_tmp7_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_SHOW_FIND, _tmp6_);
#line 1217 "../src/MainWindow.vala"
	_tmp8_ = _tmp7_;
#line 1217 "../src/MainWindow.vala"
	g_simple_action_set_enabled (_tmp8_, is_current_doc);
#line 1217 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp8_);
#line 1218 "../src/MainWindow.vala"
	_tmp9_ = self->priv->_actions;
#line 1218 "../src/MainWindow.vala"
	_tmp10_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_FIND_NEXT, _tmp9_);
#line 1218 "../src/MainWindow.vala"
	_tmp11_ = _tmp10_;
#line 1218 "../src/MainWindow.vala"
	g_simple_action_set_enabled (_tmp11_, is_current_doc);
#line 1218 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp11_);
#line 1219 "../src/MainWindow.vala"
	_tmp12_ = self->priv->_actions;
#line 1219 "../src/MainWindow.vala"
	_tmp13_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_FIND_PREVIOUS, _tmp12_);
#line 1219 "../src/MainWindow.vala"
	_tmp14_ = _tmp13_;
#line 1219 "../src/MainWindow.vala"
	g_simple_action_set_enabled (_tmp14_, is_current_doc);
#line 1219 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp14_);
#line 1221 "../src/MainWindow.vala"
	_tmp15_ = self->priv->git_manager;
#line 1221 "../src/MainWindow.vala"
	_tmp16_ = scratch_services_git_manager_get_active_project_path (_tmp15_);
#line 1221 "../src/MainWindow.vala"
	_tmp17_ = _tmp16_;
#line 1221 "../src/MainWindow.vala"
	is_active_project = g_strcmp0 (_tmp17_, "") != 0;
#line 1222 "../src/MainWindow.vala"
	_tmp18_ = self->priv->_actions;
#line 1222 "../src/MainWindow.vala"
	_tmp19_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_FIND_GLOBAL, _tmp18_);
#line 1222 "../src/MainWindow.vala"
	_tmp20_ = _tmp19_;
#line 1222 "../src/MainWindow.vala"
	g_simple_action_set_enabled (_tmp20_, is_active_project);
#line 1222 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp20_);
#line 1223 "../src/MainWindow.vala"
	result = G_SOURCE_REMOVE;
#line 1223 "../src/MainWindow.vala"
	return result;
#line 6843 "MainWindow.c"
}

static gboolean
___lambda156__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda156_ ((ScratchMainWindow*) self);
#line 1214 "../src/MainWindow.vala"
	return result;
#line 6853 "MainWindow.c"
}

static void
scratch_main_window_update_find_actions (ScratchMainWindow* self)
{
#line 1212 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1214 "../src/MainWindow.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda156__gsource_func, g_object_ref (self), g_object_unref);
#line 6863 "MainWindow.c"
}

static void
scratch_main_window_set_search_text (ScratchMainWindow* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp38_;
#line 1227 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1228 "../src/MainWindow.vala"
	_tmp0_ = self->priv->current_search_term;
#line 1228 "../src/MainWindow.vala"
	if (g_strcmp0 (_tmp0_, "") != 0) {
#line 6877 "MainWindow.c"
		ScratchWidgetsSearchBar* _tmp1_;
		GtkSearchEntry* _tmp2_;
		const gchar* _tmp3_;
		ScratchWidgetsSearchBar* _tmp4_;
		GtkSearchEntry* _tmp5_;
		ScratchWidgetsSearchBar* _tmp6_;
#line 1229 "../src/MainWindow.vala"
		_tmp1_ = self->search_bar;
#line 1229 "../src/MainWindow.vala"
		_tmp2_ = _tmp1_->search_entry;
#line 1229 "../src/MainWindow.vala"
		_tmp3_ = self->priv->current_search_term;
#line 1229 "../src/MainWindow.vala"
		gtk_entry_set_text ((GtkEntry*) _tmp2_, _tmp3_);
#line 1230 "../src/MainWindow.vala"
		_tmp4_ = self->search_bar;
#line 1230 "../src/MainWindow.vala"
		_tmp5_ = _tmp4_->search_entry;
#line 1230 "../src/MainWindow.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp5_);
#line 1231 "../src/MainWindow.vala"
		_tmp6_ = self->search_bar;
#line 1231 "../src/MainWindow.vala"
		scratch_widgets_search_bar_search_next (_tmp6_);
#line 6902 "MainWindow.c"
	} else {
		ScratchWidgetsSearchBar* _tmp7_;
		GtkSearchEntry* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 1232 "../src/MainWindow.vala"
		_tmp7_ = self->search_bar;
#line 1232 "../src/MainWindow.vala"
		_tmp8_ = _tmp7_->search_entry;
#line 1232 "../src/MainWindow.vala"
		_tmp9_ = gtk_entry_get_text ((GtkEntry*) _tmp8_);
#line 1232 "../src/MainWindow.vala"
		_tmp10_ = _tmp9_;
#line 1232 "../src/MainWindow.vala"
		if (g_strcmp0 (_tmp10_, "") != 0) {
#line 6918 "MainWindow.c"
			ScratchWidgetsSearchBar* _tmp11_;
			GtkSearchEntry* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			ScratchWidgetsSearchBar* _tmp16_;
			GtkSearchEntry* _tmp17_;
#line 1234 "../src/MainWindow.vala"
			_tmp11_ = self->search_bar;
#line 1234 "../src/MainWindow.vala"
			_tmp12_ = _tmp11_->search_entry;
#line 1234 "../src/MainWindow.vala"
			_tmp13_ = gtk_entry_get_text ((GtkEntry*) _tmp12_);
#line 1234 "../src/MainWindow.vala"
			_tmp14_ = _tmp13_;
#line 1234 "../src/MainWindow.vala"
			_tmp15_ = g_strdup (_tmp14_);
#line 1234 "../src/MainWindow.vala"
			_g_free0 (self->priv->current_search_term);
#line 1234 "../src/MainWindow.vala"
			self->priv->current_search_term = _tmp15_;
#line 1235 "../src/MainWindow.vala"
			_tmp16_ = self->search_bar;
#line 1235 "../src/MainWindow.vala"
			_tmp17_ = _tmp16_->search_entry;
#line 1235 "../src/MainWindow.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp17_);
#line 6946 "MainWindow.c"
		} else {
			ScratchServicesDocument* current_doc = NULL;
			ScratchServicesDocument* _tmp18_;
			ScratchServicesDocument* _tmp19_;
#line 1237 "../src/MainWindow.vala"
			_tmp18_ = scratch_main_window_get_current_document (self);
#line 1237 "../src/MainWindow.vala"
			current_doc = _tmp18_;
#line 1239 "../src/MainWindow.vala"
			_tmp19_ = current_doc;
#line 1239 "../src/MainWindow.vala"
			if (_tmp19_ != NULL) {
#line 6959 "MainWindow.c"
				gchar* selected_text = NULL;
				ScratchServicesDocument* _tmp20_;
				gchar* _tmp21_;
				gboolean _tmp22_ = FALSE;
				const gchar* _tmp23_;
				ScratchWidgetsSearchBar* _tmp36_;
				GtkSearchEntry* _tmp37_;
#line 1240 "../src/MainWindow.vala"
				_tmp20_ = current_doc;
#line 1240 "../src/MainWindow.vala"
				_tmp21_ = scratch_services_document_get_selected_text (_tmp20_, FALSE);
#line 1240 "../src/MainWindow.vala"
				selected_text = _tmp21_;
#line 1241 "../src/MainWindow.vala"
				_tmp23_ = selected_text;
#line 1241 "../src/MainWindow.vala"
				if (g_strcmp0 (_tmp23_, "") != 0) {
#line 6977 "MainWindow.c"
					const gchar* _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
#line 1241 "../src/MainWindow.vala"
					_tmp24_ = selected_text;
#line 1241 "../src/MainWindow.vala"
					_tmp25_ = strlen (_tmp24_);
#line 1241 "../src/MainWindow.vala"
					_tmp26_ = _tmp25_;
#line 1241 "../src/MainWindow.vala"
					_tmp22_ = ((guint) _tmp26_) < SCRATCH_MAIN_WINDOW_MAX_SEARCH_TEXT_LENGTH;
#line 6989 "MainWindow.c"
				} else {
#line 1241 "../src/MainWindow.vala"
					_tmp22_ = FALSE;
#line 6993 "MainWindow.c"
				}
#line 1241 "../src/MainWindow.vala"
				if (_tmp22_) {
#line 6997 "MainWindow.c"
					const gchar* _tmp27_;
					gchar** _tmp28_;
					gchar** _tmp29_;
					gchar** _tmp30_;
					gint _tmp30__length1;
					const gchar* _tmp31_;
					gchar* _tmp32_;
					ScratchWidgetsSearchBar* _tmp33_;
					GtkSearchEntry* _tmp34_;
					const gchar* _tmp35_;
#line 1242 "../src/MainWindow.vala"
					_tmp27_ = selected_text;
#line 1242 "../src/MainWindow.vala"
					_tmp29_ = _tmp28_ = g_strsplit (_tmp27_, "\n", 2);
#line 1242 "../src/MainWindow.vala"
					_tmp30_ = _tmp29_;
#line 1242 "../src/MainWindow.vala"
					_tmp30__length1 = _vala_array_length (_tmp28_);
#line 1242 "../src/MainWindow.vala"
					_tmp31_ = _tmp30_[0];
#line 1242 "../src/MainWindow.vala"
					_tmp32_ = g_strdup (_tmp31_);
#line 1242 "../src/MainWindow.vala"
					_g_free0 (self->priv->current_search_term);
#line 1242 "../src/MainWindow.vala"
					self->priv->current_search_term = _tmp32_;
#line 1242 "../src/MainWindow.vala"
					_tmp30_ = (_vala_array_free (_tmp30_, _tmp30__length1, (GDestroyNotify) g_free), NULL);
#line 1243 "../src/MainWindow.vala"
					_tmp33_ = self->search_bar;
#line 1243 "../src/MainWindow.vala"
					_tmp34_ = _tmp33_->search_entry;
#line 1243 "../src/MainWindow.vala"
					_tmp35_ = self->priv->current_search_term;
#line 1243 "../src/MainWindow.vala"
					gtk_entry_set_text ((GtkEntry*) _tmp34_, _tmp35_);
#line 7034 "MainWindow.c"
				}
#line 1246 "../src/MainWindow.vala"
				_tmp36_ = self->search_bar;
#line 1246 "../src/MainWindow.vala"
				_tmp37_ = _tmp36_->search_entry;
#line 1246 "../src/MainWindow.vala"
				gtk_widget_grab_focus ((GtkWidget*) _tmp37_);
#line 1239 "../src/MainWindow.vala"
				_g_free0 (selected_text);
#line 7044 "MainWindow.c"
			}
#line 1232 "../src/MainWindow.vala"
			_g_object_unref0 (current_doc);
#line 7048 "MainWindow.c"
		}
	}
#line 1250 "../src/MainWindow.vala"
	_tmp38_ = self->priv->current_search_term;
#line 1250 "../src/MainWindow.vala"
	if (g_strcmp0 (_tmp38_, "") != 0) {
#line 7055 "MainWindow.c"
		ScratchWidgetsSearchBar* _tmp39_;
#line 1251 "../src/MainWindow.vala"
		_tmp39_ = self->search_bar;
#line 1251 "../src/MainWindow.vala"
		scratch_widgets_search_bar_search_next (_tmp39_);
#line 7061 "MainWindow.c"
	}
}

/** Toggle action - linked to toolbar togglebutton. **/
static GVariant*
_variant_new3 (gboolean value)
{
#line 1258 "../src/MainWindow.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 7071 "MainWindow.c"
}

static void
scratch_main_window_action_show_fetch (ScratchMainWindow* self)
{
	GSimpleAction* fetch_action = NULL;
	GSimpleActionGroup* _tmp0_;
	GSimpleAction* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
#line 1256 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1257 "../src/MainWindow.vala"
	_tmp0_ = self->priv->_actions;
#line 1257 "../src/MainWindow.vala"
	_tmp1_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_SHOW_FIND, _tmp0_);
#line 1257 "../src/MainWindow.vala"
	fetch_action = _tmp1_;
#line 1258 "../src/MainWindow.vala"
	_tmp2_ = g_action_get_state ((GAction*) fetch_action);
#line 1258 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 1258 "../src/MainWindow.vala"
	_tmp4_ = _variant_new3 (!g_variant_get_boolean (_tmp3_));
#line 1258 "../src/MainWindow.vala"
	g_simple_action_set_state (fetch_action, _tmp4_);
#line 1258 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp4_);
#line 1258 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp3_);
#line 1256 "../src/MainWindow.vala"
	_g_object_unref0 (fetch_action);
#line 7105 "MainWindow.c"
}

static void
scratch_main_window_action_go_to (ScratchMainWindow* self)
{
	ScratchHeaderBar* _tmp0_;
	CodeFormatBar* _tmp1_;
	CodeFormatBarFormatButton* _tmp2_;
	CodeFormatBarFormatButton* _tmp3_;
#line 1261 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1262 "../src/MainWindow.vala"
	_tmp0_ = self->toolbar;
#line 1262 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_->format_bar;
#line 1262 "../src/MainWindow.vala"
	_tmp2_ = code_format_bar_get_line_menubutton (_tmp1_);
#line 1262 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 1262 "../src/MainWindow.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp3_, TRUE);
#line 7127 "MainWindow.c"
}

static void
scratch_main_window_action_templates (ScratchMainWindow* self)
{
	ScratchServicesPluginsManager* _tmp0_;
	ScratchServicesInterface* _tmp1_;
	ScratchServicesInterface* _tmp2_;
	ScratchTemplateManager* _tmp3_;
	ScratchTemplateManager* _tmp4_;
#line 1265 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1266 "../src/MainWindow.vala"
	_tmp0_ = self->priv->plugins;
#line 1266 "../src/MainWindow.vala"
	_tmp1_ = scratch_services_plugins_manager_get_plugin_iface (_tmp0_);
#line 1266 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 1266 "../src/MainWindow.vala"
	_tmp3_ = scratch_services_interface_get_template_manager (_tmp2_);
#line 1266 "../src/MainWindow.vala"
	_tmp4_ = _tmp3_;
#line 1266 "../src/MainWindow.vala"
	scratch_template_manager_show_window (_tmp4_, (GtkWidget*) self);
#line 7152 "MainWindow.c"
}

static void
scratch_main_window_action_to_lower_case (ScratchMainWindow* self)
{
	ScratchServicesDocument* doc = NULL;
	ScratchWidgetsDocumentView* _tmp0_;
	ScratchServicesDocument* _tmp1_;
	ScratchServicesDocument* _tmp2_;
	ScratchServicesDocument* _tmp3_;
	ScratchServicesDocument* _tmp4_;
	GtkTextBuffer* buffer = NULL;
	ScratchServicesDocument* _tmp5_;
	ScratchWidgetsSourceView* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextBuffer* _tmp8_;
	GtkTextBuffer* _tmp9_;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp10_;
	GtkTextIter _tmp11_ = {0};
	GtkTextIter _tmp12_ = {0};
	gchar* selected = NULL;
	GtkTextBuffer* _tmp13_;
	GtkTextIter _tmp14_;
	GtkTextIter _tmp15_;
	gchar* _tmp16_;
	GtkTextBuffer* _tmp17_;
	GtkTextBuffer* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
#line 1269 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1270 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 1270 "../src/MainWindow.vala"
	_tmp1_ = scratch_widgets_document_view_get_current_document (_tmp0_);
#line 1270 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 1270 "../src/MainWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1270 "../src/MainWindow.vala"
	doc = _tmp3_;
#line 1271 "../src/MainWindow.vala"
	_tmp4_ = doc;
#line 1271 "../src/MainWindow.vala"
	if (_tmp4_ == NULL) {
#line 1272 "../src/MainWindow.vala"
		_g_object_unref0 (doc);
#line 1272 "../src/MainWindow.vala"
		return;
#line 7205 "MainWindow.c"
	}
#line 1275 "../src/MainWindow.vala"
	_tmp5_ = doc;
#line 1275 "../src/MainWindow.vala"
	_tmp6_ = _tmp5_->source_view;
#line 1275 "../src/MainWindow.vala"
	_tmp7_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp6_);
#line 1275 "../src/MainWindow.vala"
	_tmp8_ = _tmp7_;
#line 1275 "../src/MainWindow.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 1275 "../src/MainWindow.vala"
	buffer = _tmp9_;
#line 1277 "../src/MainWindow.vala"
	_tmp10_ = buffer;
#line 1277 "../src/MainWindow.vala"
	gtk_text_buffer_get_selection_bounds (_tmp10_, &_tmp11_, &_tmp12_);
#line 1277 "../src/MainWindow.vala"
	start = _tmp11_;
#line 1277 "../src/MainWindow.vala"
	end = _tmp12_;
#line 1278 "../src/MainWindow.vala"
	_tmp13_ = buffer;
#line 1278 "../src/MainWindow.vala"
	_tmp14_ = start;
#line 1278 "../src/MainWindow.vala"
	_tmp15_ = end;
#line 1278 "../src/MainWindow.vala"
	_tmp16_ = gtk_text_buffer_get_text (_tmp13_, &_tmp14_, &_tmp15_, TRUE);
#line 1278 "../src/MainWindow.vala"
	selected = _tmp16_;
#line 1280 "../src/MainWindow.vala"
	_tmp17_ = buffer;
#line 1280 "../src/MainWindow.vala"
	gtk_text_buffer_delete (_tmp17_, &start, &end);
#line 1281 "../src/MainWindow.vala"
	_tmp18_ = buffer;
#line 1281 "../src/MainWindow.vala"
	_tmp19_ = selected;
#line 1281 "../src/MainWindow.vala"
	_tmp20_ = g_utf8_strdown (_tmp19_, (gssize) -1);
#line 1281 "../src/MainWindow.vala"
	_tmp21_ = _tmp20_;
#line 1281 "../src/MainWindow.vala"
	gtk_text_buffer_insert (_tmp18_, &start, _tmp21_, -1);
#line 1281 "../src/MainWindow.vala"
	_g_free0 (_tmp21_);
#line 1269 "../src/MainWindow.vala"
	_g_free0 (selected);
#line 1269 "../src/MainWindow.vala"
	_g_object_unref0 (buffer);
#line 1269 "../src/MainWindow.vala"
	_g_object_unref0 (doc);
#line 7259 "MainWindow.c"
}

static void
scratch_main_window_action_to_upper_case (ScratchMainWindow* self)
{
	ScratchServicesDocument* doc = NULL;
	ScratchWidgetsDocumentView* _tmp0_;
	ScratchServicesDocument* _tmp1_;
	ScratchServicesDocument* _tmp2_;
	ScratchServicesDocument* _tmp3_;
	ScratchServicesDocument* _tmp4_;
	GtkTextBuffer* buffer = NULL;
	ScratchServicesDocument* _tmp5_;
	ScratchWidgetsSourceView* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextBuffer* _tmp8_;
	GtkTextBuffer* _tmp9_;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp10_;
	GtkTextIter _tmp11_ = {0};
	GtkTextIter _tmp12_ = {0};
	gchar* selected = NULL;
	GtkTextBuffer* _tmp13_;
	GtkTextIter _tmp14_;
	GtkTextIter _tmp15_;
	gchar* _tmp16_;
	GtkTextBuffer* _tmp17_;
	GtkTextBuffer* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
#line 1284 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1285 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 1285 "../src/MainWindow.vala"
	_tmp1_ = scratch_widgets_document_view_get_current_document (_tmp0_);
#line 1285 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 1285 "../src/MainWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1285 "../src/MainWindow.vala"
	doc = _tmp3_;
#line 1286 "../src/MainWindow.vala"
	_tmp4_ = doc;
#line 1286 "../src/MainWindow.vala"
	if (_tmp4_ == NULL) {
#line 1287 "../src/MainWindow.vala"
		_g_object_unref0 (doc);
#line 1287 "../src/MainWindow.vala"
		return;
#line 7312 "MainWindow.c"
	}
#line 1290 "../src/MainWindow.vala"
	_tmp5_ = doc;
#line 1290 "../src/MainWindow.vala"
	_tmp6_ = _tmp5_->source_view;
#line 1290 "../src/MainWindow.vala"
	_tmp7_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp6_);
#line 1290 "../src/MainWindow.vala"
	_tmp8_ = _tmp7_;
#line 1290 "../src/MainWindow.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 1290 "../src/MainWindow.vala"
	buffer = _tmp9_;
#line 1292 "../src/MainWindow.vala"
	_tmp10_ = buffer;
#line 1292 "../src/MainWindow.vala"
	gtk_text_buffer_get_selection_bounds (_tmp10_, &_tmp11_, &_tmp12_);
#line 1292 "../src/MainWindow.vala"
	start = _tmp11_;
#line 1292 "../src/MainWindow.vala"
	end = _tmp12_;
#line 1293 "../src/MainWindow.vala"
	_tmp13_ = buffer;
#line 1293 "../src/MainWindow.vala"
	_tmp14_ = start;
#line 1293 "../src/MainWindow.vala"
	_tmp15_ = end;
#line 1293 "../src/MainWindow.vala"
	_tmp16_ = gtk_text_buffer_get_text (_tmp13_, &_tmp14_, &_tmp15_, TRUE);
#line 1293 "../src/MainWindow.vala"
	selected = _tmp16_;
#line 1295 "../src/MainWindow.vala"
	_tmp17_ = buffer;
#line 1295 "../src/MainWindow.vala"
	gtk_text_buffer_delete (_tmp17_, &start, &end);
#line 1296 "../src/MainWindow.vala"
	_tmp18_ = buffer;
#line 1296 "../src/MainWindow.vala"
	_tmp19_ = selected;
#line 1296 "../src/MainWindow.vala"
	_tmp20_ = g_utf8_strup (_tmp19_, (gssize) -1);
#line 1296 "../src/MainWindow.vala"
	_tmp21_ = _tmp20_;
#line 1296 "../src/MainWindow.vala"
	gtk_text_buffer_insert (_tmp18_, &start, _tmp21_, -1);
#line 1296 "../src/MainWindow.vala"
	_g_free0 (_tmp21_);
#line 1284 "../src/MainWindow.vala"
	_g_free0 (selected);
#line 1284 "../src/MainWindow.vala"
	_g_object_unref0 (buffer);
#line 1284 "../src/MainWindow.vala"
	_g_object_unref0 (doc);
#line 7366 "MainWindow.c"
}

static void
scratch_main_window_action_toggle_comment (ScratchMainWindow* self)
{
	ScratchServicesDocument* doc = NULL;
	ScratchServicesDocument* _tmp0_;
	ScratchServicesDocument* _tmp1_;
	GtkTextBuffer* buffer = NULL;
	ScratchServicesDocument* _tmp2_;
	ScratchWidgetsSourceView* _tmp3_;
	GtkTextBuffer* _tmp4_;
	GtkTextBuffer* _tmp5_;
	GtkTextBuffer* _tmp6_;
	GtkTextBuffer* _tmp7_;
#line 1299 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1300 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_focused_document (self);
#line 1300 "../src/MainWindow.vala"
	doc = _tmp0_;
#line 1301 "../src/MainWindow.vala"
	_tmp1_ = doc;
#line 1301 "../src/MainWindow.vala"
	if (_tmp1_ == NULL) {
#line 1302 "../src/MainWindow.vala"
		_g_object_unref0 (doc);
#line 1302 "../src/MainWindow.vala"
		return;
#line 7396 "MainWindow.c"
	}
#line 1305 "../src/MainWindow.vala"
	_tmp2_ = doc;
#line 1305 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_->source_view;
#line 1305 "../src/MainWindow.vala"
	_tmp4_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp3_);
#line 1305 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 1305 "../src/MainWindow.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 1305 "../src/MainWindow.vala"
	buffer = _tmp6_;
#line 1306 "../src/MainWindow.vala"
	_tmp7_ = buffer;
#line 1306 "../src/MainWindow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gtk_source_buffer_get_type ())) {
#line 7414 "MainWindow.c"
		GtkTextBuffer* _tmp8_;
#line 1307 "../src/MainWindow.vala"
		_tmp8_ = buffer;
#line 1307 "../src/MainWindow.vala"
		scratch_comment_toggler_toggle_comment (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, gtk_source_buffer_get_type ()) ? ((GtkSourceBuffer*) _tmp8_) : NULL);
#line 7420 "MainWindow.c"
	}
#line 1299 "../src/MainWindow.vala"
	_g_object_unref0 (buffer);
#line 1299 "../src/MainWindow.vala"
	_g_object_unref0 (doc);
#line 7426 "MainWindow.c"
}

static void
scratch_main_window_action_sort_lines (ScratchMainWindow* self)
{
	ScratchServicesDocument* doc = NULL;
	ScratchServicesDocument* _tmp0_;
	ScratchServicesDocument* _tmp1_;
	ScratchServicesDocument* _tmp2_;
	ScratchWidgetsSourceView* _tmp3_;
#line 1311 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1312 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_focused_document (self);
#line 1312 "../src/MainWindow.vala"
	doc = _tmp0_;
#line 1313 "../src/MainWindow.vala"
	_tmp1_ = doc;
#line 1313 "../src/MainWindow.vala"
	if (_tmp1_ == NULL) {
#line 1314 "../src/MainWindow.vala"
		_g_object_unref0 (doc);
#line 1314 "../src/MainWindow.vala"
		return;
#line 7451 "MainWindow.c"
	}
#line 1317 "../src/MainWindow.vala"
	_tmp2_ = doc;
#line 1317 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_->source_view;
#line 1317 "../src/MainWindow.vala"
	scratch_widgets_source_view_sort_selected_lines (_tmp3_);
#line 1311 "../src/MainWindow.vala"
	_g_object_unref0 (doc);
#line 7461 "MainWindow.c"
}

static GVariant*
_variant_new4 (gboolean value)
{
#line 1325 "../src/MainWindow.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 7469 "MainWindow.c"
}

static void
scratch_main_window_action_toggle_sidebar (ScratchMainWindow* self,
                                           GSimpleAction* action)
{
	CodeSidebar* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	CodeSidebar* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
#line 1320 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1320 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 1321 "../src/MainWindow.vala"
	_tmp0_ = self->sidebar;
#line 1321 "../src/MainWindow.vala"
	if (_tmp0_ == NULL) {
#line 1322 "../src/MainWindow.vala"
		return;
#line 7493 "MainWindow.c"
	}
#line 1325 "../src/MainWindow.vala"
	_tmp1_ = g_action_get_state ((GAction*) action);
#line 1325 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 1325 "../src/MainWindow.vala"
	_tmp3_ = _variant_new4 (!g_variant_get_boolean (_tmp2_));
#line 1325 "../src/MainWindow.vala"
	g_simple_action_set_state (action, _tmp3_);
#line 1325 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp3_);
#line 1325 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp2_);
#line 1326 "../src/MainWindow.vala"
	_tmp4_ = self->sidebar;
#line 1326 "../src/MainWindow.vala"
	_tmp5_ = g_action_get_state ((GAction*) action);
#line 1326 "../src/MainWindow.vala"
	_tmp6_ = _tmp5_;
#line 1326 "../src/MainWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, g_variant_get_boolean (_tmp6_));
#line 1326 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp6_);
#line 7517 "MainWindow.c"
}

static GVariant*
_variant_new5 (gboolean value)
{
#line 1331 "../src/MainWindow.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 7525 "MainWindow.c"
}

static void
scratch_main_window_action_toggle_terminal (ScratchMainWindow* self)
{
	GSimpleAction* toggle_terminal_action = NULL;
	GSimpleActionGroup* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	CodeTerminal* _tmp7_;
	GSimpleAction* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GSimpleAction* _tmp11_;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	gboolean _tmp14_;
#line 1329 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1330 "../src/MainWindow.vala"
	_tmp0_ = self->priv->_actions;
#line 1330 "../src/MainWindow.vala"
	_tmp1_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_TERMINAL, _tmp0_);
#line 1330 "../src/MainWindow.vala"
	toggle_terminal_action = _tmp1_;
#line 1331 "../src/MainWindow.vala"
	_tmp2_ = toggle_terminal_action;
#line 1331 "../src/MainWindow.vala"
	_tmp3_ = toggle_terminal_action;
#line 1331 "../src/MainWindow.vala"
	_tmp4_ = g_action_get_state ((GAction*) _tmp3_);
#line 1331 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 1331 "../src/MainWindow.vala"
	_tmp6_ = _variant_new5 (!g_variant_get_boolean (_tmp5_));
#line 1331 "../src/MainWindow.vala"
	g_simple_action_set_state (_tmp2_, _tmp6_);
#line 1331 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp6_);
#line 1331 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp5_);
#line 1333 "../src/MainWindow.vala"
	_tmp7_ = self->priv->terminal;
#line 1333 "../src/MainWindow.vala"
	_tmp8_ = toggle_terminal_action;
#line 1333 "../src/MainWindow.vala"
	_tmp9_ = g_action_get_state ((GAction*) _tmp8_);
#line 1333 "../src/MainWindow.vala"
	_tmp10_ = _tmp9_;
#line 1333 "../src/MainWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp7_, g_variant_get_boolean (_tmp10_));
#line 1333 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp10_);
#line 1335 "../src/MainWindow.vala"
	_tmp11_ = toggle_terminal_action;
#line 1335 "../src/MainWindow.vala"
	_tmp12_ = g_action_get_state ((GAction*) _tmp11_);
#line 1335 "../src/MainWindow.vala"
	_tmp13_ = _tmp12_;
#line 1335 "../src/MainWindow.vala"
	_tmp14_ = g_variant_get_boolean (_tmp13_);
#line 1335 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp13_);
#line 1335 "../src/MainWindow.vala"
	if (_tmp14_) {
#line 7595 "MainWindow.c"
		CodeTerminal* _tmp15_;
#line 1336 "../src/MainWindow.vala"
		_tmp15_ = self->priv->terminal;
#line 1336 "../src/MainWindow.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp15_);
#line 7601 "MainWindow.c"
	} else {
		ScratchServicesDocument* _tmp16_;
		ScratchServicesDocument* _tmp17_;
		gboolean _tmp18_;
#line 1337 "../src/MainWindow.vala"
		_tmp16_ = scratch_main_window_get_current_document (self);
#line 1337 "../src/MainWindow.vala"
		_tmp17_ = _tmp16_;
#line 1337 "../src/MainWindow.vala"
		_tmp18_ = _tmp17_ != NULL;
#line 1337 "../src/MainWindow.vala"
		_g_object_unref0 (_tmp17_);
#line 1337 "../src/MainWindow.vala"
		if (_tmp18_) {
#line 7616 "MainWindow.c"
			ScratchServicesDocument* _tmp19_;
			ScratchServicesDocument* _tmp20_;
#line 1338 "../src/MainWindow.vala"
			_tmp19_ = scratch_main_window_get_current_document (self);
#line 1338 "../src/MainWindow.vala"
			_tmp20_ = _tmp19_;
#line 1338 "../src/MainWindow.vala"
			scratch_services_document_focus (_tmp20_);
#line 1338 "../src/MainWindow.vala"
			_g_object_unref0 (_tmp20_);
#line 7627 "MainWindow.c"
		}
	}
#line 1329 "../src/MainWindow.vala"
	_g_object_unref0 (toggle_terminal_action);
#line 7632 "MainWindow.c"
}

static void
scratch_main_window_action_open_in_terminal (ScratchMainWindow* self,
                                             GSimpleAction* action,
                                             GVariant* param)
{
	gboolean _tmp0_ = FALSE;
	CodeTerminal* _tmp1_;
	gchar* target_path = NULL;
	gchar* _tmp8_;
	CodeTerminal* _tmp9_;
	CodeTerminal* _tmp10_;
	VteTerminal* _tmp11_;
	VteTerminal* _tmp12_;
#line 1342 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1342 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 1344 "../src/MainWindow.vala"
	_tmp1_ = self->priv->terminal;
#line 1344 "../src/MainWindow.vala"
	if (_tmp1_ == NULL) {
#line 1344 "../src/MainWindow.vala"
		_tmp0_ = TRUE;
#line 7658 "MainWindow.c"
	} else {
		CodeTerminal* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 1344 "../src/MainWindow.vala"
		_tmp2_ = self->priv->terminal;
#line 1344 "../src/MainWindow.vala"
		_tmp3_ = gtk_widget_get_visible ((GtkWidget*) _tmp2_);
#line 1344 "../src/MainWindow.vala"
		_tmp4_ = _tmp3_;
#line 1344 "../src/MainWindow.vala"
		_tmp0_ = !_tmp4_;
#line 7671 "MainWindow.c"
	}
#line 1344 "../src/MainWindow.vala"
	if (_tmp0_) {
#line 7675 "MainWindow.c"
		GSimpleAction* toggle_terminal_action = NULL;
		GSimpleActionGroup* _tmp5_;
		GSimpleAction* _tmp6_;
		GSimpleAction* _tmp7_;
#line 1345 "../src/MainWindow.vala"
		_tmp5_ = self->priv->_actions;
#line 1345 "../src/MainWindow.vala"
		_tmp6_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_TERMINAL, _tmp5_);
#line 1345 "../src/MainWindow.vala"
		toggle_terminal_action = _tmp6_;
#line 1346 "../src/MainWindow.vala"
		_tmp7_ = toggle_terminal_action;
#line 1346 "../src/MainWindow.vala"
		g_signal_emit_by_name (_tmp7_, "activate", NULL);
#line 1344 "../src/MainWindow.vala"
		_g_object_unref0 (toggle_terminal_action);
#line 7692 "MainWindow.c"
	}
#line 1351 "../src/MainWindow.vala"
	_tmp8_ = scratch_main_window_get_target_path_for_actions (self, param, TRUE);
#line 1351 "../src/MainWindow.vala"
	target_path = _tmp8_;
#line 1352 "../src/MainWindow.vala"
	_tmp9_ = self->priv->terminal;
#line 1352 "../src/MainWindow.vala"
	code_terminal_change_location (_tmp9_, target_path);
#line 1353 "../src/MainWindow.vala"
	_tmp10_ = self->priv->terminal;
#line 1353 "../src/MainWindow.vala"
	_tmp11_ = code_terminal_get_terminal (_tmp10_);
#line 1353 "../src/MainWindow.vala"
	_tmp12_ = _tmp11_;
#line 1353 "../src/MainWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 1342 "../src/MainWindow.vala"
	_g_free0 (target_path);
#line 7712 "MainWindow.c"
}

static GVariant*
_variant_new6 (gboolean value)
{
#line 1357 "../src/MainWindow.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 7720 "MainWindow.c"
}

static void
scratch_main_window_action_toggle_outline (ScratchMainWindow* self,
                                           GSimpleAction* action)
{
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	ScratchWidgetsDocumentView* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
#line 1356 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1356 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 1357 "../src/MainWindow.vala"
	_tmp0_ = g_action_get_state ((GAction*) action);
#line 1357 "../src/MainWindow.vala"
	_tmp1_ = _tmp0_;
#line 1357 "../src/MainWindow.vala"
	_tmp2_ = _variant_new6 (!g_variant_get_boolean (_tmp1_));
#line 1357 "../src/MainWindow.vala"
	g_simple_action_set_state (action, _tmp2_);
#line 1357 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp2_);
#line 1357 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp1_);
#line 1358 "../src/MainWindow.vala"
	_tmp3_ = self->document_view;
#line 1358 "../src/MainWindow.vala"
	_tmp4_ = g_action_get_state ((GAction*) action);
#line 1358 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 1358 "../src/MainWindow.vala"
	scratch_widgets_document_view_set_outline_visible (_tmp3_, g_variant_get_boolean (_tmp5_));
#line 1358 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp5_);
#line 7759 "MainWindow.c"
}

static void
scratch_main_window_action_next_tab (ScratchMainWindow* self)
{
	ScratchWidgetsDocumentView* _tmp0_;
#line 1361 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1362 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 1362 "../src/MainWindow.vala"
	scratch_widgets_document_view_next_document (_tmp0_);
#line 7772 "MainWindow.c"
}

static void
scratch_main_window_action_previous_tab (ScratchMainWindow* self)
{
	ScratchWidgetsDocumentView* _tmp0_;
#line 1365 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1366 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 1366 "../src/MainWindow.vala"
	scratch_widgets_document_view_previous_document (_tmp0_);
#line 7785 "MainWindow.c"
}

static void
scratch_main_window_action_clear_lines (ScratchMainWindow* self)
{
	ScratchServicesDocument* doc = NULL;
	ScratchServicesDocument* _tmp0_;
	ScratchServicesDocument* _tmp1_;
	ScratchServicesDocument* _tmp2_;
	ScratchWidgetsSourceView* _tmp3_;
#line 1369 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1370 "../src/MainWindow.vala"
	_tmp0_ = scratch_main_window_get_focused_document (self);
#line 1370 "../src/MainWindow.vala"
	doc = _tmp0_;
#line 1371 "../src/MainWindow.vala"
	_tmp1_ = doc;
#line 1371 "../src/MainWindow.vala"
	if (_tmp1_ == NULL) {
#line 1372 "../src/MainWindow.vala"
		_g_object_unref0 (doc);
#line 1372 "../src/MainWindow.vala"
		return;
#line 7810 "MainWindow.c"
	}
#line 1375 "../src/MainWindow.vala"
	_tmp2_ = doc;
#line 1375 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_->source_view;
#line 1375 "../src/MainWindow.vala"
	scratch_widgets_source_view_clear_selected_lines (_tmp3_);
#line 1369 "../src/MainWindow.vala"
	_g_object_unref0 (doc);
#line 7820 "MainWindow.c"
}

static void
scratch_main_window_action_new_branch (ScratchMainWindow* self,
                                       GSimpleAction* action,
                                       GVariant* param)
{
	ScratchFolderManagerFileView* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 1378 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1378 "../src/MainWindow.vala"
	g_return_if_fail (action != NULL);
#line 1379 "../src/MainWindow.vala"
	_tmp0_ = self->priv->folder_manager_view;
#line 1379 "../src/MainWindow.vala"
	_tmp1_ = scratch_main_window_get_target_path_for_actions (self, param, FALSE);
#line 1379 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 1379 "../src/MainWindow.vala"
	scratch_folder_manager_file_view_new_branch (_tmp0_, _tmp2_);
#line 1379 "../src/MainWindow.vala"
	_g_free0 (_tmp2_);
#line 7845 "MainWindow.c"
}

static void
scratch_main_window_action_move_tab_to_new_window (ScratchMainWindow* self)
{
	ScratchWidgetsDocumentView* _tmp0_;
#line 1382 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 1383 "../src/MainWindow.vala"
	_tmp0_ = self->document_view;
#line 1383 "../src/MainWindow.vala"
	scratch_widgets_document_view_transfer_tab_to_new_window (_tmp0_);
#line 7858 "MainWindow.c"
}

static gchar*
scratch_main_window_get_target_path_for_actions (ScratchMainWindow* self,
                                                 GVariant* path_variant,
                                                 gboolean use_build_dir)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp3_;
	gchar* result;
#line 1386 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1387 "../src/MainWindow.vala"
	_tmp0_ = g_strdup ("");
#line 1387 "../src/MainWindow.vala"
	path = _tmp0_;
#line 1388 "../src/MainWindow.vala"
	if (path_variant != NULL) {
#line 7878 "MainWindow.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 1389 "../src/MainWindow.vala"
		_tmp1_ = g_variant_get_string (path_variant, NULL);
#line 1389 "../src/MainWindow.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 1389 "../src/MainWindow.vala"
		_g_free0 (path);
#line 1389 "../src/MainWindow.vala"
		path = _tmp2_;
#line 7889 "MainWindow.c"
	}
#line 1392 "../src/MainWindow.vala"
	_tmp3_ = path;
#line 1392 "../src/MainWindow.vala"
	if (g_strcmp0 (_tmp3_, "") == 0) {
#line 7895 "MainWindow.c"
		ScratchServicesGitManager* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp11_;
#line 1393 "../src/MainWindow.vala"
		_tmp4_ = self->priv->git_manager;
#line 1393 "../src/MainWindow.vala"
		_tmp5_ = scratch_services_git_manager_get_active_project_path (_tmp4_);
#line 1393 "../src/MainWindow.vala"
		_tmp6_ = _tmp5_;
#line 1393 "../src/MainWindow.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 1393 "../src/MainWindow.vala"
		_g_free0 (path);
#line 1393 "../src/MainWindow.vala"
		path = _tmp7_;
#line 1394 "../src/MainWindow.vala"
		if (use_build_dir) {
#line 7915 "MainWindow.c"
			ScratchServicesGitManager* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
#line 1395 "../src/MainWindow.vala"
			_tmp8_ = self->priv->git_manager;
#line 1395 "../src/MainWindow.vala"
			_tmp9_ = path;
#line 1395 "../src/MainWindow.vala"
			_tmp10_ = scratch_services_git_manager_get_default_build_dir (_tmp8_, _tmp9_);
#line 1395 "../src/MainWindow.vala"
			_g_free0 (path);
#line 1395 "../src/MainWindow.vala"
			path = _tmp10_;
#line 7929 "MainWindow.c"
		}
#line 1398 "../src/MainWindow.vala"
		_tmp11_ = path;
#line 1398 "../src/MainWindow.vala"
		if (_tmp11_ == NULL) {
#line 7935 "MainWindow.c"
			ScratchServicesDocument* current_doc = NULL;
			ScratchServicesDocument* _tmp12_;
			ScratchServicesDocument* _tmp13_;
#line 1399 "../src/MainWindow.vala"
			_tmp12_ = scratch_main_window_get_current_document (self);
#line 1399 "../src/MainWindow.vala"
			current_doc = _tmp12_;
#line 1400 "../src/MainWindow.vala"
			_tmp13_ = current_doc;
#line 1400 "../src/MainWindow.vala"
			if (_tmp13_ != NULL) {
#line 7947 "MainWindow.c"
				ScratchServicesDocument* _tmp14_;
				GFile* _tmp15_;
				GFile* _tmp16_;
				gchar* _tmp17_;
#line 1401 "../src/MainWindow.vala"
				_tmp14_ = current_doc;
#line 1401 "../src/MainWindow.vala"
				_tmp15_ = scratch_services_document_get_file (_tmp14_);
#line 1401 "../src/MainWindow.vala"
				_tmp16_ = _tmp15_;
#line 1401 "../src/MainWindow.vala"
				_tmp17_ = g_file_get_path (_tmp16_);
#line 1401 "../src/MainWindow.vala"
				_g_free0 (path);
#line 1401 "../src/MainWindow.vala"
				path = _tmp17_;
#line 7964 "MainWindow.c"
			} else {
#line 1403 "../src/MainWindow.vala"
				result = NULL;
#line 1403 "../src/MainWindow.vala"
				_g_object_unref0 (current_doc);
#line 1403 "../src/MainWindow.vala"
				_g_free0 (path);
#line 1403 "../src/MainWindow.vala"
				return result;
#line 7974 "MainWindow.c"
			}
#line 1398 "../src/MainWindow.vala"
			_g_object_unref0 (current_doc);
#line 7978 "MainWindow.c"
		}
	}
#line 1408 "../src/MainWindow.vala"
	result = path;
#line 1408 "../src/MainWindow.vala"
	return result;
#line 7985 "MainWindow.c"
}

ScratchApplication*
scratch_main_window_get_app (ScratchMainWindow* self)
{
	ScratchApplication* result;
	ScratchApplication* _tmp0_;
#line 27 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/MainWindow.vala"
	_tmp0_ = self->priv->_app;
#line 27 "../src/MainWindow.vala"
	result = _tmp0_;
#line 27 "../src/MainWindow.vala"
	return result;
#line 8001 "MainWindow.c"
}

static void
scratch_main_window_set_app (ScratchMainWindow* self,
                             ScratchApplication* value)
{
	ScratchApplication* old_value;
#line 27 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/MainWindow.vala"
	old_value = scratch_main_window_get_app (self);
#line 27 "../src/MainWindow.vala"
	if (old_value != value) {
#line 8015 "MainWindow.c"
		ScratchApplication* _tmp0_;
#line 27 "../src/MainWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 27 "../src/MainWindow.vala"
		_g_object_unref0 (self->priv->_app);
#line 27 "../src/MainWindow.vala"
		self->priv->_app = _tmp0_;
#line 27 "../src/MainWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_main_window_properties[SCRATCH_MAIN_WINDOW_APP_PROPERTY]);
#line 8025 "MainWindow.c"
	}
}

gboolean
scratch_main_window_get_restore_docs (ScratchMainWindow* self)
{
	gboolean result;
#line 28 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 28 "../src/MainWindow.vala"
	result = self->priv->_restore_docs;
#line 28 "../src/MainWindow.vala"
	return result;
#line 8039 "MainWindow.c"
}

static void
scratch_main_window_set_restore_docs (ScratchMainWindow* self,
                                      gboolean value)
{
	gboolean old_value;
#line 28 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/MainWindow.vala"
	old_value = scratch_main_window_get_restore_docs (self);
#line 28 "../src/MainWindow.vala"
	if (old_value != value) {
#line 28 "../src/MainWindow.vala"
		self->priv->_restore_docs = value;
#line 28 "../src/MainWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_main_window_properties[SCRATCH_MAIN_WINDOW_RESTORE_DOCS_PROPERTY]);
#line 8057 "MainWindow.c"
	}
}

RestoreOverride*
scratch_main_window_get_restore_override (ScratchMainWindow* self)
{
	RestoreOverride* result;
	RestoreOverride* _tmp0_;
#line 29 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/MainWindow.vala"
	_tmp0_ = self->priv->_restore_override;
#line 29 "../src/MainWindow.vala"
	result = _tmp0_;
#line 29 "../src/MainWindow.vala"
	return result;
#line 8074 "MainWindow.c"
}

void
scratch_main_window_set_restore_override (ScratchMainWindow* self,
                                          RestoreOverride* value)
{
	RestoreOverride* old_value;
#line 29 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/MainWindow.vala"
	old_value = scratch_main_window_get_restore_override (self);
#line 29 "../src/MainWindow.vala"
	if (old_value != value) {
#line 8088 "MainWindow.c"
		RestoreOverride* _tmp0_;
#line 29 "../src/MainWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../src/MainWindow.vala"
		_g_object_unref0 (self->priv->_restore_override);
#line 29 "../src/MainWindow.vala"
		self->priv->_restore_override = _tmp0_;
#line 29 "../src/MainWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_main_window_properties[SCRATCH_MAIN_WINDOW_RESTORE_OVERRIDE_PROPERTY]);
#line 8098 "MainWindow.c"
	}
}

GSimpleActionGroup*
scratch_main_window_get_actions (ScratchMainWindow* self)
{
	GSimpleActionGroup* result;
	GSimpleActionGroup* _tmp0_;
#line 58 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../src/MainWindow.vala"
	_tmp0_ = self->priv->_actions;
#line 58 "../src/MainWindow.vala"
	result = _tmp0_;
#line 58 "../src/MainWindow.vala"
	return result;
#line 8115 "MainWindow.c"
}

static void
scratch_main_window_set_actions (ScratchMainWindow* self,
                                 GSimpleActionGroup* value)
{
	GSimpleActionGroup* old_value;
#line 58 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/MainWindow.vala"
	old_value = scratch_main_window_get_actions (self);
#line 58 "../src/MainWindow.vala"
	if (old_value != value) {
#line 8129 "MainWindow.c"
		GSimpleActionGroup* _tmp0_;
#line 58 "../src/MainWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 58 "../src/MainWindow.vala"
		_g_object_unref0 (self->priv->_actions);
#line 58 "../src/MainWindow.vala"
		self->priv->_actions = _tmp0_;
#line 58 "../src/MainWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_main_window_properties[SCRATCH_MAIN_WINDOW_ACTIONS_PROPERTY]);
#line 8139 "MainWindow.c"
	}
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 261 "../src/MainWindow.vala"
	if ((*length) == (*size)) {
#line 261 "../src/MainWindow.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 261 "../src/MainWindow.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 8155 "MainWindow.c"
	}
#line 261 "../src/MainWindow.vala"
	(*array)[(*length)++] = value;
#line 261 "../src/MainWindow.vala"
	(*array)[*length] = NULL;
#line 8161 "MainWindow.c"
}

static void
_scratch_main_window___lambda162_ (ScratchMainWindow* self)
{
#line 277 "../src/MainWindow.vala"
	scratch_main_window_update_style (self);
#line 8169 "MainWindow.c"
}

static void
__scratch_main_window___lambda162__g_settings_changed (GSettings* _sender,
                                                       const gchar* key,
                                                       gpointer self)
{
#line 276 "../src/MainWindow.vala"
	_scratch_main_window___lambda162_ ((ScratchMainWindow*) self);
#line 8179 "MainWindow.c"
}

static gboolean
_scratch_main_window_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                          guint keyval,
                                                                          guint keycode,
                                                                          GdkModifierType state,
                                                                          gpointer self)
{
	gboolean result;
	result = scratch_main_window_on_key_pressed ((ScratchMainWindow*) self, keyval, keycode, state);
#line 287 "../src/MainWindow.vala"
	return result;
#line 8193 "MainWindow.c"
}

static void
_scratch_main_window___lambda163_ (ScratchMainWindow* self)
{
	ScratchHeaderBar* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	ScratchServicesPluginsManager* _tmp3_;
	ScratchServicesInterface* _tmp4_;
	ScratchServicesInterface* _tmp5_;
	ScratchTemplateManager* _tmp6_;
	ScratchTemplateManager* _tmp7_;
#line 309 "../src/MainWindow.vala"
	_tmp0_ = self->toolbar;
#line 309 "../src/MainWindow.vala"
	_tmp1_ = scratch_header_bar_get_templates_button (_tmp0_);
#line 309 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 309 "../src/MainWindow.vala"
	_tmp3_ = self->priv->plugins;
#line 309 "../src/MainWindow.vala"
	_tmp4_ = scratch_services_plugins_manager_get_plugin_iface (_tmp3_);
#line 309 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 309 "../src/MainWindow.vala"
	_tmp6_ = scratch_services_interface_get_template_manager (_tmp5_);
#line 309 "../src/MainWindow.vala"
	_tmp7_ = _tmp6_;
#line 309 "../src/MainWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, _tmp7_->template_available);
#line 8225 "MainWindow.c"
}

static void
__scratch_main_window___lambda163__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 308 "../src/MainWindow.vala"
	_scratch_main_window___lambda163_ ((ScratchMainWindow*) self);
#line 8235 "MainWindow.c"
}

static void
_scratch_main_window___lambda164_ (ScratchMainWindow* self,
                                   const gchar* name,
                                   GVariant* new_state)
{
#line 318 "../src/MainWindow.vala"
	g_return_if_fail (name != NULL);
#line 318 "../src/MainWindow.vala"
	g_return_if_fail (new_state != NULL);
#line 319 "../src/MainWindow.vala"
	scratch_main_window_update_toolbar_button (self, name, g_variant_get_boolean (new_state));
#line 8249 "MainWindow.c"
}

static void
__scratch_main_window___lambda164__g_action_group_action_state_changed (GActionGroup* _sender,
                                                                        const gchar* action_name,
                                                                        GVariant* state,
                                                                        gpointer self)
{
#line 318 "../src/MainWindow.vala"
	_scratch_main_window___lambda164_ ((ScratchMainWindow*) self, action_name, state);
#line 8260 "MainWindow.c"
}

static GVariant*
_variant_new7 (gboolean value)
{
#line 323 "../src/MainWindow.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 8268 "MainWindow.c"
}

static GVariant*
_variant_new8 (gboolean value)
{
#line 327 "../src/MainWindow.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 8276 "MainWindow.c"
}

static GVariant*
_variant_new9 (gboolean value)
{
#line 331 "../src/MainWindow.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 8284 "MainWindow.c"
}

static gboolean
_scratch_main_window_quit_source_func_gsource_func (gpointer self)
{
	gboolean result;
	result = scratch_main_window_quit_source_func ((ScratchMainWindow*) self);
#line 334 "../src/MainWindow.vala"
	return result;
#line 8294 "MainWindow.c"
}

static GObject *
scratch_main_window_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ScratchMainWindow * self;
	GApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GtkApplication* _tmp2_;
	const gchar* _tmp3_;
	GtkIconTheme* default_theme = NULL;
	GtkIconTheme* _tmp4_;
	GtkIconTheme* _tmp5_;
	ScratchServicesDocumentManager* _tmp6_;
	ScratchServicesGitManager* _tmp7_;
	GSimpleActionGroup* _tmp8_;
	GSimpleActionGroup* _tmp9_;
	GSimpleActionGroup* _tmp10_;
	GSimpleActionGroup* _tmp11_;
	GdkRectangle rect = {0};
	GSettings* _tmp32_;
	gint _tmp33_ = 0;
	gint _tmp34_ = 0;
	GdkRectangle _tmp35_;
	GdkRectangle _tmp36_;
	GSettings* _tmp37_;
	GdkDisplay* _tmp38_;
	GtkClipboard* _tmp39_;
	GtkClipboard* _tmp40_;
	ScratchServicesPluginsManager* _tmp41_;
	GtkEventControllerKey* _tmp42_ = NULL;
	GtkEventControllerKey* _tmp43_;
	gint window_state = 0;
	GSettings* _tmp44_;
	ScratchHeaderBar* _tmp45_;
	GtkButton* _tmp46_;
	GtkButton* _tmp47_;
	ScratchServicesPluginsManager* _tmp48_;
	ScratchServicesInterface* _tmp49_;
	ScratchServicesInterface* _tmp50_;
	ScratchTemplateManager* _tmp51_;
	ScratchTemplateManager* _tmp52_;
	ScratchServicesPluginsManager* _tmp53_;
	ScratchServicesInterface* _tmp54_;
	ScratchServicesInterface* _tmp55_;
	ScratchTemplateManager* _tmp56_;
	ScratchTemplateManager* _tmp57_;
	GSimpleActionGroup* _tmp58_;
	GSimpleAction* sidebar_action = NULL;
	GSimpleActionGroup* _tmp59_;
	GSimpleAction* _tmp60_;
	GSimpleAction* _tmp61_;
	GSettings* _tmp62_;
	GVariant* _tmp63_;
	GSettings* _tmp64_;
	GSimpleAction* outline_action = NULL;
	GSimpleActionGroup* _tmp65_;
	GSimpleAction* _tmp66_;
	GSimpleAction* _tmp67_;
	GSettings* _tmp68_;
	GVariant* _tmp69_;
	GSettings* _tmp70_;
	GSimpleAction* terminal_action = NULL;
	GSimpleActionGroup* _tmp71_;
	GSimpleAction* _tmp72_;
	GSimpleAction* _tmp73_;
	GSettings* _tmp74_;
	GVariant* _tmp75_;
	GSettings* _tmp76_;
#line 244 "../src/MainWindow.vala"
	parent_class = G_OBJECT_CLASS (scratch_main_window_parent_class);
#line 244 "../src/MainWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 244 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_TYPE_MAIN_WINDOW, ScratchMainWindow);
#line 245 "../src/MainWindow.vala"
	_tmp0_ = g_application_get_default ();
#line 245 "../src/MainWindow.vala"
	gtk_window_set_application ((GtkWindow*) self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
#line 246 "../src/MainWindow.vala"
	_tmp1_ = gtk_window_get_application ((GtkWindow*) self);
#line 246 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 246 "../src/MainWindow.vala"
	scratch_main_window_set_app (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, SCRATCH_TYPE_APPLICATION, ScratchApplication));
#line 247 "../src/MainWindow.vala"
	_tmp3_ = scratch_main_window_base_title;
#line 247 "../src/MainWindow.vala"
	gtk_window_set_title ((GtkWindow*) self, _tmp3_);
#line 249 "../src/MainWindow.vala"
	_tmp4_ = gtk_icon_theme_get_default ();
#line 249 "../src/MainWindow.vala"
	default_theme = _tmp4_;
#line 250 "../src/MainWindow.vala"
	_tmp5_ = default_theme;
#line 250 "../src/MainWindow.vala"
	gtk_icon_theme_add_resource_path (_tmp5_, "/io/elementary/code");
#line 252 "../src/MainWindow.vala"
	_tmp6_ = scratch_services_document_manager_get_instance ();
#line 252 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->document_manager);
#line 252 "../src/MainWindow.vala"
	self->priv->document_manager = _tmp6_;
#line 253 "../src/MainWindow.vala"
	_tmp7_ = scratch_services_git_manager_get_instance ();
#line 253 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->git_manager);
#line 253 "../src/MainWindow.vala"
	self->priv->git_manager = _tmp7_;
#line 255 "../src/MainWindow.vala"
	_tmp8_ = g_simple_action_group_new ();
#line 255 "../src/MainWindow.vala"
	_tmp9_ = _tmp8_;
#line 255 "../src/MainWindow.vala"
	scratch_main_window_set_actions (self, _tmp9_);
#line 255 "../src/MainWindow.vala"
	_g_object_unref0 (_tmp9_);
#line 256 "../src/MainWindow.vala"
	_tmp10_ = self->priv->_actions;
#line 256 "../src/MainWindow.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp10_, SCRATCH_MAIN_WINDOW_ACTION_ENTRIES, (gint) G_N_ELEMENTS (SCRATCH_MAIN_WINDOW_ACTION_ENTRIES), self);
#line 257 "../src/MainWindow.vala"
	_tmp11_ = self->priv->_actions;
#line 257 "../src/MainWindow.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, SCRATCH_MAIN_WINDOW_ACTION_GROUP, (GActionGroup*) _tmp11_);
#line 8424 "MainWindow.c"
	{
		GeeIterator* _action_it = NULL;
		GeeMultiMap* _tmp12_;
		GeeSet* _tmp13_;
		GeeSet* _tmp14_;
		GeeIterator* _tmp15_;
		GeeIterator* _tmp16_;
#line 259 "../src/MainWindow.vala"
		_tmp12_ = scratch_main_window_action_accelerators;
#line 259 "../src/MainWindow.vala"
		_tmp13_ = gee_multi_map_get_keys (_tmp12_);
#line 259 "../src/MainWindow.vala"
		_tmp14_ = _tmp13_;
#line 259 "../src/MainWindow.vala"
		_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
#line 259 "../src/MainWindow.vala"
		_tmp16_ = _tmp15_;
#line 259 "../src/MainWindow.vala"
		_g_object_unref0 (_tmp14_);
#line 259 "../src/MainWindow.vala"
		_action_it = _tmp16_;
#line 259 "../src/MainWindow.vala"
		while (TRUE) {
#line 8448 "MainWindow.c"
			GeeIterator* _tmp17_;
			gchar* action = NULL;
			GeeIterator* _tmp18_;
			gpointer _tmp19_;
			gchar** accels_array = NULL;
			GeeMultiMap* _tmp20_;
			const gchar* _tmp21_;
			GeeCollection* _tmp22_;
			GeeCollection* _tmp23_;
			gint _tmp24_ = 0;
			gpointer* _tmp25_;
			gchar** _tmp26_;
			gint _tmp26__length1;
			gint accels_array_length1;
			gint _accels_array_size_;
			ScratchApplication* _tmp27_;
			const gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar** _tmp31_;
			gint _tmp31__length1;
#line 259 "../src/MainWindow.vala"
			_tmp17_ = _action_it;
#line 259 "../src/MainWindow.vala"
			if (!gee_iterator_next (_tmp17_)) {
#line 259 "../src/MainWindow.vala"
				break;
#line 8476 "MainWindow.c"
			}
#line 259 "../src/MainWindow.vala"
			_tmp18_ = _action_it;
#line 259 "../src/MainWindow.vala"
			_tmp19_ = gee_iterator_get (_tmp18_);
#line 259 "../src/MainWindow.vala"
			action = (gchar*) _tmp19_;
#line 260 "../src/MainWindow.vala"
			_tmp20_ = scratch_main_window_action_accelerators;
#line 260 "../src/MainWindow.vala"
			_tmp21_ = action;
#line 260 "../src/MainWindow.vala"
			_tmp22_ = gee_multi_map_get (_tmp20_, _tmp21_);
#line 260 "../src/MainWindow.vala"
			_tmp23_ = _tmp22_;
#line 260 "../src/MainWindow.vala"
			_tmp25_ = gee_collection_to_array (_tmp23_, &_tmp24_);
#line 260 "../src/MainWindow.vala"
			_tmp26_ = _tmp25_;
#line 260 "../src/MainWindow.vala"
			_tmp26__length1 = _tmp24_;
#line 260 "../src/MainWindow.vala"
			_g_object_unref0 (_tmp23_);
#line 260 "../src/MainWindow.vala"
			accels_array = _tmp26_;
#line 260 "../src/MainWindow.vala"
			accels_array_length1 = _tmp26__length1;
#line 260 "../src/MainWindow.vala"
			_accels_array_size_ = accels_array_length1;
#line 261 "../src/MainWindow.vala"
			_vala_array_add2 (&accels_array, &accels_array_length1, &_accels_array_size_, NULL);
#line 263 "../src/MainWindow.vala"
			_tmp27_ = self->priv->_app;
#line 263 "../src/MainWindow.vala"
			_tmp28_ = action;
#line 263 "../src/MainWindow.vala"
			_tmp29_ = g_strconcat (SCRATCH_MAIN_WINDOW_ACTION_PREFIX, _tmp28_, NULL);
#line 263 "../src/MainWindow.vala"
			_tmp30_ = _tmp29_;
#line 263 "../src/MainWindow.vala"
			_tmp31_ = accels_array;
#line 263 "../src/MainWindow.vala"
			_tmp31__length1 = accels_array_length1;
#line 263 "../src/MainWindow.vala"
			gtk_application_set_accels_for_action ((GtkApplication*) _tmp27_, _tmp30_, _tmp31_);
#line 263 "../src/MainWindow.vala"
			_g_free0 (_tmp30_);
#line 259 "../src/MainWindow.vala"
			accels_array = (_vala_array_free (accels_array, accels_array_length1, (GDestroyNotify) g_free), NULL);
#line 259 "../src/MainWindow.vala"
			_g_free0 (action);
#line 8528 "MainWindow.c"
		}
#line 259 "../src/MainWindow.vala"
		_g_object_unref0 (_action_it);
#line 8532 "MainWindow.c"
	}
#line 266 "../src/MainWindow.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 450, 400);
#line 267 "../src/MainWindow.vala"
	gtk_window_set_hide_titlebar_when_maximized ((GtkWindow*) self, FALSE);
#line 269 "../src/MainWindow.vala"
	memset (&rect, 0, sizeof (GdkRectangle));
#line 270 "../src/MainWindow.vala"
	_tmp32_ = scratch_saved_state;
#line 270 "../src/MainWindow.vala"
	g_settings_get (_tmp32_, "window-size", "(ii)", &_tmp33_, &_tmp34_);
#line 270 "../src/MainWindow.vala"
	rect.width = _tmp33_;
#line 270 "../src/MainWindow.vala"
	rect.height = _tmp34_;
#line 272 "../src/MainWindow.vala"
	_tmp35_ = rect;
#line 272 "../src/MainWindow.vala"
	g_object_set ((GtkWindow*) self, "default-width", _tmp35_.width, NULL);
#line 273 "../src/MainWindow.vala"
	_tmp36_ = rect;
#line 273 "../src/MainWindow.vala"
	g_object_set ((GtkWindow*) self, "default-height", _tmp36_.height, NULL);
#line 275 "../src/MainWindow.vala"
	scratch_main_window_update_style (self);
#line 276 "../src/MainWindow.vala"
	_tmp37_ = scratch_settings;
#line 276 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp37_, "changed::follow-system-style", (GCallback) __scratch_main_window___lambda162__g_settings_changed, self, 0);
#line 280 "../src/MainWindow.vala"
	_tmp38_ = gtk_widget_get_display ((GtkWidget*) self);
#line 280 "../src/MainWindow.vala"
	_tmp39_ = gtk_clipboard_get_for_display (_tmp38_, GDK_SELECTION_CLIPBOARD);
#line 280 "../src/MainWindow.vala"
	_tmp40_ = _g_object_ref0 (_tmp39_);
#line 280 "../src/MainWindow.vala"
	_g_object_unref0 (self->clipboard);
#line 280 "../src/MainWindow.vala"
	self->clipboard = _tmp40_;
#line 282 "../src/MainWindow.vala"
	_tmp41_ = scratch_services_plugins_manager_new (self);
#line 282 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->plugins);
#line 282 "../src/MainWindow.vala"
	self->priv->plugins = _tmp41_;
#line 284 "../src/MainWindow.vala"
	_tmp42_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
#line 284 "../src/MainWindow.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp42_, GTK_PHASE_CAPTURE);
#line 284 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 284 "../src/MainWindow.vala"
	self->priv->key_controller = _tmp42_;
#line 287 "../src/MainWindow.vala"
	_tmp43_ = self->priv->key_controller;
#line 287 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp43_, "key-pressed", (GCallback) _scratch_main_window_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 290 "../src/MainWindow.vala"
	scratch_main_window_init_layout (self);
#line 292 "../src/MainWindow.vala"
	_tmp44_ = scratch_saved_state;
#line 292 "../src/MainWindow.vala"
	window_state = g_settings_get_enum (_tmp44_, "window-state");
#line 293 "../src/MainWindow.vala"
	switch (window_state) {
#line 293 "../src/MainWindow.vala"
		case SCRATCH_SCRATCH_WINDOW_STATE_MAXIMIZED:
#line 8600 "MainWindow.c"
		{
#line 295 "../src/MainWindow.vala"
			gtk_window_maximize ((GtkWindow*) self);
#line 296 "../src/MainWindow.vala"
			break;
#line 8606 "MainWindow.c"
		}
#line 293 "../src/MainWindow.vala"
		case SCRATCH_SCRATCH_WINDOW_STATE_FULLSCREEN:
#line 8610 "MainWindow.c"
		{
#line 298 "../src/MainWindow.vala"
			gtk_window_fullscreen ((GtkWindow*) self);
#line 299 "../src/MainWindow.vala"
			break;
#line 8616 "MainWindow.c"
		}
		default:
		{
#line 301 "../src/MainWindow.vala"
			break;
#line 8622 "MainWindow.c"
		}
	}
#line 305 "../src/MainWindow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 307 "../src/MainWindow.vala"
	_tmp45_ = self->toolbar;
#line 307 "../src/MainWindow.vala"
	_tmp46_ = scratch_header_bar_get_templates_button (_tmp45_);
#line 307 "../src/MainWindow.vala"
	_tmp47_ = _tmp46_;
#line 307 "../src/MainWindow.vala"
	_tmp48_ = self->priv->plugins;
#line 307 "../src/MainWindow.vala"
	_tmp49_ = scratch_services_plugins_manager_get_plugin_iface (_tmp48_);
#line 307 "../src/MainWindow.vala"
	_tmp50_ = _tmp49_;
#line 307 "../src/MainWindow.vala"
	_tmp51_ = scratch_services_interface_get_template_manager (_tmp50_);
#line 307 "../src/MainWindow.vala"
	_tmp52_ = _tmp51_;
#line 307 "../src/MainWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp47_, _tmp52_->template_available);
#line 308 "../src/MainWindow.vala"
	_tmp53_ = self->priv->plugins;
#line 308 "../src/MainWindow.vala"
	_tmp54_ = scratch_services_plugins_manager_get_plugin_iface (_tmp53_);
#line 308 "../src/MainWindow.vala"
	_tmp55_ = _tmp54_;
#line 308 "../src/MainWindow.vala"
	_tmp56_ = scratch_services_interface_get_template_manager (_tmp55_);
#line 308 "../src/MainWindow.vala"
	_tmp57_ = _tmp56_;
#line 308 "../src/MainWindow.vala"
	g_signal_connect_object ((GObject*) _tmp57_, "notify::template_available", (GCallback) __scratch_main_window___lambda163__g_object_notify, self, 0);
#line 313 "../src/MainWindow.vala"
	scratch_main_window_restore_saved_state_extra (self);
#line 316 "../src/MainWindow.vala"
	scratch_main_window_create_unsaved_documents_directory (self);
#line 318 "../src/MainWindow.vala"
	_tmp58_ = self->priv->_actions;
#line 318 "../src/MainWindow.vala"
	g_signal_connect_object ((GActionGroup*) _tmp58_, "action-state-changed", (GCallback) __scratch_main_window___lambda164__g_action_group_action_state_changed, self, 0);
#line 322 "../src/MainWindow.vala"
	_tmp59_ = self->priv->_actions;
#line 322 "../src/MainWindow.vala"
	_tmp60_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_SIDEBAR, _tmp59_);
#line 322 "../src/MainWindow.vala"
	sidebar_action = _tmp60_;
#line 323 "../src/MainWindow.vala"
	_tmp61_ = sidebar_action;
#line 323 "../src/MainWindow.vala"
	_tmp62_ = scratch_saved_state;
#line 323 "../src/MainWindow.vala"
	_tmp63_ = _variant_new7 (g_settings_get_boolean (_tmp62_, "sidebar-visible"));
#line 323 "../src/MainWindow.vala"
	g_simple_action_set_state (_tmp61_, _tmp63_);
#line 323 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp63_);
#line 324 "../src/MainWindow.vala"
	_tmp64_ = scratch_saved_state;
#line 324 "../src/MainWindow.vala"
	scratch_main_window_update_toolbar_button (self, SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_SIDEBAR, g_settings_get_boolean (_tmp64_, "sidebar-visible"));
#line 326 "../src/MainWindow.vala"
	_tmp65_ = self->priv->_actions;
#line 326 "../src/MainWindow.vala"
	_tmp66_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_OUTLINE, _tmp65_);
#line 326 "../src/MainWindow.vala"
	outline_action = _tmp66_;
#line 327 "../src/MainWindow.vala"
	_tmp67_ = outline_action;
#line 327 "../src/MainWindow.vala"
	_tmp68_ = scratch_saved_state;
#line 327 "../src/MainWindow.vala"
	_tmp69_ = _variant_new8 (g_settings_get_boolean (_tmp68_, "outline-visible"));
#line 327 "../src/MainWindow.vala"
	g_simple_action_set_state (_tmp67_, _tmp69_);
#line 327 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp69_);
#line 328 "../src/MainWindow.vala"
	_tmp70_ = scratch_saved_state;
#line 328 "../src/MainWindow.vala"
	scratch_main_window_update_toolbar_button (self, SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_OUTLINE, g_settings_get_boolean (_tmp70_, "outline-visible"));
#line 330 "../src/MainWindow.vala"
	_tmp71_ = self->priv->_actions;
#line 330 "../src/MainWindow.vala"
	_tmp72_ = scratch_utils_action_from_group (SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_TERMINAL, _tmp71_);
#line 330 "../src/MainWindow.vala"
	terminal_action = _tmp72_;
#line 331 "../src/MainWindow.vala"
	_tmp73_ = terminal_action;
#line 331 "../src/MainWindow.vala"
	_tmp74_ = scratch_saved_state;
#line 331 "../src/MainWindow.vala"
	_tmp75_ = _variant_new9 (g_settings_get_boolean (_tmp74_, "terminal-visible"));
#line 331 "../src/MainWindow.vala"
	g_simple_action_set_state (_tmp73_, _tmp75_);
#line 331 "../src/MainWindow.vala"
	_g_variant_unref0 (_tmp75_);
#line 332 "../src/MainWindow.vala"
	_tmp76_ = scratch_saved_state;
#line 332 "../src/MainWindow.vala"
	scratch_main_window_update_toolbar_button (self, SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_TERMINAL, g_settings_get_boolean (_tmp76_, "terminal-visible"));
#line 334 "../src/MainWindow.vala"
	g_unix_signal_add_full (G_PRIORITY_HIGH, (gint) SIGINT, _scratch_main_window_quit_source_func_gsource_func, g_object_ref (self), g_object_unref);
#line 335 "../src/MainWindow.vala"
	g_unix_signal_add_full (G_PRIORITY_HIGH, (gint) SIGTERM, _scratch_main_window_quit_source_func_gsource_func, g_object_ref (self), g_object_unref);
#line 244 "../src/MainWindow.vala"
	_g_object_unref0 (terminal_action);
#line 244 "../src/MainWindow.vala"
	_g_object_unref0 (outline_action);
#line 244 "../src/MainWindow.vala"
	_g_object_unref0 (sidebar_action);
#line 244 "../src/MainWindow.vala"
	return obj;
#line 8737 "MainWindow.c"
}

static void
scratch_main_window_class_init (ScratchMainWindowClass * klass,
                                gpointer klass_data)
{
	GeeHashMultiMap* _tmp0_;
	GeeMultiMap* _tmp1_;
	GeeMultiMap* _tmp2_;
	GeeMultiMap* _tmp3_;
	GeeMultiMap* _tmp4_;
	GeeMultiMap* _tmp5_;
	GeeMultiMap* _tmp6_;
	GeeMultiMap* _tmp7_;
	GeeMultiMap* _tmp8_;
	GeeMultiMap* _tmp9_;
	GeeMultiMap* _tmp10_;
	GeeMultiMap* _tmp11_;
	GeeMultiMap* _tmp12_;
	GeeMultiMap* _tmp13_;
	GeeMultiMap* _tmp14_;
	GeeMultiMap* _tmp15_;
	GeeMultiMap* _tmp16_;
	GeeMultiMap* _tmp17_;
	GeeMultiMap* _tmp18_;
	GeeMultiMap* _tmp19_;
	GeeMultiMap* _tmp20_;
	GeeMultiMap* _tmp21_;
	GeeMultiMap* _tmp22_;
	GeeMultiMap* _tmp23_;
	GeeMultiMap* _tmp24_;
	GeeMultiMap* _tmp25_;
	GeeMultiMap* _tmp26_;
	GeeMultiMap* _tmp27_;
	GeeMultiMap* _tmp28_;
	GeeMultiMap* _tmp29_;
	GeeMultiMap* _tmp30_;
	GeeMultiMap* _tmp31_;
	GeeMultiMap* _tmp32_;
	GeeMultiMap* _tmp33_;
	GeeMultiMap* _tmp34_;
	GeeMultiMap* _tmp35_;
	GeeMultiMap* _tmp36_;
	GeeMultiMap* _tmp37_;
	GeeMultiMap* _tmp38_;
	GeeMultiMap* _tmp39_;
	GeeMultiMap* _tmp40_;
	GeeMultiMap* _tmp41_;
	GeeMultiMap* _tmp42_;
	GeeMultiMap* _tmp43_;
	GeeMultiMap* _tmp44_;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp45_;
	GtkCssProvider* _tmp46_;
	GdkScreen* _tmp47_;
	GtkCssProvider* _tmp48_;
#line 22 "../src/MainWindow.vala"
	scratch_main_window_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/MainWindow.vala"
	g_type_class_adjust_private_offset (klass, &ScratchMainWindow_private_offset);
#line 22 "../src/MainWindow.vala"
	((GtkWidgetClass *) klass)->delete_event = (gboolean (*) (GtkWidget*, GdkEventAny*)) scratch_main_window_real_delete_event;
#line 22 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_scratch_main_window_get_property;
#line 22 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_scratch_main_window_set_property;
#line 22 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = scratch_main_window_constructor;
#line 22 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = scratch_main_window_finalize;
#line 22 "../src/MainWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_MAIN_WINDOW_APP_PROPERTY, scratch_main_window_properties[SCRATCH_MAIN_WINDOW_APP_PROPERTY] = g_param_spec_object ("app", "app", "app", SCRATCH_TYPE_APPLICATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/MainWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_MAIN_WINDOW_RESTORE_DOCS_PROPERTY, scratch_main_window_properties[SCRATCH_MAIN_WINDOW_RESTORE_DOCS_PROPERTY] = g_param_spec_boolean ("restore-docs", "restore-docs", "restore-docs", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/MainWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_MAIN_WINDOW_RESTORE_OVERRIDE_PROPERTY, scratch_main_window_properties[SCRATCH_MAIN_WINDOW_RESTORE_OVERRIDE_PROPERTY] = g_param_spec_object ("restore-override", "restore-override", "restore-override", TYPE_RESTORE_OVERRIDE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 22 "../src/MainWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_MAIN_WINDOW_ACTIONS_PROPERTY, scratch_main_window_properties[SCRATCH_MAIN_WINDOW_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", g_simple_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 110 "../src/MainWindow.vala"
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 110 "../src/MainWindow.vala"
	scratch_main_window_action_accelerators = (GeeMultiMap*) _tmp0_;
#line 184 "../src/MainWindow.vala"
	_tmp1_ = scratch_main_window_action_accelerators;
#line 184 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp1_, SCRATCH_MAIN_WINDOW_ACTION_FIND "::", "<Control>f");
#line 185 "../src/MainWindow.vala"
	_tmp2_ = scratch_main_window_action_accelerators;
#line 185 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp2_, SCRATCH_MAIN_WINDOW_ACTION_FIND_NEXT, "<Control>g");
#line 186 "../src/MainWindow.vala"
	_tmp3_ = scratch_main_window_action_accelerators;
#line 186 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp3_, SCRATCH_MAIN_WINDOW_ACTION_FIND_PREVIOUS, "<Control><shift>g");
#line 187 "../src/MainWindow.vala"
	_tmp4_ = scratch_main_window_action_accelerators;
#line 187 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp4_, SCRATCH_MAIN_WINDOW_ACTION_FIND_GLOBAL "::", "<Control><shift>f");
#line 188 "../src/MainWindow.vala"
	_tmp5_ = scratch_main_window_action_accelerators;
#line 188 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp5_, SCRATCH_MAIN_WINDOW_ACTION_OPEN, "<Control>o");
#line 189 "../src/MainWindow.vala"
	_tmp6_ = scratch_main_window_action_accelerators;
#line 189 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp6_, SCRATCH_MAIN_WINDOW_ACTION_REVERT, "<Control><shift>o");
#line 190 "../src/MainWindow.vala"
	_tmp7_ = scratch_main_window_action_accelerators;
#line 190 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp7_, SCRATCH_MAIN_WINDOW_ACTION_SAVE, "<Control>s");
#line 191 "../src/MainWindow.vala"
	_tmp8_ = scratch_main_window_action_accelerators;
#line 191 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp8_, SCRATCH_MAIN_WINDOW_ACTION_SAVE_AS, "<Control><shift>s");
#line 192 "../src/MainWindow.vala"
	_tmp9_ = scratch_main_window_action_accelerators;
#line 192 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp9_, SCRATCH_MAIN_WINDOW_ACTION_GO_TO, "<Control>i");
#line 193 "../src/MainWindow.vala"
	_tmp10_ = scratch_main_window_action_accelerators;
#line 193 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp10_, SCRATCH_MAIN_WINDOW_ACTION_SORT_LINES, "F5");
#line 194 "../src/MainWindow.vala"
	_tmp11_ = scratch_main_window_action_accelerators;
#line 194 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp11_, SCRATCH_MAIN_WINDOW_ACTION_NEW_TAB, "<Control>n");
#line 195 "../src/MainWindow.vala"
	_tmp12_ = scratch_main_window_action_accelerators;
#line 195 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp12_, SCRATCH_MAIN_WINDOW_ACTION_DUPLICATE_TAB, "<Control><Shift>k");
#line 196 "../src/MainWindow.vala"
	_tmp13_ = scratch_main_window_action_accelerators;
#line 196 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp13_, SCRATCH_MAIN_WINDOW_ACTION_UNDO, "<Control>z");
#line 197 "../src/MainWindow.vala"
	_tmp14_ = scratch_main_window_action_accelerators;
#line 197 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp14_, SCRATCH_MAIN_WINDOW_ACTION_REDO, "<Control><shift>z");
#line 198 "../src/MainWindow.vala"
	_tmp15_ = scratch_main_window_action_accelerators;
#line 198 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp15_, SCRATCH_MAIN_WINDOW_ACTION_SHOW_REPLACE, "<Control>r");
#line 199 "../src/MainWindow.vala"
	_tmp16_ = scratch_main_window_action_accelerators;
#line 199 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp16_, SCRATCH_MAIN_WINDOW_ACTION_TO_LOWER_CASE, "<Control>l");
#line 200 "../src/MainWindow.vala"
	_tmp17_ = scratch_main_window_action_accelerators;
#line 200 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp17_, SCRATCH_MAIN_WINDOW_ACTION_TO_UPPER_CASE, "<Control>u");
#line 201 "../src/MainWindow.vala"
	_tmp18_ = scratch_main_window_action_accelerators;
#line 201 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp18_, SCRATCH_MAIN_WINDOW_ACTION_DUPLICATE, "<Control>d");
#line 202 "../src/MainWindow.vala"
	_tmp19_ = scratch_main_window_action_accelerators;
#line 202 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp19_, SCRATCH_MAIN_WINDOW_ACTION_FULLSCREEN, "F11");
#line 203 "../src/MainWindow.vala"
	_tmp20_ = scratch_main_window_action_accelerators;
#line 203 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp20_, SCRATCH_MAIN_WINDOW_ACTION_QUIT, "<Control>q");
#line 204 "../src/MainWindow.vala"
	_tmp21_ = scratch_main_window_action_accelerators;
#line 204 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp21_, SCRATCH_MAIN_WINDOW_ACTION_ZOOM_DEFAULT, "<Control>0");
#line 205 "../src/MainWindow.vala"
	_tmp22_ = scratch_main_window_action_accelerators;
#line 205 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp22_, SCRATCH_MAIN_WINDOW_ACTION_ZOOM_DEFAULT, "<Control>KP_0");
#line 206 "../src/MainWindow.vala"
	_tmp23_ = scratch_main_window_action_accelerators;
#line 206 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp23_, SCRATCH_MAIN_WINDOW_ACTION_ZOOM_IN, "<Control>plus");
#line 207 "../src/MainWindow.vala"
	_tmp24_ = scratch_main_window_action_accelerators;
#line 207 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp24_, SCRATCH_MAIN_WINDOW_ACTION_ZOOM_IN, "<Control>equal");
#line 208 "../src/MainWindow.vala"
	_tmp25_ = scratch_main_window_action_accelerators;
#line 208 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp25_, SCRATCH_MAIN_WINDOW_ACTION_ZOOM_IN, "<Control>KP_Add");
#line 209 "../src/MainWindow.vala"
	_tmp26_ = scratch_main_window_action_accelerators;
#line 209 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp26_, SCRATCH_MAIN_WINDOW_ACTION_ZOOM_OUT, "<Control>minus");
#line 210 "../src/MainWindow.vala"
	_tmp27_ = scratch_main_window_action_accelerators;
#line 210 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp27_, SCRATCH_MAIN_WINDOW_ACTION_ZOOM_OUT, "<Control>KP_Subtract");
#line 211 "../src/MainWindow.vala"
	_tmp28_ = scratch_main_window_action_accelerators;
#line 211 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp28_, SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_COMMENT, "<Control>m");
#line 212 "../src/MainWindow.vala"
	_tmp29_ = scratch_main_window_action_accelerators;
#line 212 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp29_, SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_COMMENT, "<Control>slash");
#line 213 "../src/MainWindow.vala"
	_tmp30_ = scratch_main_window_action_accelerators;
#line 213 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp30_, SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_SIDEBAR, "F9");
#line 214 "../src/MainWindow.vala"
	_tmp31_ = scratch_main_window_action_accelerators;
#line 214 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp31_, SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_SIDEBAR, "<Control>backslash");
#line 215 "../src/MainWindow.vala"
	_tmp32_ = scratch_main_window_action_accelerators;
#line 215 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp32_, SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_TERMINAL, "<Control><Alt>t");
#line 216 "../src/MainWindow.vala"
	_tmp33_ = scratch_main_window_action_accelerators;
#line 216 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp33_, SCRATCH_MAIN_WINDOW_ACTION_OPEN_IN_TERMINAL "::", "<Control><Alt><Shift>t");
#line 217 "../src/MainWindow.vala"
	_tmp34_ = scratch_main_window_action_accelerators;
#line 217 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp34_, SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_OUTLINE, "<Alt>backslash");
#line 218 "../src/MainWindow.vala"
	_tmp35_ = scratch_main_window_action_accelerators;
#line 218 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp35_, SCRATCH_MAIN_WINDOW_ACTION_NEXT_TAB, "<Control>Tab");
#line 219 "../src/MainWindow.vala"
	_tmp36_ = scratch_main_window_action_accelerators;
#line 219 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp36_, SCRATCH_MAIN_WINDOW_ACTION_NEXT_TAB, "<Control>Page_Down");
#line 220 "../src/MainWindow.vala"
	_tmp37_ = scratch_main_window_action_accelerators;
#line 220 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp37_, SCRATCH_MAIN_WINDOW_ACTION_CLOSE_TAB "::", "<Control>w");
#line 221 "../src/MainWindow.vala"
	_tmp38_ = scratch_main_window_action_accelerators;
#line 221 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp38_, SCRATCH_MAIN_WINDOW_ACTION_PREVIOUS_TAB, "<Control><Shift>Tab");
#line 222 "../src/MainWindow.vala"
	_tmp39_ = scratch_main_window_action_accelerators;
#line 222 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp39_, SCRATCH_MAIN_WINDOW_ACTION_PREVIOUS_TAB, "<Control>Page_Up");
#line 223 "../src/MainWindow.vala"
	_tmp40_ = scratch_main_window_action_accelerators;
#line 223 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp40_, SCRATCH_MAIN_WINDOW_ACTION_CLEAR_LINES, "<Control>K");
#line 224 "../src/MainWindow.vala"
	_tmp41_ = scratch_main_window_action_accelerators;
#line 224 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp41_, SCRATCH_MAIN_WINDOW_ACTION_NEW_BRANCH "::", "<Control>B");
#line 225 "../src/MainWindow.vala"
	_tmp42_ = scratch_main_window_action_accelerators;
#line 225 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp42_, SCRATCH_MAIN_WINDOW_ACTION_HIDE_PROJECT_DOCS "::", "<Control><Shift>h");
#line 226 "../src/MainWindow.vala"
	_tmp43_ = scratch_main_window_action_accelerators;
#line 226 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp43_, SCRATCH_MAIN_WINDOW_ACTION_MOVE_TAB_TO_NEW_WINDOW, "<Control><Alt>n");
#line 227 "../src/MainWindow.vala"
	_tmp44_ = scratch_main_window_action_accelerators;
#line 227 "../src/MainWindow.vala"
	gee_multi_map_set (_tmp44_, SCRATCH_MAIN_WINDOW_ACTION_RESTORE_PROJECT_DOCS "::", "<Control><Shift>r");
#line 229 "../src/MainWindow.vala"
	_tmp45_ = gtk_css_provider_new ();
#line 229 "../src/MainWindow.vala"
	provider = _tmp45_;
#line 230 "../src/MainWindow.vala"
	_tmp46_ = provider;
#line 230 "../src/MainWindow.vala"
	gtk_css_provider_load_from_resource (_tmp46_, "io/elementary/code/Application.css");
#line 231 "../src/MainWindow.vala"
	_tmp47_ = gdk_screen_get_default ();
#line 231 "../src/MainWindow.vala"
	_tmp48_ = provider;
#line 231 "../src/MainWindow.vala"
	gtk_style_context_add_provider_for_screen (_tmp47_, (GtkStyleProvider*) _tmp48_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 235 "../src/MainWindow.vala"
	if (g_strcmp0 (CONSTANTS_BRANCH, "") != 0) {
#line 9012 "MainWindow.c"
		gchar* _tmp49_;
#line 236 "../src/MainWindow.vala"
		_tmp49_ = g_strdup_printf (_ ("Code (%s)"), CONSTANTS_BRANCH);
#line 236 "../src/MainWindow.vala"
		_g_free0 (scratch_main_window_base_title);
#line 236 "../src/MainWindow.vala"
		scratch_main_window_base_title = _tmp49_;
#line 9020 "MainWindow.c"
	} else {
		gchar* _tmp50_;
#line 238 "../src/MainWindow.vala"
		_tmp50_ = g_strdup (_ ("Code"));
#line 238 "../src/MainWindow.vala"
		_g_free0 (scratch_main_window_base_title);
#line 238 "../src/MainWindow.vala"
		scratch_main_window_base_title = _tmp50_;
#line 9029 "MainWindow.c"
	}
#line 241 "../src/MainWindow.vala"
	hdy_init ();
#line 183 "../src/MainWindow.vala"
	_g_object_unref0 (provider);
#line 9035 "MainWindow.c"
}

static void
scratch_main_window_instance_init (ScratchMainWindow * self,
                                   gpointer klass)
{
	gchar* _tmp0_;
#line 22 "../src/MainWindow.vala"
	self->priv = scratch_main_window_get_instance_private (self);
#line 48 "../src/MainWindow.vala"
	self->priv->preferences_dialog = NULL;
#line 113 "../src/MainWindow.vala"
	self->priv->color_scheme_listener_handler_id = (gulong) 0;
#line 1149 "../src/MainWindow.vala"
	_tmp0_ = g_strdup ("");
#line 1149 "../src/MainWindow.vala"
	self->priv->current_search_term = _tmp0_;
#line 9053 "MainWindow.c"
}

static void
scratch_main_window_finalize (GObject * obj)
{
	ScratchMainWindow * self;
#line 22 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_TYPE_MAIN_WINDOW, ScratchMainWindow);
#line 27 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->_app);
#line 29 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->_restore_override);
#line 31 "../src/MainWindow.vala"
	_g_object_unref0 (self->document_view);
#line 34 "../src/MainWindow.vala"
	_g_object_unref0 (self->toolbar);
#line 35 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->search_revealer);
#line 36 "../src/MainWindow.vala"
	_g_object_unref0 (self->search_bar);
#line 37 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->welcome_view);
#line 38 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->terminal);
#line 39 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->folder_manager_view);
#line 40 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->document_manager);
#line 41 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 43 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->plugins);
#line 46 "../src/MainWindow.vala"
	_g_object_unref0 (self->sidebar);
#line 48 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->preferences_dialog);
#line 49 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->hp1);
#line 50 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->vp);
#line 51 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->content_stack);
#line 53 "../src/MainWindow.vala"
	_g_object_unref0 (self->clipboard);
#line 58 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->_actions);
#line 115 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->git_manager);
#line 1149 "../src/MainWindow.vala"
	_g_free0 (self->priv->current_search_term);
#line 22 "../src/MainWindow.vala"
	G_OBJECT_CLASS (scratch_main_window_parent_class)->finalize (obj);
#line 9106 "MainWindow.c"
}

static GType
scratch_main_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScratchMainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scratch_main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScratchMainWindow), 0, (GInstanceInitFunc) scratch_main_window_instance_init, NULL };
	GType scratch_main_window_type_id;
	scratch_main_window_type_id = g_type_register_static (hdy_window_get_type (), "ScratchMainWindow", &g_define_type_info, 0);
	ScratchMainWindow_private_offset = g_type_add_instance_private (scratch_main_window_type_id, sizeof (ScratchMainWindowPrivate));
	return scratch_main_window_type_id;
}

GType
scratch_main_window_get_type (void)
{
	static volatile gsize scratch_main_window_type_id__once = 0;
	if (g_once_init_enter (&scratch_main_window_type_id__once)) {
		GType scratch_main_window_type_id;
		scratch_main_window_type_id = scratch_main_window_get_type_once ();
		g_once_init_leave (&scratch_main_window_type_id__once, scratch_main_window_type_id);
	}
	return scratch_main_window_type_id__once;
}

static void
_vala_scratch_main_window_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	ScratchMainWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_TYPE_MAIN_WINDOW, ScratchMainWindow);
#line 22 "../src/MainWindow.vala"
	switch (property_id) {
#line 22 "../src/MainWindow.vala"
		case SCRATCH_MAIN_WINDOW_APP_PROPERTY:
#line 22 "../src/MainWindow.vala"
		g_value_set_object (value, scratch_main_window_get_app (self));
#line 22 "../src/MainWindow.vala"
		break;
#line 22 "../src/MainWindow.vala"
		case SCRATCH_MAIN_WINDOW_RESTORE_DOCS_PROPERTY:
#line 22 "../src/MainWindow.vala"
		g_value_set_boolean (value, scratch_main_window_get_restore_docs (self));
#line 22 "../src/MainWindow.vala"
		break;
#line 22 "../src/MainWindow.vala"
		case SCRATCH_MAIN_WINDOW_RESTORE_OVERRIDE_PROPERTY:
#line 22 "../src/MainWindow.vala"
		g_value_set_object (value, scratch_main_window_get_restore_override (self));
#line 22 "../src/MainWindow.vala"
		break;
#line 22 "../src/MainWindow.vala"
		case SCRATCH_MAIN_WINDOW_ACTIONS_PROPERTY:
#line 22 "../src/MainWindow.vala"
		g_value_set_object (value, scratch_main_window_get_actions (self));
#line 22 "../src/MainWindow.vala"
		break;
#line 9165 "MainWindow.c"
		default:
#line 22 "../src/MainWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/MainWindow.vala"
		break;
#line 9171 "MainWindow.c"
	}
}

static void
_vala_scratch_main_window_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	ScratchMainWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_TYPE_MAIN_WINDOW, ScratchMainWindow);
#line 22 "../src/MainWindow.vala"
	switch (property_id) {
#line 22 "../src/MainWindow.vala"
		case SCRATCH_MAIN_WINDOW_APP_PROPERTY:
#line 22 "../src/MainWindow.vala"
		scratch_main_window_set_app (self, g_value_get_object (value));
#line 22 "../src/MainWindow.vala"
		break;
#line 22 "../src/MainWindow.vala"
		case SCRATCH_MAIN_WINDOW_RESTORE_DOCS_PROPERTY:
#line 22 "../src/MainWindow.vala"
		scratch_main_window_set_restore_docs (self, g_value_get_boolean (value));
#line 22 "../src/MainWindow.vala"
		break;
#line 22 "../src/MainWindow.vala"
		case SCRATCH_MAIN_WINDOW_RESTORE_OVERRIDE_PROPERTY:
#line 22 "../src/MainWindow.vala"
		scratch_main_window_set_restore_override (self, g_value_get_object (value));
#line 22 "../src/MainWindow.vala"
		break;
#line 22 "../src/MainWindow.vala"
		case SCRATCH_MAIN_WINDOW_ACTIONS_PROPERTY:
#line 22 "../src/MainWindow.vala"
		scratch_main_window_set_actions (self, g_value_get_object (value));
#line 22 "../src/MainWindow.vala"
		break;
#line 9209 "MainWindow.c"
		default:
#line 22 "../src/MainWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/MainWindow.vala"
		break;
#line 9215 "MainWindow.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

